2024-06-30  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* NEWS: Update.
	* doc/gendocs_template: Update version to `4.2'.

2024-06-30  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-ast.c (pkl_ast_format_1): Show `nframes' and
	`npopes' fields of `PKL_AST_BREAK_CONTINUE_STMT' node.

2024-06-30  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* testsuite/poke.pkl/break-while-3.pk: Use explicit
	output base 10.

2024-06-30  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-trans.c (PKL_TRANS_PUSH_ESCAPABLE): Initialize
	`npopes' field.

2024-06-30  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-trans.c (pkl_trans1_pr_try_stmt_handler): Fix
	`nframes' tracking to only change iff we're using try-catch
	with argument form: `try {...} catch (Exception ex) {...}'.
	* (pkl_trans1_ps_try_stmt_handler): Likewise.
	* testsuite/poke.pkl/break-while-4.pk: New test.
	* testsuite/poke.pkl/break-while-5.pk: Likewise.
	* testsuite/poke.pkl/break-while-6.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2024-06-16  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* pickles/diff.pk (diff_structured): Fix `elem_simple_p'
	to detect "simple" types correctly.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.
	* testsuite/poke.cmd/sdiff-13.pk: New test.

2024-06-15  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-tab.y (pushlevel_args): Call `assert' on
	the result of `pkl_register_arg' function instead of the
	whole function call expression.

2024-06-13  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-diag.c (pkl_detailed_location): Remove extra empty
	line.
	(pkl_loc_to_source): Handle compilation from buffer.

2024-06-13  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-cmd-ios.c (expr_to_ios): Emit diagnostics in all failing
	cases.
	(pk_cmd_ios): Adjust accordingly.
	(pk_cmd_close): Likewise.

2024-06-10  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (iogetb): Do not convert units to bytes.
	* testsuite/poke.pkl/iobias-1.pk: Update test accordingly.
	* testsuite/poke.pkl/iobias-2.pk: Likewise.
	* testsuite/poke.pkl/iosetbias-2.pk: Likewise.
	* testsuite/poke.pkl/iosetbias-3.pk: Likewise.
	* testsuite/poke.pkl/iosetbias-4.pk: Likewise.

2024-06-10  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-typify.c (INVALID_CAST): Remove.
	(pkl_typify1_ps_cast): Mention types in invalid cast error
	diagnostic.

2024-06-10  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.h (PKL_AST_COMP_STMT_BUILTIN): Remove.
	(struct pkl_ast_comp_stmt): Remove field `builtin'.
	(PKL_AST_BUILTIN_NONE): Remove.
	* libpoke/pkl-ast.c (pkl_ast_make_comp_stmt): Do not initialize
	PKL_AST_COMP_STMT_BUILTIN.
	(pkl_ast_make_builtin): Remove.
	(pkl_ast_format_1): Do not print the `builtin' field.
	* libpoke/pkl-anal.c (pkl_anal1_ps_comp_stmt): Remove handler.
	* libpoke/pkl-gen.c (pkl_gen_pr_comp_stmt): Do not handle
	builtins.
	(pkl_gen_ps_comp_stmt): Likewise.

2024-06-09  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/poke.pkl/array-bound-8.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2024-06-08  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-trans.c (pkl_trans1_pr_try_stmt_body): increase
	npopes only if not try-until.
	(pkl_trans1_ps_try_stmt_body): Likewise.

2024-06-07  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-trans.c (pkl_trans1_pr_try_stmt_body): Increase
	npopes in escapable.
	(pkl_trans1_ps_try_stmt_body): Decrease npopes in escapable.
	* testsuite/poke.pkl/break-while-6.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2024-06-06  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-trans.c (PKL_TRANS_PUSH_UNESCAPABLE): Define.
	(pkl_trans1_pr_type_struct): Push unescapable context.
	(pkl_trans1_ps_type_struct): Pop uescapable context.
	(pkl_trans1_pr_type_array): Push unescapable context.
	(pkl_trans1_ps_type_array): Pop uescapable context.
	(pkl_trans1_pr_func): Push unescapable context.
	(pkl_trans1_ps_func): Pop uescapable context.
	* libpoke/pkl-trans.h (PKL_TRANS_MAX_COMP_STMT_NEST): Bump
	to 120.
	* testsuite/poke.pkl/break-diag-2.pk: New test.
	* testsuite/poke.pkl/break-diag-3.pk: Likewise.
	* testsuite/poke.pkl/break-diag-4.pk: Likewise.
	* testsuite/poke.pkl/break-diag-5.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2024-06-03  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* doc/poke.texi (Dot-Commands): Fix the example to use
	`.vm disa' instead of `.vm dis'.
	(.vm disassemble): Remove non-existent sub-commands.

2024-06-03  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* testsuite/poke.pokefmt/pokefmt.exp (pokefmt_run): Catch
	exceptional returns of `exec'.

2024-06-03  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-ast.h (enum pkl_ast_code): Remove `PKL_AST_GCD'.

2024-06-03  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-ast.c (pkl_struct_type_traverse): s/strtok/strtok_r/.

2024-06-02  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-ast.c (pkl_struct_type_traverse): Exclude unnamed
	fields.

2024-05-31  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/ios-dev-mmap.c (ios_dev_mmap_open): Fix error handling
	of `strdup'.

2024-05-30  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* NEWS: Update.
	* doc/gendocs_template: Update version to `4.1'.

2024-05-15  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-pass.c (pkl_do_pass_1): Avoid accessing
	uninitialized memory.

2024-05-01  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* utils/pk-jojopatch.in: Disable auto-remap to improve speed.

2024-04-26  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poke/pk-cmd-vm.c (vm_cmd): Update usage string to also mention
	`profile' and `dispatch' sub-commands.

2024-04-26  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-ast.h (PKL_AST_BREAK_CONTINUE_STMT_NPOPES): New
	macro.
	(struct pkl_ast_break_continue_stmt): New field `npopes' to keep
	track of number of `pope' instructions.
	* libpoke/pkl-trans.h (struct pkl_trans_escapable_ctx): Add new
	field `npopes'.
	* libpoke/pkl-trans.c (pkl_trans1_pr_comp_stmt): For EXCOND
	expression statements, only keep track of number of `pope' insns.
	(pkl_trans1_ps_comp_stmt): Likewise.
	(pkl_trans1_ps_break_continue_stmt): Update the node with the number
	of `pope' insns.
	* libpoke/pkl-gen.c (pkl_gen_ps_break_continue_stmt): Emit `pope'
	instruction(s).
	(pkl_gen_pr_op_excond): Push the failure result after evaluation
	of the EXCOND's LHS.
	* testsuite/poke.pkl/excond-6.pk: New test.
	* testsuite/poke.pkl/excond-7.pk: Likewise.
	* testsuite/poke.pkl/excond-8.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2024-04-09  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-diag.c (pkl_detailed_location): Handle the failure
	of `fseeko'.

2024-04-02  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (Poke Scripts): Document poke_interactive_p.

2024-04-01  Sergio Durigan Junior  <sergiodj@sergiodj.net>

	* man/Makefile.am: Generate manpage for pokefmt.

2024-04-01  Sergio Durigan Junior  <sergiodj@sergiodj.net>

	* pokefmt/pokefmt.l (poke_stmt): Fix typo.
	(poke_expr): Likewise.

2024-003-31  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.c (pkl_type_append_to): Include itype in
	integral struct type string representations.

2024-03-31  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-pass.c (pkl_do_pass_1): Do not increase reference
	counter automatically in substituted PKL_PASS_NODE.  Let the
	handlers do it instead.
	* libpoke/pkl-fold.c (OP_UNARY_II): Increase reference counting in
	PKL_PASS_NODE.
	(OP_UNARY_OO): Likewise.
	(OP_BINARY_OOI): Likewise.
	(OP_BINARY_OOO): Likewise.
	(OP_BINARY_SIS): Likewise.
	(OP_BINARY_OIO): Likewise.
	(OP_BINARY_III): Likewise.
	(OP_BINARY_SSS): Likewise.
	(OP_BINARY_SSI): Likewise.
	(OP_BINARY_AAA_ADD): Likewise.
	(pkl_fold_pow): Likewise.
	(pkl_fold_bconc): Likewise.
	(pkl_fold_ps_cast): Likewise.
	* libpoke/pkl-typify.c (pkl_typify1_ps_isa): Likewise.
	* libpoke/pkl-trans.c (pkl_trans1_ps_var): Likewise.
	(pkl_tarns2_ps_struct_ref): Likewise.
	(pkl_trans3_ps_op_sizeof): Likewise.

2024-03-31  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.c (pkl_ast_handle_bconc_ass_stmt_1): Fix
	reference counting in synthetized compount statement.

2024-03-30  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/ios-dev-mmap.c (ios_dev_mmap_open): Avoid using variable
	fd uninitialized.

2024-03-30  Jose E. Marchesi  <jemarch@gnu.org>

	* NEWS: Update for 4.0.
	* doc/gendocs_template: Likewise.

2024-03-30  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/ios.pk: fix print :val.

2024-03-24  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-fold.c (pkl_fold_ps_cast): Fix integer cast by
	adding missing conditional sign-extension operation.
	Also fix offset casting to work with negative magnitudes by
	using signed division, masking and conditional sign extension.
	* libpoke/pkl-gen.pks (offset_cast): Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.
	* testsuite/poke.pkl/cast-integers-20.pk: New test.
	* testsuite/poke.pkl/cast-integers-21.pk: Likewise.
	* testsuite/poke.pkl/cast-integers-22.pk: Likewise.
	* testsuite/poke.pkl/cast-offsets-6.pk: Likewise.
	* testsuite/poke.pkl/cast-offsets-7.pk: Likewise.

2024-03-16  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/ios-dev-mmap.c (ios_dev_mmap_open): Close the opened
	file, in case of error.

2024-03-16  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* testsuite/Makefile.am (check-DEJAGNU): Set `HOST_OS' env var.
	* testsuite/lib/poke-dg.exp (dg-require): Add "no-darwin"
	requirement.
	* testsuite/poke.cmd/mmap-1.pk: Disable the test on Darwin.

2024-03-15  Andreas Klinger  <ak@it-klinger.de>

	* testsuite/poke.pickles/jpeg-test.pk: Fix trailing blank.

2024-03-15  Andreas Klinger  <ak@it-klinger.de>

	* pickles/jpeg.pk: New pickle for jpeg files.
	* pickles/Makefile.am (dist_pickles_DATA): Add jpeg.pk.
	* testsuite/poke.pickles/jpeg-test.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add jpeg-test.pk.

2024-03-15  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* pickles/jojodiff.pk (Jojo_Length2): Add initializer to
	constraint.
	(Jojo_Length2): Likewise.
	(Jojo_Length3): Likewise.
	(Jojo_Length5): Likewise.
	(Jojo_Length9): Likewise.
	(jojo_length_encode): New function to encode length according to
	the Jojo format.
	(Jojo_EscapedByte): Remove.
	(Jojo_Datum): Auxiliary type for `Jojo_Bytes'.
	(Jojo_Bytes): Type to describe sequence of data bytes in Jojo
	format.
	(Jojo_Bytes_Callback): Auxiliary type for `jojo_bytes_map' function.
	(jojo_bytes_map): Add function to run the provided callback
	for each decoded byte in `Jojo_Bytes'.
	(jojo_bytes): Add function to encode bytes as `Jojo_Bytes'.
	(Jojo_MOD): Use `Jojo_Bytes' instead of `Jojo_Byte[]'.
	(Jojo_INS): Likewise.
	(Jojo_MOD.get_count): Update accordingly.
	(Jojo_INS.get_count): Likewise.
	(Jojo_Hunk): Add `Jojo_Bytes' field to comply with the latest
	version of JojoDiff generator.
	(Jojo_Hunk_Orig): Add type to describe original format of JojoDiff.
	(jojo_patch_from_orig): Add conversion function to transform
	from `Jojo_Patch_Orig' to `Jojo_Patch'.
	(jojo_patch_apply): Update to support new `Jojo_Patch' and make
	verbosity more fine-grained.
	* testsuite/poke.pickles/jojodiff-test.pk: Add tests for JojoDiff
	pickle.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2024-03-05  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* autogen.sh: Updated by `./bootstrap --bootstrap-sync'.
	* autopull.sh: Likewise.
	* bootstrap: Likewise.
	* bootstrap-funclib.sh: Likewise.

2024-02-27  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* testsuite/lib/poke-unit.h (wait): Rename to `deja_wait'.

2024-02-27  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/poke.libpoke/values.c: Use EXIT_FAILURE instead of 1
	as exit status in case of error.

2024-02-27  Hannes Domani  <ssbssa@yahoo.de>

	* testsuite/poke.libpoke/Makefile.am (COMMON_LDADD): Put
	libpoke.la before libgnu.la.

2024-02-27  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/poke.c (initialize_user): Only use xdg_config_home if it is
	not NULL.

2024-02-27  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/poke.libpoke/values.c: Get rid of err.h.

2024-02-27  Jose E. Marchesi  <jemarch@gnu.org>

	* configure.ac: Check for runtest instead of dejagnu.h.
	* testsuite/lib/poke-uni.h: New file adapted rom dejagnu.h.
	* testsuite/Makefile.am (EXTRA_DIST): Add lib/poke-unit.h.
	* testsuite/poke.libpoke/Makefile.am (COMMON_CPPFLAGS): Add
	$(top_srcdir)/testsuite/lib to the include path.
	(COMMON_CFLAGS): It is no more needed to use -fgnu89-inline.
	(check_PROGRAMS): These are now built unconditionally.
	* testsuite/poke.libpoke/api.c: Include poke-unit.h instead of dejagnu.h.
	* testsuite/poke.libpoke/decls.c: Likewise.
	* testsuite/poke.libpoke/foreign-iod.c: Likewise.
	* testsuite/poke.libpoke/values.c: Likewise.

2024-02-25  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl.c (pkl_resolve_module): Handle failure of `asprintf'.

2024-02-25  Bruno Haible  <bruno@clisp.org>

	libpoke: Fix compiler warnings re [v]asprintf on AIX (regr. 2024-02-23).
	* bootstrap.conf (libpoke_modules): Add back 'vasprintf-posix'.

2024-02-25  Jose E. Marchesi  <jemarch@gnu.org>

	* NEWS: Update entry for 3.90.4.
	* doc/gendocs_template: Update version to 3.90.4.

2024-02-25  Jose E. Marchesi  <jemarch@gnu.org>

	* common/pk-utils.c (pk_str_concat): Assert that first argument
	shall not be NULL.
	* poke/poke.c (initialize_user): Take care to not use HOME if it
	is not defined.
	* libpoke/pvm.c: Include assert.h.
	* libpoke/ios-dev-sub.c: Likewise.
	* poke/pk-ios.c: Likewise.

2024-02-23  Jose E. Marchesi  <jemarch@gnu.org>

	* configure.ac: Support --{enable,disable}-{poked,pokefmt} and
	print summary at end.
	* pokefmt/Makefile.am: Build pokefmt only if ENABLE_POKEFMT.
	* poked/Makefile.am: Build poked only if ENABLE_POKED
	* man/Makefile.am: Build poked manpages only if ENABLE_POKED.
	* etc/hacking.org (Disabling building some components): New
	section.
	* HACKING: Regenerate.

2024-02-24  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* run.in (PATH): Add pokefmt/ and poked/ to PATH env var.

2024-02-24  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poked/usock.c (usock_handler_srv): Do F_GETFL before F_SETFL
	on client sockets.

2024-02-23  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poked/usock.c (errorf): Remove.
	(usock_errorf): Adapt `errorf' to accept `struct usock *'
	to make the buffer usage implicit.  Add more comments.
	(usock_handle_srv): Replace `errorf' with `usock_errorf'.
	(usock_handle_notif): Likewise.
	(usock_serve): Likewise.

2024-02-23  Jose E. Marchesi  <jemarch@gnu.org>

	* bootstrap.conf (libpoke_modules): Add c-vasprintf and
	c-vsnprintf gnulib modules.
	* libpoke/pvm-wrappers.c: Use c_vaspritnf and c_vsnprintf.

2024-02-22  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/lib/poke-dg.exp (dg-require): New procedure.
	* testsuite/poke.cmd/file-mode.pk: Do not use /etc/passwd and
	dg-require devnull.

2024-02-22  Jose E. Marchesi  <jemarch@gnu.org>

	* bootstrap.conf (libpoke_modules): Import modules c-strtof and
	c-strtod.
	* libpoke/pvm.c (pvm_stof): Use c_strtof.
	(pvm_stod): Use c_strtod.

2024-02-22  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.h: Move prototypes for pvm_stof and pvm_stod from
	common/pk-utils.h.
	* libpoke/pvm.c (pvm_stof): Move from common/pk-utils.c.
	(pvm_stod): Likewise.

2024-02-22  Hannes Domani  <ssbssa@yahoo.de>

	* libpoke/ios-dev-file.c (ios_dev_file_open): Open files in
	binary mode on windows.

2024-02-22  Hannes Domani  <ssbssa@yahoo.de>

	* poke/pk-repl.c (poke_sigint_handler, pk_repl): Use pthread
	functions only if available.

2024-02-21  Hannes Domani  <ssbssa@yahoo.de>

	* libpoke/pvm.jitter: Undef raise on windows.

2024-02-21  Jose E. Marchesi  <jemarch@gnu.org>

	* AUTHORS: Add Hannes Domani.

2024-02-20  Hannes Domani  <ssbssa@yahoo.de>

	* poke/pk-term.c (pk_term_init): Set erase_line_str.
	(pk_puts_paged): Use console functions on windows.

2024-02-17  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* bootstrap.conf (gnulib_modules): s/strerror/strerror_r-posix/.
	* pokefmt/pokefmt.l (err): Use `strerror_r'.
	* poked/poked.c (err): Likewise.
	* poked/usock.c (errorf): New function.
	(usock_handle_srv): Use `errorf' to make the buffer.
	(usock_handle_notif): Likewise.
	(usock_serve): Likewise.

2024-02-17  Hannes Domani  <ssbssa@yahoo.de>

	* poke/poke.c: Don't include <arpa/inet.h> on windows.

2024-02-17  Hannes Domani  <ssbssa@yahoo.de>

	* poke/pk-term.c (update_screen_dimensions): Define if not availbale.

2024-02-15  Hannes Domani  <ssbssa@yahoo.de>

	* libpoke/ras: Ignore '\r' of windows line endings.

2024-02-15  Hannes Domani  <ssbssa@yahoo.de>

	* doc/poke.texi: Mention colon characters in windows drives.
	* libpoke/pkl.c: Don't use ':' of windows drives as path separator.

2024-02-15  Bruno Haible  <bruno@clisp.org>

	Provide an easy way to generate the monolithic HTML-formatted manual.
	* doc/Makefile.am (html-monolithic, poke-manual.html): New targets.
	(MOSTLYCLEANFILES): Add poke-manual.html.

2024-02-12  Jose E. Marchesi  <jemarch@gnu.org>

	* bootstrap.conf (gnulib_modules): Import regex module from
	gnulib.

2024-02-12  Jose E. Marchesi  <jemarch@gnu.org>,

	* doc/poke.texi (Struct Methods): Entry for SELF in concept index.
	(Methods): Likewise.

2024-02-11  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poked/poked.c: Fix GNU code style.
	* pokefmt/pokefmt.l: Likewise.

2024-02-11  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poked/poked.c (#include <err.h>): Remove.
	(#include <stdarg.h>): Add.
	(err): New function.
	(errx): Likewise.
	* pokefmt/pokefmt.l (#include <err.h>): Remove.
	(#include <stdarg.h>): Add.
	(err): New function.
	(errx): Likewise.

2024-02-11  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poked/usock.c (usock_handle_notif): Handle `EWOULDBLOCK'
	errno.
	(usock_serve): Likewise.

2024-02-10  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* bootstrap.conf (gnulib_modules): Update comment to mention
	`pokefmt'.

2024-02-10  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* bootstrap.conf (gnulib_modules): Add `strerror'.
	* poked/usock-buf.c (#include <err.h>): Remove.
	* poked/usock.h (USOCK_SERVE_OK): New macro.
	(USOCK_SERVE_NOK): Likewise.
	(usock_serve): Change signature to return status (success/failure).
	(usock_serve_error): New function to retrieve content of error
	buffer (`errbuf').
	(usock_out_printf): Change return type to `int' and return number
	of sent bytes or -1 in case of error.
	* poked/usock.c (#include <err.h>): Likewise.
	(USOCK_ERRBUF_SIZE): New macro.
	(USOCK_HANDLE_SRV_OK): Likewise.
	(USOCK_HANDLE_SRV_NOK): Likewise.
	(USOCK_HANDLE_NOTIF_OK): Likewise.
	(USOCK_HANDLE_NOTIF_NOK): Likewise.
	(struct usock): Add new field `errbuf' to save error messages.
	(usock_handle_srv): Do not call `err'; fill `errbuf' and return
	error.
	(usock_handle_notif): Likewise.
	(usock_serve): Adapt new signature and in case of error, fill
	the `errbuf' and return `USOCK_SERVE_NOK'.
	(usock_serve_error): New function.
	* poked/poke.c (srvthread): Handle failure of `usock_serve'.
	(poked_disas_send): Handle failure of `usock_out_printf'.

2024-02-10  Jose E. Marchesi  <jemarch@gnu.org>

	* utils/Makefile.am (bin_SCRIPTS): Remove pk-elfextractor.
	(EXTRA_DIST): Remove pk-elfextractor.in.

2024-01-28  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* configure.ac (gl_HOST_CPU_ABI_32BIT): Emit an error instead of
	warning when the result is "unknown".

2024-01-26  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poke/pk-term.h (pk_compiler): Don't re-typedef `pk_compiler'.
	Include "libpoke.h".

2024-01-25  Andreas Klinger  <ak@it-klinger.de>

	* poke/pk-cmd.h: New command arg type PK_CMD_ARG_UINT
	* poke/pk-cmd.c (pk_atou): New function
	* poke/pk-cmd-ios.c (pk_cmd_mmap, pk_cmd_sub):
				Change base and size to PK_CMD_ARG_UINT

2024-01-22  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/poke.c (pk_print_version): Update --version copyright to
	2024.

2024-01-22  Jose E. Marchesi  <jemarch@gnu.org>

	* NEWS: Add entries for 3.90.1.
	* doc/gendocs_template (For version): Update to 3.90.1.

2024-01-22  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/Makefile.am (LTV_CURRENT): Bump to 1.

2024-01-20  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* testsuite/Makefile.am (EXTRA_DIST): Add `poke.pvm/pvm.exp'.

2024-01-20  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (open): Document that IO space identifiers are
	allocated sequentially and consistently reused.

2024-01-07  Mark Wielaard  <mark@klomp.org>

    * etc/pvm-wraps-whitelist: Add __stack_chk_guard.

2023-12-30  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-ast.c (pkl_ast_handle_bconc_ass_stmt): Add location
	info to synthesized BCONC assignment statements.

2023-12-28  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-trans.c (pkl_trans1_ps_asm_stmt): Add location info
	to ass-stmt.
	(pkl_trans2_ps_incrdecr): Likewise.

2023-12-28  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-tab.y (pkl_make_assertion): Fix typo.
	(expression): Fix location for unary/binary/ternary
	expressions.

2023-12-28  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-ast.h (pkl_ast_format_loc): Change first input
	param from `pkl_ast' to `const char *'.  Pass filename
	directly.
	* libpoke/pkl-ast.c (pkl_ast_format_loc): Use the provided
	filename and remove the extra ": ".
	* libpoke/pkl-gen.c (pkl_gen_ps_func): Adapt.

2023-12-28  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-gen.h (struct pkl_gen_payload): Add new field
	`filename'.
	* libpoke/pkl-gen.c (pkl_gen_ps_src): Populate `filename'
	field.
	(pkl_gen_pr_program): Likewise.

2023-12-28  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-ast.h: Fix comment:
	s/PKL_AST_COMPOUND_STMT/PKL_AST_COMP_STMT/.
	* libpoke/pkl-trans.h (struct pkl_trans_function_ctx): Remove
	unnecessary field `next'.
	* poke/pk-help.pk (Poke_HelpEntry::is_line_p): Remove extra
	semi-colon.

2023-12-22  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* utils/Makefile.am (bin_SCRIPTS): Add `pk-jojopatch'.
	(EXTRA_DIST): Add `pk-jojopatch.in'.

2023-12-18  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* pickles/jojodiff.pk: New pickle for JojoDiff utility.
	* pickles/Makefile.am (dist_pickles_DATA): Add `jojodiff.pk'.
	* utils/pk-jojopatch.in: New Poke script to apply JojoDiff patches
	to files.
	* utils/Makefile.am (pk-jojopatch): Add rule for `pk-jojopatch'.

2023-12-04  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-ast.c (pkl_ast_print): Change `fprintf' with `fputs'.

2023-12-01  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/libpoke.h (struct pk_iod_if): Fix comments by referring to
	`PK_IOD_*' return values instead of `IOD_*'.

2023-11-26  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/libpoke.h (pk_make_int): Add new param of type `pk_compiler'.
	(pk_make_uint): Likewise.
	(pk_make_string): Likewise.
	(pk_make_offset): Likewise.
	(pk_make_struct): Likewise.
	(pk_make_array): Likewise.
	(pk_make_integral_type): Likewise.
	(pk_make_string_type): Likewise.
	(pk_make_any_type): Likewise.
	(pk_make_offset_type): Likewise.
	(pk_make_struct_type): Likewise.
	(pk_make_array_type): Likewise.
	* libpoke/pk-val.c (pk_make_int): Likewise.
	(pk_make_uint): Likewise.
	(pk_make_string): Likewise.
	(pk_make_offset): Likewise.
	(pk_make_struct): Likewise.
	(pk_make_array): Likewise.
	(pk_make_integral_type): Likewise.
	(pk_make_string_type): Likewise.
	(pk_make_any_type): Likewise.
	(pk_make_offset_type): Likewise.
	(pk_make_struct_type): Likewise.
	(pk_make_array_type): Likewise.
	(pk_val_offset): Update.
	* poke/pk-cmd-help (pk_cmd_help): Likewise.
	(pk_cmd_set): Likewise.
	* poke/pk-hserver.c (pk_hserver_token_p): Likewise.
	(pk_hserver_token_kind): Likewise.
	(pk_hserver_cmd): Likewise.
	(pk_hserver_function): Likewise.
	(pk_hserver_init): Likewise.
	(pk_hserver_start): Likewise.
	(pk_hserver_make_hyperlink): Likewise.
	* poke/poke.c (pk_set_var_int): Likewise.
	(set_script_args): Likewise.
	(initialize): Likewise.
	* poked/poked.c (poked_init): Likewise.
	* pokefmt/pokefmt.l (poke_init): Likewise.
	* testsuite/poke.libpoke/values.c (test_simple_values): Likewise.
	(test_simple_values_mapping): Likewise.
	(test_pk_typeof): Likewise.
	(main): Pass `pk_compiler' to `test_simple_values',
	`test_simple_values_mapping' and `test_pk_typeof'.

2023-11-25  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (endhl): Do not raise exceptions.
	(endsc): Likewise.
	(pvm_literal_nohyperlink): Remove variable.
	* libpoke/pkl-rt.pk (term_end_hyperlink): Adapt accordingly.
	(term_end_class): Likewise.

2023-11-24  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-typify.c (pkl_typify2_ps_type_array): Sanity check
	fixed size bounds.
	* testsuite/poke.map/maps-unions-14.pk: Adapt test.
	* testsuite/poke.map/maps-unions-15.pk: Likewise.
	* testsuite/poke.map/maps-unions-16.pk: Likewise.
	* testsuite/poke.pkl/scons-union-14.pk: Likewise.
	* testsuite/poke.pkl/scons-union-13.pk: Likewise.
	* testsuite/poke.pkl/scons-union-12.pk: Likewise.
	* testsuite/poke.pkl/array-siz-diag-2.pk: New test.
	* testsuite/poke.pkl/array-siz-diag-3.pk: Likewise.
	* testsuite/poke.pkl/array-siz-2.pk: Likewise.
	* testsuite/poke.pkl/array-siz-3.pk: Likewise.
	* testsuite/poke.pkl/cast-array-siz-diag-1.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2023-11-24  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/orc.pk: New file.
	* pickles/Makefile.am (dist_pickles_DATA): Add orc.pk.

2023-11-23  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-hserver.c (hserver_thread_worker): Call
	pk_unregister_thread before pthread_exit.

2023-11-23  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/srec.pk (srec_encode): Create start address records.

2023-11-23  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/btf.pk (BTF_Array): Use BTF_Type_Id for index_type.

2023-11-18  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/libpoke.h (struct pk_term_if): Add `pk_compiler' parameter
	to all function pointers.
	* libpoke/libpoke.c (include "libpoke.h"): Move to the top.
	(libpoke_term_if): Change the type to `struct pk_term_if_internal'.
	(pk_compiler_new_with_flags): Populate `libpoke_term_if'.
	* libpoke/pkt.h (PKT_IF): New macro to convey the terminal interface
	function pointers.
	(PK_PKC): New macro to convey the instance of current incremental
	compiler.
	(pk_*): Re-write the macro definitions to new paradigm.
	(struct pk_term_if_internal): New data type.
	(libpoke_term_if): Change the type of the variable.
	* poke/pk-term.h (pk_puts): Define as a macro.
	(pk_term_indent): Likewise.
	(pk_term_class): Likewise.
	(pk_term_end_class): Likewise.
	(pk_term_hyperlink): Likewise.
	(pk_term_end_hyperlink): Likewise.
	(pk_term_get_color): Likewise.
	(pk_term_get_bgcolor): Likewise.
	(pk_term_set_color): Likewise.
	(pk_term_set_bgcolor): Likewise.
	(pk_term_flush_1): New terminal interface function with `pk_compiler'
	parameter.
	(pk_puts_1): Likewise.
	(pk_printf_1): Likewise.
	(pk_term_indent_1): Likewise.
	(pk_term_class_1): Likewise.
	(pk_term_end_class_1): Likewise.
	(pk_term_hyperlink_1): Likewise.
	(pk_term_end_hyperlink_1): Likewise.
	(pk_term_get_color_1): Likewise.
	(pk_term_get_bgcolor_1): Likewise.
	(pk_term_set_color_1): Likewise.
	(pk_term_set_bgcolor_1): Likewise.
	* poke/pk-term.c (pk_term_flush_1): Likewise.
	(pk_puts_1): Likewise.
	(pk_printf_1): Likewise.
	(pk_term_indent_1): Likewise.
	(pk_term_class_1): Likewise.
	(pk_term_end_class_1): Likewise.
	(pk_term_hyperlink_1): Likewise.
	(pk_term_end_hyperlink_1): Likewise.
	(pk_term_get_color_1): Likewise.
	(pk_term_get_bgcolor_1): Likewise.
	(pk_term_set_color_1): Likewise.
	(pk_term_set_bgcolor_1): Likewise.
	(pk_term_flush_1): Likewise.
	(pk_puts): Remove.
	(pk_term_indent): Likewise.
	(pk_term_class): Likewise.
	(pk_term_end_class): Likewise.
	(pk_term_hyperlink): Likewise.
	(pk_term_end_hyperlink): Likewise.
	(pk_term_get_color): Likewise.
	(pk_term_get_bgcolor): Likewise.
	(pk_term_set_color): Likewise.
	(pk_term_set_bgcolor): Likewise.
	* poked/poked.c (tif_flush): Add `pk_compiler' parameter.
	(tif_puts): Likewise.
	(tif_printf): Likewise.
	(tif_indent): Likewise.
	(tif_class): Likewise.
	(tif_class_end): Likewise.
	(tif_hlink): Likewise.
	(tif_hlink_end): Likewise.
	(tif_color): Likewise.
	(tif_bgcolor): Likewise.
	(tif_color_set): Likewise.
	(tif_bgcolor_set): Likewise.
	* pokefmt/pokefmt.l (tif_flush): Likewise.
	(tif_puts): Likewise.
	(tif_printf): Likewise.
	(tif_indent): Likewise.
	(tif_class): Likewise.
	(tif_class_end): Likewise.
	(tif_hlink): Likewise.
	(tif_hlink_end): Likewise.
	(tif_color): Likewise.
	(tif_bgcolor): Likewise.
	(tif_color_set): Likewise.
	(tif_bgcolor_set): Likewise.
	* testsutie/poke.libpoke/term-if.h (pk_term_flush): Likewise.
	(pk_puts): Likewise.
	(pk_printf): Likewise.
	(pk_term_indent): Likewise.
	(pk_term_class): Likewise.
	(pk_term_end_class): Likewise.
	(pk_term_hyperlink): Likewise.
	(pk_term_end_hyperlink): Likewise.
	(pk_term_get_color): Likewise.
	(pk_term_get_bgcolor): Likewise.
	(pk_term_set_color): Likewise.
	(pk_term_set_bgcolor): Likewise.

2023-11-18  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* common/pk-utils.h (PK_INTEGRAL_SUFFIX): New macro.
	(pk_integral_suffix): Remove function declaration.
	(PK_PRINT_BINARY): Remove `use_suffix_p' parameter. And don't print
	the suffix.
	* common/pk-utils.c (PK_INTEGRAL_SUFFIX): Remove function definition.
	* libpoke/pvm-val.c (pvm_print_val_1): Update use of `PK_PRINT_BINARY'
	and use `PK_INTEGRAL_SUFFIX'.
	* libpoke/pvm.jitter (wrapped-functions): Remove `pk_integral_suffix'.
	(PVM_PRINTI): Update use of `PK_PRINT_BINARY'.
	(PVM_PRINTL): Likewise.

2023-11-14  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* common/pk-utils.h (pk_print_binary): Remove function decl.
	(PK_PRINT_BINARY): New macro for printing in base 2 to make use of
	`pk_puts' macro easier.
	* common/pk-utils.c (pk_print_binary): Remove function.
	(pk_integral_suffix): New function.
	* libpoke/pvm-val.c (pvm_print_val_1): Change `pk_print_binary' to
	`PK_PRINT_BINARY'.
	* libpoke/pvm.jitter (wrapped-functions):
	s/pk_print_binary/pk_integral_suffix/.
	(PVM_PRINTI): s/pk_print_binary/PK_PRINT_BINARY/.
	(PVM_PRINTL): Likewise.

2023-11-14  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/libpoke.h (pk_set_user_data): New function to register an
	opaque data pointer.
	(pk_get_user_data): New function to retrieve the registered opaque
	data pointer.
	* libpoke/libpoke.c (struct _pk_compiler): Add new field `user_data'.
	(pk_set_user_data): New function impl.
	(pk_get_user_data): Likewise.
	* testsuite/poke.libpoke/api.c (main): Add tests for new functions.

2023-11-04  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.c (pkl_gen_ps_var): Fix detection of
	non-methods.
	* testsuite/poke.pkl/optcond-pre-13.pk: New test.
	* testsuite/poke.pkl/optcond-pre-14.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.
	* pickles/Makefile.am (dist_pickles_DATA): Distribute srec.pk.
	* testsuite/poke.pickles/srec-test.pk: New file.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2023-11-03  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/poke.pk (pk_exception_handler): Fix styling.

2023-11-02  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-cmd-ios.c (ios_cmd): The option to .ios is optional.
	(pk_cmd_ios): Avoid crash when no IO space is
	(pk_cmd_file): Fix string.

2023-11-02  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-cmd-ios.c: Prepend . to dot-command Usage messages.
	* poke/pk-cmd-compiler.c: Likewise.
	* poke/pk-cmd-def.c: Likewise.
	* poke/pk-cmd-set.c: Likewise.
	* poke/pk-cmd-map.c: Likewise.
	* poke/pk-cmd-vm.c: Likewise.

2023-11-02  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-cmd-ios.c (sub_cmd): Use poke_completion_function.

2023-11-02  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (Files as IO Spaces): Document that $<...>
	supports specifying a non ambiguous non-empty substring.

2023-11-01  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/ios.h: Prototype for ios_get_handler.
	* libpoke/ios.c (ios_get_handler): New function.
	* libpoke/libpoke.h: Update description of
	pk_ios_completion_function.
	* libpoke/libpoke.c (pk_ios_completion_function): Complete on IOS
	handlers/names, not ids.
	* poked/poked.c (poked_autocmpl_send_one): Adapt to new
	pk_ios_completion_function.
	* poke/pk-repl.c (poke_completion_function): Complete IO space
	names.
	* testsuite/poke.repl/repl.exp: Update test
	tab-completion-subcommand-3.

2023-11-01  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-cmd-ios.c (ios_completion_function): Remove.
	(ios_cmd): Use poke_completion_function.
	(close_cmd): Likewise.
	* poke/pk-cmd-map.c (info_maps_completion_function): Remove.
	(info_maps_cmd): Use poke_completion_function.

2023-11-01  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/poke.pk (pk_prompt): New function.
	(pk_prompt_commented_p): Remove.
	* poke/pk-repl.c (pk_prompt): Call the Poke function pk_prompt to
	get the prompt string.
	* poke/pk-settings.pk (Example): Remove the prompt-commented
	setting.
	* doc/poke.texi (Changing the Prompt): New sectino

2023-11-01  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-cmd-editor.c (pk_cmd_editor): Stylize the prompt.

2023-11-01  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/libpoke.h (pk_ios_search): Add new param: FLAGS to support
	partial match of handlers.
	* libpoke/libpoke.c (pk_ios_search): Likewise.
	* libpoke/ios.h (ios_search): Likewise.
	* libpoke/ios.c (ios_search): Likewise.
	* poke/pk-ios.c (pk_ios_alien_token_handler): Update to do partial
	search for IOS handlers.
	* poke/pk-cmd-ios.c (pk_cmd_file): Call `pk_ios_search' with
	`PK_IOS_SEARCH_F_EXACT' flag.
	(pk_cmd_mem): Likewise.
	(pk_cmd_nbd): Likewise.
	* testsuite/poke.libpoke/api.c (STREQ): New macro.
	(test_pk_ios): New function for testing IO space functions.
	(main): Call `test_pk_ios'.

2023-11-01  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poke/pk-ios.c (pk_ios_alien_token_handler): Fix handling of
	alien tokens of length 1, i.e. $<.> tokens.

2023-11-01  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-cmd.h (enum pk_cmd_arg_type): Remove PK_CMD_ARG_TAG.
	(PK_CMD_ARG_TAG): Delete.
	* poke/pk-cmd.c (pk_cmd_exec_1): Remove handling of tag arguments.

2023-11-01  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-cmd-ios.c (expr_to_ios): New function.
	(pk_cmd_close): Get a Poke expression as an
	argument intead of an IOS tag.
	(pk_cmd_sub): Likewise.
	(pk_cmd_ios): Likewise.
	* poke/pk-cmd-map.c (pk_cmd_map_remove): Likewise.
	(pk_cmd_map_create): Likewise.
	(pk_cmd_map_show): Likewise.
	(pk_cmd_map_entry_add): Likewise.
	(pk_cmd_map_entry_remove): Likewise.
	(pk_cmd_map_load): Likewise.
	(pk_cmd_info_maps): Likewise.
	* testsuite/poke.cmd/extract-1.pk: Adapt test accordingly.
	* testsuite/poke.cmd/close-sub-1.pk: Likewise.
	* testsuite/poke.map/ass-map-22.pk: Likewise.
	* testsuite/poke.pkl/ios-cur-1.pk: Likewise.
	* testsuite/poke.cmd/ios-1.pk: Likewise.
	* testsuite/poke.cmd/sub-2.pk: Likewise.
	* testsuite/poke.cmd/sub-2.pk: Likewise.
	* testsuite/poke.cmd/maps-3.pk: Likewise.
	* testsuite/poke.cmd/maps-4.pk: Likewise.
	* testsuite/poke.cmd/maps-5.pk: Likewise.
	* testsuite/poke.cmd/maps-6.pk: Likewise.
	* testsuite/poke.cmd/maps-7.pk: Likewise.
	* testsuite/poke.cmd/maps-2.pk: Likewise.
	* testsuite/poke.cmd/maps-7.pk: Likewise.
	* testsuite/poke.cmd/maps-8.pk: Likewise.
	* testsuite/poke.cmd/maps-9.pk: Likewise.
	* testsuite/poke.cmd/file-mode.pk: Likewise.
	* testsuite/poke.cmd/file-bias-1.pk: Likewise.
	* testsuite/poke.cmd/file-bias-2.pk: Likewise.
	* testsuite/poke.cmd/file-relative.pk: Likewise.
	* doc/poke.texi: Update documentation on IO space tags and ids.

2023-10-30  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-help.pk (pk_help): Hint at activating the page at the
	end of the output of `.help'.

2023-10-29  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-info.pk (pk_info_type): Skip field pretty-printers in
	method list and anonymous fields in field list.

2023-10-29  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/linux.pk: New file.
	* pickles/Makefile.am (dist_pickles_DATA): Distribute linux.pk.
	* pickles/ios.pk (ios_dump_bytes): Always use the IOS of :val if
	present.

2023-10-29  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (Field Labels): Document that field labels should
	be specified after constraint expressions and initialization field
	values.

2023-10-29  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-cmd-def.c (pk_cmd_info_type): Get a Poke expression as
	the argument for .info type.
	* poke/pk-help.pk: Update help of .info type.
	* doc/poke.texi (info command): Likewise.

2023-10-29  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-info.pk (pk_info_type): Style sections.

2023-10-29  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-cmd.c (dot_cmds): Add compiler_cmd.
	(pk_cmd_init): Initialize compiler_trie.
	(pk_cmd_shutdown): Free compiler_trie.
	* poke/pk-cmd-compiler.c: New file.
	* poke/Makefile.am (poke_SOURCES): Add pk-cmd-compiler.c
	* libpoke/pkl-ast.c (pkl_ast_format): Initialize the
	string_buffer.
	* poke/pk-help.pk: Add .help topic for the .compiler command.
	* doc/poke.texi (@:.compiler ast): New section.
	(compiler command): Likewise.

2023-10-29  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl.h: Prototypes for pkl_debug_p, pkl_set_debug_p and
	pkl_get_last_ast_str.
	* libpoke/pkl.c (struct pkl_compiler): New fields debug_p and
	last_ast_str.
	(pkl_new): Initialize debug_p and last_ast_str.
	(pkl_debug_p): New function.
	(pkl_set_debug_p): Likewise.
	(pkl_get_last_ast_str): Likewise.
	(pkl_free): Free last_ast_str.
	(rest_of_compilation): Save printable representation of the ast if
	in debug mode.
	* libpoke/libpoke.h: New services pk_set_debug_p and
	pk_get_debug_ast.
	* libpoke/libpoke.c (pk_set_debug_p): New function.
	(pk_get_debug_ast): Likewise.
	* libpoke/pkl-ast.h: Add prototype of pkl_ast_format.
	* libpoke/pkl-ast.c (pkl_ast_format): New function.
	(pkl_ast_print): Rewrite in terms of pkl_ast_format.
	(pkl_ast_format_1): Rename from pkl_ast_print_1.

2023-10-28  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-cmd-ios.c (print_info_ios): Do not style `size' and
	`bias' entries as offsets.

2023-10-28  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-settings.pk (pk_settings_dump): Do not emit hyperlinks
	for setting headers, but style it.
	* poke/pk-cmd-set.c (pk_cmd_set_dump): Likewise.

2023-10-28  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-hserver.pk (hserver_print_hl): Make it possible to style
	hyperlinks.
	* pickles/pk-table.pk (PK_Table.print_table): Likewise.
	* poke/pk-table.c (pk_table_print): Likewise.
	* poke/pk-repl.c (banner): Likewise.
	* poke/pk-cmd-set.c (pk_cmd_set_dump): Likewise.

2023-10-28  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/ios.pk (ios_dump_bytes): Restore the proper style in the
	ascii area once dump :val is done with the value range.

2023-10-28  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-repl.c (pk_repl): Emit a styled prompt.

2023-10-28  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.h (PKL_AST_TYPE_I_DYN_P): Define.
	(struct pkl_ast_type): New field dyn_p in integral types.
	* libpoke/pkl-ast.c (pkl_ast_dup_type): Handle dyn_p in integral
	types.
	(pkl_ast_print_1): Likewise.
	* libpoke/pkl-tab.y (dynamic_integral_type_specifier: New rule.
	(integral_struct): Accept a dynamic integral type specifier as
	itype.
	* libpoke/pkl-typify.c (pkl_typify1_ps_type_struct): Handle int<*>
	and uint<*> as integral struct itypes.
	(pkl_typify1_ps_type_integral): Do not check size boundaries at
	compile-time for dynamic integral types.
	* testsuite/poke.pkl/int-struct-type-diag-16.pk: New test.
	* testsuite/poke.pkl/int-struct-type-diag-17.pk: Likewise.
	* testsuite/poke.pkl/int-struct-type-diag-18.pk: Likewise.
	* testsuite/poke.pkl/int-struct-type-diag-19.pk: Likewise.
	* testsuite/poke.pkl/int-struct-dyn-1.pk: Likewise.
	* testsuite/poke.pkl/int-struct-dyn-2.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.
	* doc/poke.texi (Integral Structs): Document using int<*> and
	uint<*> in integral structs.

2023-10-28  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/poke.pkl/struct-ind-5.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2023-10-28  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/iscan-str.pk: Add usage example.

2023-10-28  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/base64.pk: Use std's strchr.

2023-10-28  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/std.pk (strstr): New function.
	* testsuite/poke.std/std-test.pk: Add tests for strstr.
	* doc/poke.texi (strstr): New section.

2023-10-27  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-info.pk (pk_info_type): Do not list computed field
	setters and getters nor pretty printers as methods.

2023-10-23  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/gcov.pk: GCOV_Length now stores length in number of
	bytes and not in number of words.
	(GCOV_Record): counters use GCOV_Int64, not int<64>.

2023-10-23  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/Makefile.am (dist_pickles_DATA): Distribute gcov.pk.

2023-10-23  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/gcov.pk (GCOV_Version): Allow ' ' as status character.
	(GCOV_String): Fix length constraint.

2023-10-22  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/gcov.pk: New file.
	* testsuite/poke.pickles/bmp-test.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2023-10-09  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* doc/poke.texi (pokefmt): Fix typo in example code.
	(Integral Structs): Add missing map operator.

2023-10-06  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl.h (pkl_execute_file): Fix comment regarding
	EXIT_EXCEPTION.
	(pkl_execute_buffer): Likewise.

2023-10-06  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/libpoke.h (pk_load): Add `exit_exception' parameter.
	* libpoke/libpoke.c (pk_load): Likewise.
	* libpoke/pkl.h (pkl_load): Likewise.
	* libpoke/pkl.c (pkl_load): Likewise.
	* poke/pk-cmd.c (pk_cmd_init): Call default handler for loading
	`pk-cmd' module.
	* poke/poke.c (initialize): Update use of `pk_load'.
	* pokefmt/pokefmt.l (poke_init): Likewise.
	* testsuite/poke.libpoke/api.c (test_pk_load): New function for
	`pk_load'-related tests.
	(main): Call `test_pk_load'.

2023-10-06  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/libpoke.h (LIBPOKE_NONNULL): New macro for nonnull attribute
	for functions.
	(pk_compile_file): Use `LIBPOKE_NONNULL'.
	(pk_compile_buffer): Likewise.
	(pk_compile_buffer_with_loc): Likewise.
	(pk_compile_statement): Likewise.
	(pk_compile_statement_with_loc): Likewise.
	(pk_compile_expression): Likewise.
	(pk_compile_expression_with_loc): Likewise.

2023-10-06  Jose E. Marchesi  <jemarch@gnu.org>

	* etc/hacking.org: List Mohammad-Reza Nabipoor as GNU maintainer.

2023-10-04 Vincenzo Palazzo  <vincenzopalazzodev@gmail.com>

	* etc/hacking.org (Write After Approval): Update.
    * HACKING: Regenerate.

2023-10-04  Vincenzo Palazzo  <vincenzopalazzodev@gmail.com>

	* etc/nix/default.nix: remove the empty line at the EOF.

2023-10-02  Vincenzo Palazzo  <vincenzopalazzodev@gmail.com>

	* etc/nix/default.nix: add a simple nix shell.

2023-09-25  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/libpoke.c (pk_compiler_new_with_flags): Add checks for
	presence of user-provided function pointers for the terminal
	interface.
	* testsuite/poke.libpoke/api.c (test_pk_compiler_new): Update tests.

2023-09-23  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* etc/hacking.org (Maintainers): Update.
	* HACKING: Regenerate.

2023-09-22  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* configure.ac (AC_CONFIG_FILES): Add `pokefmt/Makefile'.
	* Makefile.am (SUBDIRS): Add `pokefmt'.
	* pokefmt/pokefmt.l: New template system to embed Poke code in docs,
	tests, etc.
	* pokefmt/pokefmt.pk: Poke support code for `pokefmt' app.
	* pokefmt/Makefile.am: New file.
	* run.in (POKEFMTAPPDIR): New variable.
	* poke.pokefmt/pokefmt.exp: New tests.
	* testsuite/Makefile.am (check-DEJAGNU): Add `POKEFMTAPPDIR' env var.
	(EXTRA_DIST): Update.
	* doc/poke.texi (pokefmt): Add new chapter.

2023-09-18  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-lex.l: Accept t and T suffix for uint<1> values.
	* libpoke/pkl-rt.pk: Adapt values printer accordingly.
	* testsuite/poke.pkl/integers-13.pk: New test.
	* testsuite/poke.pkl/integers-14.pk: Likewise.
	* testsuite/poke.pkl/integers-15.pk: Likewise.
	* testsuite/poke.pkl/integers-16.pk: Likewise.
	* testsuite/poke.map/ass-map-19.pk: Update test accordingly.
	* testsuite/poke.map/maps-int-structs-11.pk: Likewise.
	* testsuite/poke.map/maps-int-structs-6.pk: Likewise.
	* testsuite/poke.map/maps-int-union-3.pk: Likewise.
	* testsuite/poke.map/maps-int-union-4.pk: Likewise.
	* testsuite/poke.map/maps-int-union-5.pk: Likewise.
	* testsuite/poke.pkl/bconc-lvalue-6.pk: Likewise.
	* testsuite/poke.pkl/cast-integers-12.pk: Likewise.
	* testsuite/poke.pkl/cast-integers-8.pk: Likewise.
	* testsuite/poke.pkl/printf-value-15.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.
	* doc/poke.texi (Integer Literals): Document suffixes for bit
	integer literals.

2023-09-17  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-diff.pk: Refer to default values of configuration
	variables in doc strings as to hold the value "initially" rather
	than "currently".

2023-09-16  Jose E. Marchesi  <jose.marchesi@oracle.com>

	* pickles/Makefile.am (dist_pickles_DATA): Add gpt.pk.

2023-09-15  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm-val.c (pvm_array_insert): Fix defensive check when
	array allocation grows.
	* testsuite/poke.pkl/array-3.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2023-09-10  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* pickles/gpt.pk (GPT_SECTOR_SIZE): Remove.
	(GPT_SectorSize): New unit.
	(GPT_LBA): New type.
	(GPT_Header): Change type of fields to offset when appropriate.
	(GPT_Partition_Entry): Likewise.
	(GPT): Update.
	* testsuite/poke.pickles/gpt-test.pk (tests): Likewise.

2023-09-10  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* pickles/mbr.pk (MBR_SectorSize): New unit.
	(MBR_PartitionType): Change it to integral struct.
	(MBR_PTE): Change `lba' and `sector_count' to little-endian offset
	type.  Add `lba_end' method.
	(MBR): Mark `signature' and `magic' as little-endian.
	* testsuite/poke.pickles/mbr-test.pk (SAMPLE_MBR): New sample data.
	("Sample MBR verification"): New test to verify sample data.

2023-09-09  Denis Maryin  <des.maryin@googlemail.com>

	* pickles/Makefile.am (dist_pickles_DATA): Add new pickles.
	* pickles/gpt-partition-attrs.pk: New pickle.
	* pickles/gpt-partition-types.pk: Likewise.
	* pickles/gpt.pk: Liekwise.
	* pickles/guid.pk: Likewise.
	* pickles/mbr.pk (MBR_PT_*): New constants.
	(MBR_PartitionType): New type.
	(MBR_PTE): Use `MBR_PartitionType'.
	* testsuite/poke.pickles/gpt-test.pk: New test.
	* testsuite/poke.pickles/guid-test.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2023-09-09  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-lex.l (NEWLINE): Add `\r\n' sequence to newline
	definition.
	* doc/poke.texi (The Poke Language): Add a new section `Source Code
	Encoding'.

2023-09-08  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-typify.c (pkl_typify1_ps_trimmer): The type of the
	result of an array trim is an array bounded by number of elements.
	* testsuite/poke.pkl/arrays-17.pk: Adapt test to the new type of
	the trimmed value.
	* testsuite/poke.pkl/trim-26.pk: Likewise.
	* testsuite/poke.pkl/trim-32.pk: Likewise.

2023-09-08  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-insn.def: Remove PKL_INSN_ATRIM.
	* libpoke/pkl-asm.c (pkl_asm_insn_atrim): Delete.
	(pkl_asm_insn): Do not handle ATRIM.
	* libpoke/pkl-asm.pks (atrim): Move macro from here...
	* libpoke/pkl-gen.pks (atrim): ... to here.

2023-09-06  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (elfextractor): Fix example.

2023-08-26  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pvm-alloc.h (GC_THREADS): New cpp define.
	(pvm_alloc_register_thread): Remove `const' qualifier from local var.

2023-08-26  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm-alloc.h: Fix prototypes for
	pvm_alloc_{register,unregister}_thread.

2023-08-24  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/ios.pk: Use "closure" hyperlinks to guarantee that they
	will work ever if another subsequent dump is issued.

2023-08-24  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-hserver.c (hserver_thread_worker): Register/unregister
	listener thread in libpoke.

2023-08-23  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/libpoke.h: Prototypes for pk_register_thread and
	pk_unregister_threads.
	* libpoke/libpoke.c (pk_register_thread): New function.
	(pk_unregister_thread): Likewise.
	* libpoke/pvm-alloc.h: Prototypes for pvm_alloc_register_thread
	and pvm_alloc_unregister_thread.
	* libpoke/pvm-alloc.c (pvm_alloc_initialize): Call
	GC_allow_register_threads.
	(pvm_alloc_register_thread): New function.
	(pvm_alloc_unregister_thread): Likewise.
	* libpoke/pvm.h: Prototype for pvm_register_thread and
	pvm_unregister_thread.
	* libpoke/pvm.c (pvm_register_thread): New function.
	(pvm_unregister_thread): Likewise.


2023-08-23  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-dump.pk (pk_dump_max_line_width): New variable.
	(dump): Pass val and max_line_width.
	Document arguments :val and :max_line_width.
	(dumpval): New function.
	* doc/poke.texi (Information @command{dump} shows): Document dump
	:val.

2023-08-21  Jose E. Marchesi  <jemarch@gnu.org>

	* etc/poke-dark.css (.dump-val1): New class.
	(.dump-val2): Likewise.
	(.dump-val3): Likewise.
	(.dump-val4): Likewise.
	* pickles/ios.pk (ios_dumpval_styles): New global.

2023-08-22  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.c (pkl_gen_pr_ass_stmt): Fix assigning values to
	any[] arrays.
	* libpoke/pvm-val.c (pvm_type_equal_p): Handle null[] types
	properly.
	* testsuite/poke.pkl/ass-22.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2023-08-20  Jose E. Marchesi  <jemarch@gnu.org>

	* NEWS: Add entries for poke 3.3.
	* doc/gendocs_template (For version 3.3): Update version to 3.3.

2023-08-20  Jose E. Marchesi  <jemarch@gnu.org>

	* configure.ac: Do not use AC_PROG_CC_C99 with autoconf >= 2.70.

2023-08-06  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* liboke/ios.c (ios_write_int_common): Fix the function when `bits'
	is 16, 24, 32, 40, 48, 56, 64.
	* testsuite/poke.map/maps-uint-write-75.pk: New test.
	* testsuite/poke.map/maps-uint-write-76.pk: Likewise.
	* testsuite/poke.map/maps-uint-write-77.pk: Likewise.
	* testsuite/poke.map/maps-uint-write-78.pk: Likewise.
	* testsuite/poke.map/maps-uint-write-79.pk: Likewise.
	* testsuite/poke.map/maps-uint-write-80.pk: Likewise.
	* testsuite/poke.map/maps-uint-write-81.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2023-07-06  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* doc/poke.texi (Integral Structs): Update.

2023-07-20  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (Scripts): Add missing `open' to example.

2023-07-15  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-cmd-ios.c (pk_cmd_sub): Avoid assert when no name is
	specified for the sub IO space.
	* testsuite/poke.cmd/sub-1.pk: New test.
	* testsuite/poke.cmd/sub-2.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2023-07-12  David Faust  <david.faust@oracle.com>

	* pickles/btf.pk (BTF_KIND_ENUM64): New.
	(BTF_KIND_LAST): Update accordingly.
	(btf_kind_names): Add "enum64".
	(type BTF_Enum64): New type.
	(type BTF_Type): Support BTF_Enum64 here.
	* pickles/btf-dump.pk (btf_dump_enum64): New function.
	(btf_dump_type_vdata): Call it here.


2023-07-06  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-gen.pks (struct_mapper): Make sure `@field' is of
	type `PKL_AST_STRUCT_TYPE_FIELD' before using the field accessor.
	(struct_constructor): Likewise.

2023-07-02  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-ast.h (PKL_AST_DECL_PREV_DECL): New macro.
	(PKL_AST_DECL_REDECL_CHAIN): Likewise.
	(struct pkl_ast_decl): New fields.
	* libpoke/pkl-ast.c (pkl_type_append_to): Don't report re-declared
	names directly (because they contain the a dollar character and
	a generation number which are implementation details). Use
	user-defined name.
	(pkl_ast_node_free_1): Handle `prev_decl' field.
	(pkl_ast_print_1): Likewise.
	* libpoke/pkl-env.h (pkl_env_commit_renames): New function and
	comments.
	* libpoke/pkl-env.c (struct pkl_env): Add new field `redecls' to
	keep track of re-declarations.
	(decl_rollback): New static function.
	(env_redecls_free): Likewise.
	(register_decl): Add new param `env'.  Change the logic of re-naming
	for re-declarations.
	(pkl_env_free): Handle `redecls'.
	(pkl_env_register): Pass `env' to `register_decl'.
	(decl_redefined_p): New static function.
	(pkl_env_iter_begin): Updated to skip re-defined declarations.
	(pkl_env_iter_next): Likewise.
	(pkl_env_commit_renames): New function to commit new re-declarations
	in the environment.
	(pkl_env_rollback_renames): Rewrite to call `env_redecls_free'.
	* libpoke/pkl.c (pkl_execute_buffer): Add
	`pkl_env_{commit,rollback}_reanmes'.
	(pkl_execute_statement): Likewise.
	(pkl_compile_expression): Likewise.
	(pkl_execute_expression): Likewise.
	(pkl_execute_file): Likewise.
	* testsuite/poke.pkl/redef-4.pk: New test.
	* testsuite/poke.pkl/redef-5.pk: Likewise.
	* testsuite/poke.pkl/redef-6.pk: Likewise.
	* testsuite/poke.pkl/redef-7.pk: Likewise.
	* testsuite/poke.pkl/redef-diag-4.pk: Likewise.
	* testsuite/poke.pkl/redef-diag-5.pk: Likewise.
	* testsuite/poke.pkl/redef-diag-6.pk: Likewise.
	* testsuite/poke.pkl/deftype-2.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2023-07-02  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-env.h (pkl_env_new): Update comment to document
	behavior on failure (return `NULL').
	(pkl_env_push_frame): Likewise.
	(pkl_env_dup_toplevel): Likewise.
	* libpoke/pkl-env.c (xalloc.h): Remove include.
	(pkl_env_new): Use `calloc' instead of `xzalloc'.
	(pkl_env_push): Handle memory error.
	(pkl_env_dup_toplevel): Likewise.
	* libpoke/pkl.c (pkl_new): Handle memory failures related to
	`pkl_env'.
	(pkl_execute_buffer): Likewise.
	(pkl_execute_statement): Likewise.
	(pkl_compile_expression): Likewise.
	(pkl_execute_expression): Likewise.
	(pkl_execute_file): Likewise.

2023-06-28  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-ios.c (pk_open_proc_maps): Fix access to uninitialized
	memory.

2023-06-26  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/ios-dev-stream.c (assert.h): Remove.
	(ios_dev_stream_flush): Call `fflush' only on `<stdout>'/`<stderr>'
	based on IOS flags.
	* libpoke/pvm.jitter (flush): Push `PVM_NULL' when there's no error.
	* testsuite/poke.pkl/flush-2.pk: New test.
	* testsuite/poke.pkl/flush-3.pk: Likewise.
	* testsuite/poke.pkl/flush-4.pk: Likewise.
	* testsuite/poke.pkl/flush-5.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2023-06-23  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.pks (struct_constructor): Re-raise an E_conv
	from ATOA as an E_constraint.
	* testsuite/poke.pkl/ass-19.pk: New test.
	* testsuite/poke.pkl/ass-20.pk: Likewise.
	* testsuite/poke.pkl/ass-21.pk: Likewise.
	* testsuite/poke.pkl/scons-43.pk: Update test.
	* libpoke/pkl-asm.pks (asetc): Raise E_constraint instead of
	E_conv if the array type boundaries are violated.
	* testsuite/poke.pkl/array-siz-diag-1.pk: Update test accordingly.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2023-06-22  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (From Bytes to Integers): Add missing word.

2023-06-19  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-asm.pks (asetc): Raise E_constraint and not E_conv
	if the new value makes the array to not fulfill its boundary.

2023-06-19  Jose E. Marchesi  <jemarch@gnu.org>
2023-06-19  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pvm-val.h (array): New field sct.constructor.
	(PVM_VAL_TYP_S_CONSTRUCTOR): Define.
	* libpoke/pvm-val.c (pvm_struct_type_constructor): New function.
	(pvm_make_struct_type): Get a new `constructor' argument.
	* libpoke/pkl-insn.def (PKL_INSN_TYSCTGETC): New instruction.
	(PKL_INSN_TYSCTSETC): Likewise.
	* libpoke/pk-val.c (pk_make_struct_type): Pass PVM_NULL for
	constructor.
	* libpoke/pvm-val.c (pvm_make_exception): Likewise.
	* libpoke/pvm.jitter (mktysct): Likewise.
	(tysctgetc): New instruction.
	(tysctsetc): Likewise.
	* libpoke/pkl-gen.c (pkl_gen_ps_type_struct): Install constructor
	closure in the created PVM struct type.
	(pkl_gen_pr_cons): Converted from pkl_gen_ps_cons.
	(pkl_gen_pr_decl): Moving mapper generation after the generation of
	constructor.
	(pkl_gen_pr_ass_stmt): fix field assignements within methods.
	* libpoke/pkl-asm.pks (ssetc): Use run-time consructor closure if
	no struct_type AST node is provided.
	* testsuite/poke.map/maps-structs-methods-12.pk: New test.
	* testsuite/poke.map/maps-structs-methods-13.pk: Likewise.
	* testsuite/poke.map/maps-structs-methods-14.pk: Likewise.
	* testsuite/poke.pkl/struct-method-20.pk: Likewise.
	* testsuite/poke.pkl/struct-method-21.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2023-05-28  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-ast.h (PKL_AST_DECL_IN_STRUCT_P): Add comment to
	explain the field.

2023-05-24  Constantin Nickel  <constantin.nickel@gmail.com>

	* libpoke/libpoke.h (pk_compiler_new): Remove leftover comment
	about RTPATH argument.

2023-05-23  Constantin Nickel  <constantin.nickel@gmail.com>

	* common/pk-utils.h: Fix spelling mistakes.
	* doc/poke.texi: Likewise.
	* libpoke/ios.h: Likewise.
	* libpoke/libpoke.h: Likewise.
	* libpoke/pkl-ast.h: Likewise.
	* libpoke/pkl-promo.c: Likewise.
	* libpoke/pkl-rt.pk: Likewise.
	* libpoke/pkl.h: Likewise.
	* libpoke/pvm-val.h: Likewise.
	* libpoke/pvm.jitter: Likewise.
	* libpoke/ras: Likewise.
	* pickles/pe.pk: Likewise.
	* poke/pk-cmd-ios.c: Likewise.
	* poke/pk-settings.pk: Likewise.
	* testsuite/poke.pkl/eq-any-integral-1.pk: Likewise.
	* testsuite/poke.pkl/eq-any-integral-2.pk: Likewise.
	* testsuite/poke.pkl/eq-any-integral-3.pk: Likewise.
	* testsuite/poke.pkl/eq-any-integral-4.pk: Likewise.

2023-05-19  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.c (pkl_gen_pr_ass_stmt): Perform a LMAP whenever
	necessary when assigning to struct fields within methods.
	* testsuite/poke.map/setter-1.pk: New test.
	* testsuite/poke.map/setter-2.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2023-05-19  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-tab.y: Adjust hack that workarounds bison problem to
	field pre-conditions.
	* testsuite/poke.pkl/int-union-type-diag-9.pk: Fix test.

2023-05-19  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.c (PKL_GEN_PUSH_CONTEXT): Emit error instead of
	aborting if maximum nesting level is reached.
	* libpoke/pkl-anal.c (PKL_ANAL_PUSH_CONTEXT): Likewise.
	* testsuite/poke.pkl/maxnest-diag-1.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2023-05-19  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-env.c (pkl_env_iter_next): Skip re-defined
	declarations.
	(pkl_env_iter_begin): Likewise.

2023-05-18  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.pks (check_struct_field_constraint): Get STRICT
	as an argument in the stack and use it after executing the
	constraint.
	(handle_struct_field_constraints): Let
	check_struct_field_constraint handle STRICT.
	(struct_constructor): Pass a STRICT to
	check_struct_field_constraint.
	* testsuite/poke.map/nsmap-7.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.
	* doc/poke.texi (Working with Incorrect Data): Document new
	behavior.

2023-05-18  Jose E. Marchesi  <jemarch@gnu.org>

	* etc/poke.rec (Auto-complete fields foo->bar): New entry.

2023-05-18  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/libpoke.c (find_field_referrer): New function.

2023-05-18  Jose E. Marchesi  <jemarch@gnu.org>

	* etc/poke.rec (Alien tokens for IO space names: $<path/to/file>):
	Remove as done.
	(Auto-complete $<...> in the prompt): New todo.

2023-05-18  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/poke.pvm/pvm-insns-test.pk: Add tests for instructions
	`sconc', `and', `or', and `not'.

2023-05-18  Jose E. Marchesi  <jemarch@gnu.org>a

	* libpoke/pkl-promo.c (promote_array): Fix bounded array fast
	path.
	* testsuite/poke.pkl/promo-array-return-6.pk: New test.
	* testsuite/poke.pkl/add-arrays-4.pk: Fix test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2023-05-17  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (iosearch): New function.
	* testsuite/poke.pkl/iosearch-1.pk: New test.
	* testsuite/poke.pkl/iosearch-2.pk: Likewise.
	* testsuite/poke.pkl/iosearch-3.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.
	* doc/poke.texi (iosearch): New section.

2023-05-17  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/poke.cmd/ios-2.pk: New test.
	* testsuite/poke.cmd/ios-3.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2023-05-17  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-ios.c (pk_ios_init): New function.
	(pk_ios_shutdown): Likewise.
	(pk_ios_alien_token_handler): Likewise.
	* poke/poke.c (initialize): Call pk_ios_init.
	(finalize): Call pk_ios_shutdown.

2023-05-17  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-lex.l: Support $<...> alien tokens.
	* libpoke/libpoke.c (pk_set_alien_dtoken_fn): New function.
	* libpoke/pkl.c (struct pkl_compiler): New field alien_dtoken_fn.
	(pkl_alien_dtoken_fn): New function.
	(pkl_set_alien_dtoken_fn): Likewise.

2023-05-17  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.pks (struct_constructor): Make sure the
	destination type of a cast to an array has a bounder.
	* libpoke/pkl-gen.c (pkl_gen_pr_type_array): Make sure the array
	type has a bounder in PKL_GEN_CTX_IN_TYPE context.
	* testsuite/poke.pkl/scons-72.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2023-05-16  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/pe.pk (PE_Name): //BASE64 is worse than I thought.
	* testsuite/poke.pickles/pe-test.pk: Update.

2023-05-16  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/Makefile.am (dist_pickles_DATA): Add base64.pk.

2023-05-16  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/base64.pk (base64_decode): Simplify.

2023-05-15  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/base64.pk (base64_decode): Quote characters are optional
	as per RFC.
	* testsuite/poke.pickles/pe-test.pk: Add tests for optional quote
	characters.
	* pickles/pe.pk (PE_Nam.get_offset): Simplify accordingly.

2023-05-15  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/coff.pk (COFF_File): Use pre-condition for optional
	field opt_hdr.

2023-05-14  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/base64.pk: New file.
	* testsuite/poke.pickles/base64-test.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.
	* testsuite/poke.pickles/pe-test.pk: Add tests for PE names
	encoding and decoding.

2023-05-14  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/poke.pvm/pvm-insns-test.pk: Add tests for subi, subiu,
	subl and sublu.

2023-05-14  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/poke.pvm/pvm-insns-test.pk: Add tests for gei, geiu,
	gel, gelu, ges, lei, leiu, lel, lelu, les, eqc and nec.

2023-05-13  Jose E. Marchesi  <jemarch@gnu.org>

	* NEWS: Add entries for 3.2.
	* doc/gendocs_template (For version 3.2): Update version to 3.2.

2023-05-13  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/poke.pvm/pvm-insns-test.pk: Add tests for cgetn, nn,
	nnn, eqi, eqiu, eql, eqlu, eqs, nei, neiu, nel, nelu, nes, lti,
	ltiu, ltl, ltlu, lts, gti, gtiu, gtl, gtlu, gts.

2023-05-13  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.h (PKL_AST_TYPE_FALLIBLE_UNKNOWN): Define.
	(PKL_AST_TYPE_FALLIBLE_YES): Likewise.
	(PKL_AST_TYPE_FALLIBLE_NO): Likewise.
	(PKL_AST_TYPE_FALLIBLE): Likewise.
	(struct pkl_ast_type): New field `fallible'.
	* libpoke/pkl-ast.c (pkl_ast_make_type): Initialize newly created
	types with unknown fallible.
	(pkl_ast_make_integral_type): Initialize fallible.
	(pkl_ast_make_string_type): Likewise.
	(pkl_ast_make_void_type): Likewise.
	(pkl_ast_make_offset_type): Likewise.
	(pkl_ast_make_any_type): Likewise.
	(pkl_ast_dup_type): Handle fallible.
	(pkl_ast_type_is_fallible): New function.
	(pkl_ast_print_1): Print fallible.
	* libpoke/pkl-typify.c (pkl_typify2_ps_type): Set fallibility of
	type nodes.

2023-05-13  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/poke.pkl/rtrace-3.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2023-05-13  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (RTRACE): New macro.
	(rtrace): Call RTRACE.

2023-05-13  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (rtrace): New section.

2023-05-13  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-insn.def (PKL_INSN_RTRACE): New instruction.
	* libpoke/pvm.jitter (PVM_CALL): Push the caller's name in the
	returnstack.
	(return): Drop the caller's name from the returnstack.
	(rtrace): New instruction.
	* libpoke/pkl-rt.pk (rtrace): New function.
	* testsuite/poke.pkl/rtrace-1.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.
	* etc/poke.rec (PVM stack traces): Remove as done.

2023-05-13  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm-val.h (PVM_VAL_CLS_NAME): Define.
	(struct pvm_cls): New field `name'.
	* libpoke/pvm-val.c (pvm_make_cls): Get a a `name' argument.
	* libpoke/pkl-insn.def (PKL_INSN_CGETN): New instruction.
	* libpoke/pvm.jitter (duc): Specify a name in pvm_make_cls.
	(cgetn): New instruction.
	* libpoke/pkl-gen.c (pkl_gen_pr_decl): Likewise.
	(pkl_gen_ps_lambda): Likewise.
	(pkl_gen_pr_type_function): Likewise.
	* libpoke/ras: Likewise.
	* libpoke/pkl-rt.pk (_pkl_print_format_any): Print closure names.
	* testsuite/poke.pkl/clsname-1.pk: New test.
	* testsuite/poke.pkl/arrays-15.pk: Update test.
	* testsuite/poke.pkl/funcall-17.pk: Likewise.
	* testsuite/poke.pkl/ios-hook-close-pre-2.pk: Likewise.
	* testsuite/poke.pkl/scons-59.pk: Likewise.
	* testsuite/poke.pkl/struct-method-17.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2023-05-13  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (PVM_PEEK): Do not raise exceptions.
	(peeki): Update description and remove branching jitter tag.
	(peekiu): Likewise.
	(peekl): Likewise.
	(peeklu): Likewise.
	(peekdi): Likewise.
	(peekdiu): Likewise.
	(peekdl): Likewise.
	(peekdlu): Likewise.
	(peeks): Likewise.
	* libpoke/pkl-gen.c (pkl_gen_ps_type_integral): Check and handler
	exceptions by peek* instructions.
	(pkl_gen_ps_type_string): Likewise.

2023-05-13  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (close): Do not raise exceptions.
	(flush): Likewise.
	* libpoke/pkl-rt.pk (close): Adapt accordingly.
	(flush): Likewise.
	* testsuite/poke.pkl/flush-1.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2023-05-13  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (PVM_MAKE_DFL_EXCEPTION): Define.
	(PVM_POKE): Do not raise exceptions.
	(pokei): Update description and remove branching jitter tag.
	(pokeiu): Likewise.
	(pokel): Likewise.
	(pokelu): Likewise.
	(pokedi): Likewise.
	(pokediu): Likewise.
	(pokedl): Likewise.
	(pokedlu): Likewise.
	(pokes): Likewise.
	* libpoke/pkl-gen.c (pkl_gen_ps_type_integral): Check and handler
	exceptions by poke* instructions.
	(pkl_gen_ps_type_string): Likewise.

2023-05-07  Patrick Trottier  <code@algolibre.net>

	Various fixes in the manual.

2023-05-03  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.c (pkl_gen_pr_ass_stmt): Fix check for non-null
	field name.
	* testsuite/poke.pkl/ass-18.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2023-04-30  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/ios.h (ios_context): New type.
	(ios_init): Returns `ios_context`.
	(ios_shutdown): Add new `ios_context` param.
	(ios_open): Likewise.
	(ios_close): Likewise.
	(ios_cur): Likewise.
	(ios_set_cur): Likewise.
	(ios_search): Likewise.
	(ios_search_by_id): Likewise.
	(ios_begin): Likewise.
	(ios_map): Likewise.
	(ios_register_foreign_iod): Likewise.
	(ios_foreign_iod): Likewise.
	* libpoke/ios-dev-sub.c (ios_dev_sub_open): Update.
	* libpoke/ios.c (struct ios): Mark `dev_if' as const.
	(struct ios_context): Add new field `foreign_dev_if'.
	(IOS_DEV_IF_DATA): Remove macro.
	(IOS_DEV_ZERO): New constant.
	(IOS_DEV_MEM): Likewise.
	(IOS_DEV_STREAM): Likewise.
	(IOS_DEV_NBD): Likewise.
	(IOS_DEV_PROC): Likewise.
	(IOS_DEV_SUB): Likewise.
	(IOS_DEV_FILE): Likewise.
	(ios_dev_ifs): Update.
	(ios_ctx): Remove.
	(ios_dev_ifs_count): New constant.
	(ios_context_data): New internal function.
	(ios_init): Returns `ios_context'.
	(ios_shutdown): Add new `ios_context' param.
	(ios_open): Likewise.
	(ios_close): Likewise.
	(ios_cur): Likewise.
	(ios_set_cur): Likewise.
	(ios_search): Likewise.
	(ios_search_by_id): Likewise.
	(ios_begin): Likewise.
	(ios_map): Likewise.
	(ios_foreign_iod): Likewise.
	(ios_register_foreign_iod): Likewise.
	* libpoke/pvm.h (pvm_ios_context): New function.
	* libpoke/pvm.c (pvm_ios_context): Likewise.
	(PVM_STATE_IOS_CONTEXT): New macro.
	(pvm_init): Add IOS initialization.
	(pvm_shutdown): Add IOS finalization.
	* libpoke/libpoke.c (struct _pk_compiler): Add `struct ios_dev_if`
	for foreign IOD.
	(pk_ios_completion_function): Update to use `ios_context'.
	(pk_ios_cur): Likewise.
	(pk_ios_set_cur): Likewise.
	(pk_ios_search): Likewise.
	(pk_ios_search_by_id): Likewise.
	(pk_ios_open): Likewise.
	(pk_ios_close): Likewise.
	(pk_ios_map): Likewise.
	(foreign_iod_if): Remove global variable.
	(pk_register_iod): Rely on `pk_compiler' fields instead of global
	variable. Use `ios_context'.
	* libpoke/pvm.jitter (state-struct-backing-c): Add new
	field `ios_context'.
	(state-initialization-c): Initialize new field.
	(PVM_PEEK): Update to use IOS context.
	(PVM_POKE): Likewise.
	(open): Likewise.
	(close): Likewise.
	(flush): Likewise.
	(pushios): Likewise.
	(popios): Likewise.
	(ioflags): Likewise.
	(iosize): Likewise.
	(ionum): Likewise.
	(ioref): Likewise.
	(iohandler): Likewise.
	(iogetb): Likewise.
	(iosetb): Likewise.
	(peeks): Likewise.
	(pokes): Likewise.

2023-04-30  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/ios.h (ios_get_dev_if): Add declaration.
	(ios_get_dev): Likewise.
	* libpoke/ios.c (ios_get_dev_if): Add `const' to function def.
	* libpoke/ios-dev.h (ios_dev_if): Likewise.

2023-04-29  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/ios-dev.h (struct ios_dev_if): Remove `data' field.
	* libpoke/ios.h (ios_register_foreign_iod): Add new param: `data'.
	* libpoke/ios.c (struct ios_context): New struct to put all
	global states in one place.
	(IOS_DEV_IF_DATA): New macro.
	(ios_ctx): An instance of `struct ios_context' which contains
	all global states.
	(ios_shutdown): Adapt to use `ios_ctx' global variable.
	(ios_open): Likewise.
	(ios_close): Likewise.
	(ios_cur): Likewise.
	(ios_set_cur): Likewise.
	(ios_search): Likewise.
	(ios_search_by_id): Likewise.
	(ios_set_bias): Likewise.
	(ios_map): Likewise.
	(ios_register_foreign_iod): Use new param.
	* libpoke/libpoke.c (pk_register_iod): Update.

2023-04-30  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/ios.h (ios_zombie_p): Fix typo in function declaration.

2023-04-29  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl.c (pkl_free): Remove unused variable.

2023-04-29  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/ios.h (ios_inc_sub_dev): New function to track sub
	IO spaces.
	(ios_dec_sub_dev): Likewise.
	(ios_zombie_p): New function.
	* libpoke/ios.c (struct ios): Add new fields `zombie_p` and
	`num_sub_devs'.
	(ios_inc_sub_dev): New function definition.
	(ios_dec_sub_dev): Likewise.
	(ios_zombie_p): Likewise.
	(ios_open): Initialize new fields.
	(ios_close): Instead of deallocating the IOS, it becomes a zombie,
	if there's at least one sub-device that using this IOS.
	* libpoke/ios-dev-sub.c (struct ios_dev_sub): Use `ios' instead of
	ios id.
	(ios_dev_sub_open): Update to track base IOS.
	(ios_dev_sub_close): Likewise.
	(ios_dev_sub_pread): Use base IOS directly instead of searching
	using id.
	(ios_dev_sub_pwrite): Likewise.
	* testsuite/poke.pkl/open-sub-19.pk: New test.
	* testusite/poke.pkl/open-sub-20.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2023-04-29  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-tab.y (format_arg_list): Reworked to avoid code
	duplication.

2023-04-29  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl.c (pkl_module_loaded_p): Remove function.
	(pkl_add_module): Likewise.
	* libpoke/pkl.h: ... and prototypes.
	* libpoke/pkl.c (struct pkl_compiler): Remove `modules' and
	`num_modules' fields.
	(pkl_new): Do not initialize these.
	(pkl_free): Do not dispose memory for these.
	* libpoke/pkl-tab.y (load_module): Do not call pkl_add_module.

2023-04-29  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl.c (pkl_load): Allow loading modules more than once.
	* libpoke/libpoke.h: Document this behavior.

2023-04-28  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/libpoke.c (pk_load): Fix returned value.
	* poke/pk-cmd.c (pk_cmd_init): Fix call to pk_load.
	* poke/poke.c (initialize): Likewise.

2023-04-26  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/libpoke.h: Prototype for pk_keyword_p.
	* libpoke/libpoke.c (pk_keyword_p): New function.
	* libpoke/Makefile.am: Generate $(srcdir)/pkl-keywords.def.
	* testsuite/poke.libpoke/api.c (test_pk_keyword_p): New test.
	* .gitignore: Add /libpoke/pkl-keywords.def.

2023-04-25  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/poke.std/std-test.pk: Do not use "standard" types.

2023-04-25  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/lib/poke-pk.exp (tap_execute): Pass --no-stdtypes to
	poke.
	* pickles/asn1-ber.pk: Do not use "standard" types.
	* pickles/bmp.pk: Likewise.
	* pickles/color.pk: Likewise.
	* pickles/id3v2.pk: Likewise.
	* pickles/id3v1.pk: Likewise.
	* pickles/ieee754.pk: Likewise.
	* pickles/leb128.pk: Likewise.
	* pickles/mbr.pk: Likewise.
	* pickles/openpgp.pk: Likewise.
	* pickles/jffs2.pk: Likewise.
	* pickles/pdap.pk: Likewise.
	* pickles/pcap.pk: Likewise.
	* pickles/riscv.pk: Likewise.
	* testsuite/poke.pickles/mbr-test.pk: Likewise.
	* testsuite/poke.pickles/uuid-test.pk: Likewise.
	* testsuite/poke.pickles/search-test.pk: Likewise.

2023-04-25  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/poke.c (initialize): Use pk_compiler_new_with_flags.
	(NO_STDTYPES_ARG): Define.
	(parse_args_1): Handle NO_STDTYPES_ARG.
	(parse_args_2): Likewise.
	* poke/pk-hserver.pk: Do not use standard types.
	* poke/pk-settings.pk: Likewise.
	* poke/pk-dump.pk: Likewise.
	* poke/pk-copy.pk: Likewise.
	* poke/pk-save.pk: Likewise.
	* poke/pk-scrabble.pk: Likewise.
	* poke/pk-diff.pk: Likewise.
	* pickles/diff.pk: Likewise.

2023-04-24  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/bpf.pk: Do not use "standard" types.
	* pickles/btf.pk: Likewise.
	* pickles/sframe.pk: Likewise.
	* pickles/time.pk: Likewise.
	* pickles/coff.pk: Likewise.
	* pickles/pe.pk: Likewise.
	* pickles/ustar.pk: Likewise.
	* pickles/pktest.pk: Likewise.
	* pickles/redoxfs.pk: Likewise.
	* pickles/ios.pk: Likewise.
	* pickles/argp.pk: Likewise.

2023-04-23  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-attrs.def: New attribute 'ref.
	* libpoke/pkl-typify.c (pkl_typify1_ps_attr): Handle 'ref.
	* libpoke/pkl-anal.c (pkl_anal1_ps_op_attr): Likewise.
	* libpoke/pkl-promo.c (pkl_promo_ps_op_attr): Likewise.
	* libpoke/pkl-gen.c (pkl_gen_ps_op_attr): Likewise.
	* libpoke/pkl-gen-attrs.pks (attr_ref): New macro.
	* doc/poke.texi (Offset Attributes): Document the 'ref attribute.
	* testsuite/poke.pkl/attr-ref-diag-1.pk: New test.
	* testsuite/poke.pkl/attr-ref-diag-2.pk: Likewise.
	* testsuite/poke.pkl/attr-ref-diag-3.pk: Likewise.
	* testsuite/poke.pkl/attr-ref-diag-4.pk: Likewise.
	* testsuite/poke.pkl/attr-ref-1.pk: Likewise.
	* testsuite/poke.pkl/attr-ref-2.pk: Likewise.
	* testsuite/poke.pkl/attr-ref-3.pk: Likewise.
	* testsuite/poke.pkl/attr-ref-4.pk: New test.
	* testsuite/poke.pkl/attr-ref-5.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2023-03-05  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.h (PKL_AST_STRUCT_REF_INDIRECTION_P): Define.
	(struct pkl_ast_struct_ref): New field indirection_p.
	* libpoke/pkl-tab.y: New token IND.
	(primary): New rule for indirecting struct fields.
	* libpoke/pkl-lex.l: Recognize token IND.
	* libpoke/pkl-typify.c (pkl_typify1_ps_struct_ref): Handle
	indirected struct references.
	* libpoke/pkl-trans.c (pkl_trans2_ps_struct_ref): Transform
	indirected struct references into mapping operations.
	* libpoke/pkl-gen.c (pkl_gen_ps_struct_ref): Support indirections.
	(pkl_gen_pr_ass_stmt): Likewise.
	* testsuite/poke.pkl/struct-ind-diag-1.pk: New test.
	* testsuite/poke.pkl/struct-ind-diag-2.pk: Likewise.
	* testsuite/poke.pkl/struct-ind-diag-3.pk: Likewise.
	* testsuite/poke.pkl/struct-ind-diag-4.pk: Likewise.
	* testsuite/poke.pkl/struct-ind-1.pk: Likewise.
	* testsuite/poke.pkl/struct-ind-2.pk: Likewise.
	* testsuite/poke.pkl/struct-ind-3.pk: Likewise.
	* testsuite/poke.pkl/struct-ind-4.pk: Likewise.
	* testsuite/poke.pkl/ass-ind-1.pk: Likewise.
	* testsuite/poke.pkl/ass-ind-2.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2023-02-12  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.h (struct pkl_ast_type): New field ref_type in
	offset types.
	(PKL_AST_TYPE_O_REF_TYPE): Define.
	* libpoke/pkl-ast.c (pkl_ast_make_offset_type): Get a ref_type
	argument.
	(pkl_ast_node_free_1): Free ref_type.
	(pkl_ast_print_1): Print ref_type.
	(pkl_type_append_to): Include ref_type in printed representation.
	(pkl_ast_type_equal_p): Handle referred types.
	* libpoke/pkl-tab.y (ref_type): New rule.
	* libpoke/pkl-typify.c: Pass ref_type argument to calls to
	pkl_ast_make_offset_type.
	* libpoke/pkl-promo.c (promote_offset): Likewise.
	* libpoke/pkl-trans.c: Likewise.
	* libpoke/pkl-promo.c (promote_offset): Handle ref_type.
	(promote_node): Likewise.
	* libpoke/pkl-pass.c (pkl_do_pass_1): Traverse ref_type in offset
	type nodes.
	* libpoke/pkl-lex.l: Likewise.
	* libpoke/pkl-gen.c (pkl_gen_pr_type_offset): Use ref_type.
	* libpoke/pkl-rt.pk (_pkl_print_format_any): Print ref_type in
	offset types.
	* libpoke/pvm-val.h (PVM_VAL_TYP_O_REF_TYPE): Define.
	* libpoke/pvm-val.c (pvm_make_offset_type): Get an argument
	ref_type.
	* libpoke/pvm.jitter (tyosetrt): New instruction.
	(tyogetrt): Likewise.
	* libpoke/pkl-insn.def: New instructions PKL_INSN_TYOSETRT and
	PKL_INSN_TYOGETRT.
	* libpoke/pk-val.c (pk_make_offset_type): Likewise.
	* doc/poke.texi (Offset Types): Document referred types in offset
	types.
	* testsuite/poke.pkl/offset-type-2.pk: New test.
	* testsuite/poke.pkl/print-any-4.pk: Likewise.
	* testsuite/poke.pkl/add-offset-11.pk: Likewise.
	* testsuite/poke.pkl/sub-offsets-9.pk: Likewise.
	* testsuite/poke.pkl/mul-offsets-12.pk: Likewise.
	* testsuite/poke.pkl/div-offsets-5.pk: Likewise.
	* testsuite/poke.pkl/bnot-offsets-2.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2023-02-12  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.h (struct pkl_ast_type): New field ref_type in
	offset types.
	(PKL_AST_TYPE_O_REF_TYPE): Define.
	* libpoke/pkl-ast.c (pkl_ast_make_offset_type): Get a ref_type
	argument.
	(pkl_ast_node_free_1): Free ref_type.
	(pkl_ast_print_1): Print ref_type.
	(pkl_type_append_to): Include ref_type in printed representation.
	(pkl_ast_type_equal_p): Handle referred types.
	* libpoke/pkl-tab.y (ref_type): New rule.
	* libpoke/pkl-typify.c: Pass ref_type argument to calls to
	pkl_ast_make_offset_type.
	* libpoke/pkl-promo.c (promote_offset): Likewise.
	* libpoke/pkl-trans.c: Likewise.
	* libpoke/pkl-promo.c (promote_offset): Handle ref_type.
	(promote_node): Likewise.
	* libpoke/pkl-pass.c (pkl_do_pass_1): Traverse ref_type in offset
	type nodes.
	* libpoke/pkl-lex.l: Likewise.
	* libpoke/pkl-gen.c (pkl_gen_pr_type_offset): Use ref_type.
	* libpoke/pkl-rt.pk (_pkl_print_format_any): Print ref_type in
	offset types.
	* libpoke/pvm-val.h (PVM_VAL_TYP_O_REF_TYPE): Define.
	* libpoke/pvm-val.c (pvm_make_offset_type): Get an argument
	ref_type.
	* libpoke/pvm.jitter (tyosetrt): New instruction.
	(tyogetrt): Likewise.
	* libpoke/pkl-insn.def: New instructions PKL_INSN_TYOSETRT and
	PKL_INSN_TYOGETRT.
	* libpoke/pk-val.c (pk_make_offset_type): Likewise.
	* doc/poke.texi (Offset Types): Document referred types in offset
	types.
	* testsuite/poke.pkl/offset-type-2.pk: New test.
	* testsuite/poke.pkl/print-any-4.pk: Likewise.
	* testsuite/poke.pkl/add-offset-11.pk: Likewise.
	* testsuite/poke.pkl/sub-offsets-9.pk: Likewise.
	* testsuite/poke.pkl/mul-offsets-11.pk: Likewise.
	* testsuite/poke.pkl/div-offsets-5.pk: Likewise.
	* testsuite/poke.pkl/bnot-offsets-2.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2023-04-21  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-tab.y (primary): Remove typification of `format'.
	Remove unnecessary `PKL_AST_LOC' invocations.
	* libpoke/pkl-typify.c (pkl_typify1_ps_format): Typify the `format'.

2023-04-17  Jose E. Marchesi  <jemarch@gnu.org>

	* NEWS: Add entries for 3.1.
	* doc/gendocs_template (For version 3.1): Bump version to 3.1.
	* libpoke/Makefile.am (pvm-vm.h): Remove dependency on $(JITTER).

2023-04-17  Jose E. Marchesi  <jemarch@gnu.org>

	* etc/hacking.org (Continuous Integration): Update.
	* HACKING: Regenerate.

2023-04-13  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* doc/poke.texi (Integral Structs): s/little-endian/big-endian/
	when talking about how gcc encodes bit fields.

2023-03-28  Jose E. Marchesi  <jemarch@gnu.org>

	* etc/poke.rec: Remove priority fields.

2023-03-23  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* common/pk-utils.h (pvm_stof): New declaration.
	(pvm_stod): Likewise.
	* common/pk-utils.c (pvm_stof): Definition of string to `float'
	conversion function.
	(pvm_stod): Definition of string to `double' conversion function.
	* libpoke/pkl-insn.def (PKL_INSN_STOF): New instruction.
	(PKL_INSN_STOD): Likewise.
	* libpoke/pvm.jitter (wrapped-functions): Add `pvm_stof' and
	`pvm_stod'.
	(stof): New instruction to convert string to float32 number
	represented as a `uint<32>'.
	(stod): New instruction to convert string to float64 number
	represented as a `uint<64>'.
	* libpoke/std.pk (stof): New function to wrap `stof' instruction.
	(stod): Likewise.
	* testsuite/poke.pvm/pvm-insns-test.pk (tests): Add entries for
	`stof' and `stod'.
	* testsuite/poke.std/std-test.pk (tests): Likewise.

2023-03-16  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (push32): Fix printers.

2023-03-16  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (pushlo): Remove.
	(pushhi): Likewise.
	(push32): Changed to accept two arguments.
	* libpoke/pvm-program.c (pvm_program_append_push_instruction):
	Adapt accordingly.

2023-03-16  Jose E. Marchesi  <jemarch@gnu.org>

	* etc/poke.rec (Support #foo within string literals): New bug.

2023-03-05  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.c (pkl_gen_pr_cast): Fix memory leak.

2023-03-04  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.c (pkl_gen_ps_type_any): Construct a value 0 for
	values of type `any'.
	* testsuite/poke.pkl/scons-71.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2023-03-04  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-fold.c (OP_BINARY_OIO): Support units 0.
	* testsuite/poke.pkl/mul-offsets-11.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2023-03-03  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* doc/poke.texi (Poking a SBM Image :: Saving the Image): Fix
	the example.

2023-02-27  Frederic Cambus <fred@statdns.com>

	* INSTALL: Remove section about building the GUI.

2023-02-20  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/iscan.pk: New file.
	* pickles/iscan-str.pk: Likewise.
	* pickles/Makefile.am (dist_pickles_DATA): Add iscan.pk and
	iscan-str.pk.
	* testsuite/poke.pickles/iscan-test.pk: New testsuite.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2023-02-20  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter: Use pvm_strcat instead of strcat.

2023-02-20  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-asm.c (pkl_asm_insn_cmp): Support values of type
	any.
	* testsuite/poke.pkl/eq-any-array-3.pk: New test.
	* testsuite/poke.pkl/neq-array-3.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2023-02-19  Bruno Haible  <bruno@clisp.org>

	build: Regenerate pvm-vm.h, pvm-vm1.c, pvm-vm2.c when jitter has changed.
	* libpoke/Makefile.am (generate-vm-files): When cross-compiling, don't
	fail, just emit a warning.
	(pvm-vm.h): Depend also on $(JITTER).

2023-02-19  Bruno Haible  <bruno@clisp.org>

	Allow accessing the installed files in a Cygwin-based mingw environment.
	* bootstrap.conf (gnulib_modules, libpoke_modules): Add configmake.
	* libpoke/Makefile.am (libpoke_la_CPPFLAGS): Don't define PKGDATADIR.
	* libpoke/libpoke.c: Instead, include configmake.h.
	* libpoke/pkl.c: Likewise.
	* poke/Makefile.am (poke_CPPFLAGS): Don't define PKGDATADIR.
	* poke/pk-map.c: Instead, include configmake.h.
	* poke/pk-term.c: Likewise.
	* poke/poke.c: Likewise.
	* poked/Makefile.am (poked_CPPFLAGS): Remove useless -I options. Don't
	define PKGDATADIR. Add -I options to find the common gl/ directories.
	* poked/poked.c: Include configmake.h.
	* testsuite/poke.libpoke/Makefile.am (COMMON_CPPFLAGS): Don't define
	PKGDATADIR.

2023-02-18  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-insn.def (asettb): Remove instruction.
	(tyasetb): New instruction.
	* libpoke/pvm.jitter (asettb): Remove.
	(tyasetb): New instruction to update the array's type bounder.
	* libpoke/pkl-asm.c (pkl_asm_insn_atoa): Use new instruction.
	* libpoke/pkl-asm.pks (array_conv_sel): Likewise.
	(array_conv_siz): Likewise.

2023-02-18  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-asm.c (pkl_asm_insn_atoa): Do not use `PVM_NULL' as
	the bounder in the type of array.  Use a closure that returns
	`PVM_NULL'.
	* testsuite/poke.pkl/cast-array-8.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2023-02-18  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pvm.jitter (wrapped-globals): Remove
	`pvm_literal_inval_obase'.
	(late-c): Likewise.

2023-02-15  Hannes Domani  <ssbssa@yahoo.de>

	* poke/pk-map-lex.l: Rename ERROR to ERR.
	* poke/pk-map-tab.y: Likewise.

2023-02-14  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* common/pk-utils.h (pk_unreachable): New function declaration.
	(PK_UNREACHABLE): Changed the macro to use `pk_unreachable'.
	* common/pk-utils.c (pk_unreachable): New function definition.

2023-02-14  Hannes Domani  <ssbssa@yahoo.de>

	* pickles/pe.pk: Add size_of_stack_reserve.

2023-02-14  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-parser.h (struct pkl_parser): New field `toplevel'.
	* libpoke/pkl-parser.c (pkl_parse_buffer): Set a longjmp return
	point for out-of-memory and other recoverable error conditions.
	(pkl_parse_file): Likewise.
	* libpoke/pkl-lex.l (YY_FATAL_ERROR): Longjump to parser->toplevel
	instead of aborting.

2023-02-14  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen-builtins.pks: Remove.
	* libpoke/Makefile.am (libpoke_la_SOURCES): Update accordingly.
	* libpoke/pkl-ast.h (PKL_AST_BUILTIN_TERM_GET_COLOR): Remove.
	(PKL_AST_BUILTIN_TERM_SET_COLOR): Likewise.
	(PKL_AST_BUILTIN_TERM_GET_BGCOLOR): Likewise.
	(PKL_AST_BUILTIN_TERM_SET_BGCOLOR): Likewise.
	* libpoke/pkl-gen.c (pkl_gen_ps_comp_stmt): Do not handle
	builtins.
	* libpoke/pkl-lex.l: Remove rules for
	__PKL_BUILTIN_TERM_{GET,SET}_[BG]COLOR__ tokens.
	* libpoke/pkl-tab.y (builtin): Remove rule.
	* libpoke/pkl-rt.pk (term_get_color): Rewrite using inline asm.
	(term_get_bgcolor): Likewise.
	(term_set_color): Likewise.
	(term_set_bgcolor): Likewise.

2023-02-14  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.pks (union_deintegrator): Remove unused
	variable.

2023-02-14  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-asm.pks (ais): Rewrite.
	(eqa): Do not revert argument arrays.
	* testsuite/poke.pkl/in-10.pk: New test.
	* testsuite/poke.pkl/in-11.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2023-02-12  Jose E. Marchesi  <jemarch@gnu.org>

	* common/pk-utils.h: Include assert.h.
	* libpoke/libpoke.c: Do not include assert.h.
	* poke/pk-cmd.c: Likewise.
	* poke/pk-ios.c: Likewise.

2023-02-12  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-asm.c (pkl_asm_insn): Remove reference to
	pkl_asm_insn_oto.

2023-02-12  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-insn.def: Remove instruction PKL_INSN_OTO.
	* libpoke/pkl-asm.c (pkl_asm_insn_oto): Remove.
	(pkl_asm_insn): Do not handle PKL_INSN_OTO.
	* libpoke/pkl-asm.pks: Move RAS_MACRO_OFFSET_CAST from here..
	* libpoke/pkl-gen.pks: ... to here.
	* libpoke/pkl-gen.c (pkl_gen_pr_cast): Use RAS_MACRO_OFFSET_CAST.

2023-02-12  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen-attrs.pks (attr_size): Use mkoq.
	(attr_offset): Likewise.
	(attr_eoffset): Likewise.
	(attr_esize): Likewise.
	* libpoke/pkl-gen.pks (emit_tv_field_event): Likewise.
	(struct_mapper): Likewise.
	(struct_constructor): Likewise.
	(struct_field_extractor): Create offset type explicitly.
	(deint_extract_field_value): Likewise.
	(union_deintegrator): Likewise.
	* libpoke/pkl-gen.c (pkl_gen_pr_type_offset): Create offset type
	explicitly.
	(pkl_gen_ps_offset): Likewise.
	(pkl_gen_ps_op_div): Likewise.
	* libpoke/pkl-asm.c (pkl_asm_insn_binop): Use mkoq instead of mko.
	* libpoke/pkl-asm.pks (addo): Likewise.
	(subo): Likewise.
	(mulo): Likewise.
	(modo): Likewise.
	(offset_cast): Likewise.
	* libpoke/pkl-insn.def (PKL_INSN_MKOQ): New instruction.
	* libpoke/pvm.jitter (mkoq): New instruction.

2023-02-12  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm-val.h (PVM_VAL_OFF_UNIT): Remove.
	(PVM_VAL_OFF_BASE_TYPE): Likewise.
	* libpoke/pvm-val.c (pvm_make_offset): Get an offset type as an
	argument.
	(pvm_typeof): Adjust accordingly.
	(pvm_val_equal_p): Likewise.
	(pvm_print_val_1): Likewise.
	* libpoke/pvm.jitter (iosetb): Likewise.
	(ogetu): Likewise.
	(ogetbt): Likewise.
	(iosize): Likewise.
	(iogetb): Likewise.
	* libpoke/pk-val.c (pk_offset_unit): Likewise.
	(pk_val_set_offset): Likewise.
	(pk_make_offset): Likewise.
	(pk_val_offset): Likewise.
	* libpoke/pkl-asm.c (pkl_asm_new): Remove old code involving the
	IO base register.

2023-02-12  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (mktyo): Get the unit of the offset as an
	ulong instead of an int.

2023-02-08  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/btf.pk (BTF_Header): Add constraint to check hdr_len.

2023-02-07  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (PVM_BINOP_SL): Remove macro.
	(bsli): Use PVM_BINOP.
	(bsliu): Likewise.
	(bsll): Likewise.
	(bsllu): Likewise.

	* libpoke/pkl-asm.c (pkl_asm_insn_binop): Check for UB in SL
	instructions and raise exception consequently.

2023-02-07  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (vm_set_obase): Check for valid values.
	(vm_set_omode): Likewise.
	* libpoke/pvm.jitter (popob): Do not raise exceptions.
	(popom): Likewise.

2023-02-07  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-asm.c (pkl_asm_insn_binop): Check for division by
	zero before div and mod.
	* libpoke/pvm.jitter (PVM_CHECKED_BINOP): Remove macro.
	(divi): Do not raise division by zero exception.
	(diviu): Likewise.
	(divl): Likewise.
	(divlu): Likewise.
	(modi): Likewise.
	(modiu): Likewise.
	(modl): Likewise.
	(modlu): Likewise.

2023-02-07  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (PVM_NEG_SIGNED): Do not check for overflow.
	(negi): Remove jitter `branching' annotation, and use PVM_UNOP.
	(negl): Likewise.
	(addi): Likewise.
	(addl): Likewise.
	(subi): Likewise.
	(subl): Likewise.
	(muli): Likewise.
	(mull): Likewise.
	(divi): Likewise.
	(divl): Likewise.
	(modi): Likewise.
	(modl): Likewise.
	(powi): Likewise.
	(powl): Likewise.
	(PVM_NEG_SIGNED): Remove macro.
	(PVM_ADD_SIGNED): Likewise.
	(PVM_SUB_SIGNED): Likewise.
	(PVM_MUL_SIGNED): Likewise.
	(PVM_DIV_SIGNED): Likewise.
	(PVM_MOD_SIGNED): Likewise.
	(PVM_POWOP_SIGNED): Likewise.

2023-02-07  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-asm.c (pkl_asm_insn_binop): Check for signed
	overflow whenever appropriate.
	(pkl_asm_insn): Handle signed overflow macro-instructions.

2023-02-07  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-insn.def (PKL_INSN_NEGOF): New macro-instruction.
	(PKL_INSN_ADDOF): Likewise.
	(PKL_INSN_SUBOF): Likewise.
	(PKL_INSN_MULOF): Likewise.
	(PKL_INSN_DIVOF): Likewise.
	(PKL_INSN_MODOF): Likewise.
	(PKL_INSN_POWOF): Likewise.
	* libpoke/pkl-asm.c (pkl_asm_insn_binop): Add support for integer
	overflow checking instructions.

2023-02-07  Indu Bhagat  <indu.bhagat@oracle.com>

	* pickles/sframe.pk: Use camel casing for types consistently.
	* pickles/sframe-dump.pk: Likewise.

2023-02-07  Indu Bhagat  <indu.bhagat@oracle.com>

	* pickles/sframe.pk: Update the pickle for AArch64 PAuth
	support.

2023-02-07  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (addiof): New instruction.
	(addlof): Likewise.
	(subiof): Likewise.
	(sublof): Likewise.
	(muliof): Likewise.
	(mullof): Likewise.
	(diviof): Likewise.
	(divlof): Likewise.
	(modiof): Likewise.
	(modlof): Likewise.
	(negiof): Likewise.
	(neglof): Likewise.
	(powiof): Likewise.
	(powlof): Likewise.
	* testsuite/poke.pvm/pvm-insns-test.pk (addiof): New test.
	(addlof): Likewise.
	(subiof): Likewise.
	(sublof): Likewise.
	(muliof): Likewise.
	(mullof): Likewise.
	(diviof): Likewise.
	(divlof): Likewise.
	(modiof): Likewise.
	(modlof): Likewise.
	(negiof): Likewise.
	(neglof): Likewise.
	(powiof): Likewise.
	(powlof): Likewise.

2023-02-06  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* pickles/search.pk (search_type): Fix `mapper' invocation.
	* testsuite/poke.pickles/search-test.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2023-02-06  Nikolaos Chatzikonstantinou  <nchatz314@gmail.com>

	* libpoke/std.pk (stoca): Add support for returning the converted
	value.
	* doc/poke.texi (stoca): Update accordingly.
	* testsuite/poke.std/std-test.pk: Add stoca-catos idempotence
	test.

2023-02-06  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/poke.pvm/pvm.exp: New file.
	* testsuite/poke.pvm/vm-insns.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2023-02-06  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm-alloc.c (pvm_alloc_initialize): Do not initialize
	the boehm GC if it has been already initialized.

2023-02-06  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi: Update examples to new semantics of FNAME ==
	EXPR.

2023-02-04  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl.c (pkl_constant_fold): Get an ast argument and avoid
	duplicating ast node uids.
	* libpoke/pkl-gen.pks (aoref): Update call accordingly.

2023-02-04  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.c: Add note to pkl_ast_sizeof_type comment.
	* libpoke/pkl.h: Prototype for pkl_constant_fold.
	* libpoke/pkl.c (pkl_constant_fold): New function.
	* testsuite/poke.pkl/arrays-index-17.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2023-02-04  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.c (pkl_gen_pr_asm_stmt): Emit error whenever
	necessary.
	(pkl_gen_pr_asm_exp): Likewise.

	* libpoke/pvm-program.c (pvm_program_parse_from_string): Return an
	error status in the form of an error message.
	* libpoke/pkl-asm.c (pkl_asm_from_string): Likewise.

2023-02-03  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-tab.y (declaration): improve error message.

2023-02-03  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (The any Type): Document that == and != are
	applicable to values of type `any'.

2023-02-03  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (_pkl_eq_any): Fix comparation for structs.
	* testsuite/poke.pkl/eq-any-union-1.pk: New test.
	* testsuite/poke.pkl/neq-any-union-1.pk: Likewise.
	* testsuite/poke.pkl/eq-any-struct-5.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2023-02-03  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (_pkl_eq_any): Fix typo in assembly template.

2023-02-03  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/ios-dev-stream.c: Include `<assert.h>'.
	(ios_dev_stream_flush): Call `fflush' when user calls `flush'
	on output streams.

2023-02-03  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (_pkl_64x64_128): New function.
	(_pkl_any_integral_p): Likewise.
	(_pkl_eq_integral): Likewise.
	(_pkl_eq_offset): Likewise.
	(_pkl_eq_array): Likewise.
	(_pkl_eq_struct): Likewise.
	(_pkl_eq_any): Likewise.
	* libpoke/pkl-gen.c (pkl_gen_ps_op_rela): Support EQ and NE for
	`any' values.
	(pkl_gen_pr_cast): Do nothing for casts to `any'.
	* libpoke/pkl-typify.c (pkl_typify1_ps_op_rela): Likewise.
	* libpoke/pkl-promo.c (pkl_promo_ps_op_rela): Likewise.
	(promote_to_any): New function.
	* testsuite/poke.pkl/eq-any-diag-1.pk: Remove test.
	* testsuite/poke.pkl/neq-any-diag-1.pk: Likewise.
	* testsuite/poke.pkl/ge-any-diag-1.pk: New test.
	* testsuite/poke.pkl/le-any-diag-1.pk: Likewise.
	* testsuite/poke.pkl/lt-any-diag-1.pk: Likewise.
	* testsuite/poke.pkl/gt-any-diag-1.pk: Likewise.
	* testsuite/poke.pkl/eq-any-integral-1.pk: Likewise.
	* testsuite/poke.pkl/eq-any-integral-2.pk: Likewise.
	* testsuite/poke.pkl/eq-any-integral-3.pk: Likewise.
	* testsuite/poke.pkl/eq-any-integral-4.pk: Likewise.
	* testsuite/poke.pkl/eq-any-offset-1.pk: Likewise.
	* testsuite/poke.pkl/eq-any-offset-2.pk: Likewise.
	* testsuite/poke.pkl/eq-any-offset-3.pk: Likewise.
	* testsuite/poke.pkl/eq-any-offset-4.pk: Likewise.
	* testsuite/poke.pkl/eq-any-offset-5.pk: Likewise.
	* testsuite/poke.pkl/eq-any-offset-6.pk: Likewise.
	* testsuite/poke.pkl/eq-any-offset-7.pk: Likewise.
	* testsuite/poke.pkl/neq-any-offset-1.pk: Likewise.
	* testsuite/poke.pkl/neq-any-offset-2.pk: Likewise.
	* testsuite/poke.pkl/neq-any-offset-3.pk: Likewise.
	* testsuite/poke.pkl/neq-any-offset-4.pk: Likewise.
	* testsuite/poke.pkl/neq-any-offset-5.pk: Likewise.
	* testsuite/poke.pkl/neq-any-offset-6.pk: Likewise.
	* testsuite/poke.pkl/neq-any-offset-7.pk: Likewise.
	* testsuite/poke.pkl/eq-any-array-1.pk: Likewise.
	* testsuite/poke.pkl/eq-any-array-2.pk: Likewise.
	* testsuite/poke.pkl/neq-any-array-1.pk: Likewise.
	* testsuite/poke.pkl/neq-any-array-2.pk: Likewise.
	* testsuite/poke.pkl/eq-any-string-1.pk: Likewise.
	* testsuite/poke.pkl/neq-any-string-1.pk: Likewise.
	* testsuite/poke.pkl/eq-any-struct-1.pk: Likewise.
	* testsuite/poke.pkl/eq-any-struct-2.pk: Likewise.
	* testsuite/poke.pkl/eq-any-struct-3.pk: Likewise.
	* testsuite/poke.pkl/eq-any-struct-4.pk: Likewise.
	* testsuite/poke.pkl/neq-any-struct-1.pk: Likewise.
	* testsuite/poke.pkl/neq-any-struct-2.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2023-02-01  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poked/poked.c: Include `<unistd.h>' for `getuid'.
	(poked_options): Remove const-qualifier from `socket_path'.
	(poked_options_init): Change the default socket path to have
	UID in the path.
	(main): Adapt.

2023-01-31  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poked/usock.c: Include `<sys/stat.h>' for `umask'.
	(usock_new): use `umask' to create the unix
	socket with the right permissions.

2023-01-31  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poked/usock.c (usock_new): use `pipe2' instead of `pipe'.
	do a F_GETFL before F_SETFL to keep the current flags.

2023-01-31  Jose E. Marchesi  <jose.marchesi@oracle.com>

	* poked/poked.c (poked_options_init): Fix getopt_long to recognize
	-S.

2023-02-12  Arsen Arsenović  <arsen@aarsen.me>

	Fix -Wreturn-type warnings on -DNDEBUG
	* common/pk-utils.h (PK_UNREACHABLE): New macro.  Diagnoses
	reaching unreachable code and aborts.
	* libpoke/ios.c: Use PK_UNREACHABLE.
	* libpoke/libpoke.c: Ditto.
	* libpoke/pkl-anal.c: Ditto.
	* libpoke/pkl-asm.c: Ditto.
	* libpoke/pkl-ast.c: Ditto.
	* libpoke/pkl-diag.c: Ditto.
	* libpoke/pkl-env.c: Ditto.
	* libpoke/pkl-fold.c: Ditto.
	* libpoke/pkl-gen.c: Ditto.
	* libpoke/pkl-lex.l: Ditto.
	* libpoke/pkl-parser.c: Ditto.
	* libpoke/pkl-pass.c: Ditto.
	* libpoke/pkl-promo.c: Ditto.
	* libpoke/pkl-tab.y: Ditto.
	* libpoke/pkl-trans.c: Ditto.
	* libpoke/pkl-typify.c: Ditto.
	* libpoke/pkl.c: Ditto.
	* libpoke/pvm-val.c: Ditto.
	* poke/pk-cmd-help.c: Ditto.
	* poke/pk-cmd-set.c: Ditto.
	* poke/pk-cmd-vm.c: Ditto.
	* poke/pk-cmd.c: Ditto.
	* poke/pk-ios.c: Ditto.
	* poke/pk-map-tab.y: Ditto.
	* poke/poke.c: Ditto.

2023-01-31  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/std.pk (Pk_Version): Add control fields.
	(Pk_Version.to_string): New method.
	(Pk_Version._print): Likewise.
	* doc/poke.texi (Version Tools): Reflect new contents of
	Pk_Version.
	* testsuite/poke.std/std-test.pk: Add tests for
	Pk_Version.to_string.

2023-01-31  Arsen Arsenović  <arsen@aarsen.me>

	pk_vercmp: Allow passing and automatically parsing strings
	* libpoke/std.pk (pk_vercmp): Allow passing strings.
	* doc/poke.texi (Version Tools): Document the new flexibility of
	pk_vercmp.

2023-01-31  Arsen Arsenović  <arsen@aarsen.me>

	pk_parse_version: Provide more context on parse failure
	* libpoke/std.pk (raise_exception): New function, takes an
	exception and augments it with more context, to create a new
	exception.  Intended as a helper for errors during parsing.
	(pk_parse_version): Use new raise_exception facility.
	* doc/poke.texi (strtok): Document raise_exception.

2023-01-30  Arsen Arsenović  <arsen@aarsen.me>

	poke.texi: Remedy syntax-check fails
	* doc/poke.texi (strtoi): Remove ``lets''.
	(strtok): Italicize usages of ``i.e.''.

2023-01-30  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-info.pk (pk_info_type): Do not print a header for
	Computed Fields if there are no computed fields.

2023-01-29  Arsen Arsenović  <arsen@aarsen.me>

	std.pk: Implement pk_version_parse, pk_vercmp
	* doc/poke.texi (Other Functions): New node and section.
	Documents miscellaneous functions.
	(Concept Index): Merge the variable index into the concept index.
	(Version Tools): New node.  Documents pk_version,
	pk_version_parse, Pk_Version, pk_vercmp and the version string
	format.
	* libpoke/std.pk (pk_vercmp): New function.  Compares a pair of
	Pk_Version structs.
	(pk_version_parse): New function.  Parses a version string into a
	new Pk_Version struct.
	* testsuite/poke.std/std-test.pk: Add pk_version_parse, pk_vercmp
	tests.
	* autoconf/poke.m4 (PK_PROG_POKE): Update to use pk_vercmp.

2023-01-29  Arsen Arsenović  <arsen@aarsen.me>

	std.pk: Implement strtok
	* doc/poke.texi (strtok): Document the strtok API.
	(String Functions): Add strtok to menu.
	(Concept Index): Merge fn -> cp, as there's not enough use of the
	function index to justify separate section currently.
	* libpoke/std.pk (String_Tokenizer): New type.  Holds the persistent
	state of the strtok-like operation.
	(strtok): New function.  Returns a new String_Tokenizer.
	(String_Tokenizer): New type.  Holds tokenization state.
	* testsuite/poke.std/std-test.pk: Add strtok test.

2023-01-29  Arsen Arsenović  <arsen@aarsen.me>

	std.pk: Refactor atoi into strtoi
	* libpoke/std.pk (Strtoi_Result): New type.  Stores the result of
	a strtoi call.
	(strtoi): New function.  Parses a numeric prefix on a string and
	returns the result and the number of parsed characters.
	(atoi): Refactor to wrap strtoi.
	* doc/poke.texi (strtoi): New node.
	(atoi): Refer to strtoi for a list of bases.
	* testsuite/poke.std/std-test.pk: Add tests for strtoi
	offset-returning semantics.

2023-01-28  Arsen Arsenović  <arsen@aarsen.me>

	std.pk: Implement strrchr
	* libpoke/std.pk (strrchr): New function.  Finds the last
	occurrence of a character in a string and returns its index, or
	-1.
	* doc/poke.texi (strrchr): Document new standard library function.
	(String Functions): Add strrchr to menu, disambiguate menu entries
	of strchr and strrchr.
	* testsuite/poke.std/std-test.pk: Add strrchr test.

2023-01-28  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/std.pk (isdigit): New function.
	(isxdigit): Likewise.
	* testsuite/poke.std/std-test.pk (tests): Add tests for `isdigit'
	and `isxdigit'.
	* doc/poke.texi (The Standard Library): Add doc.

2023-01-28  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (_pkl_print_format_any): Make sure to end
	styling classes before returning.

2023-01-28  Jose E. Marchesi  <jemarch@gnu.org>

	* configure.ac: Use tar-ustar option in Automake.

2023-01-28  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/sframe.pk: Do not load elf.pk.  It is not needed.
	* pickles/elf.pk: Remove.
	* pickles/elf-32.pk: Likewise.
	* pickles/elf-64.pk: Likewise.
	* pickles/elf-common.pk: Likewise.
	* pickles/dwarf.pk: Likewise.
	* pickles/dwarf-common.pk: Likewise.
	* pickles/dwarf-expr.pk: Likewise.
	* pickles/dwarf-frame.pk: Likewise.
	* pickles/dwarf-info.pk: Likewise.
	* pickles/dwarf-pubnames.pk: Likewise.
	* pickles/dwarf-types.pk: Likewise.
	* pickles/README.elf: New file.
	* pickles/README.dwarf: Likewise.
	* pickles/Makefile.am (dist_pickles_DATA): Remove elf pickles.
	(EXTRA_DIST): Distribute README.elf and README.dwarf.
	* testsuite/poke.pickles/elf-test.pk: Remove.
	* testsuite/poke.pickles/dwarf-test.pk: Likewise.
	* testsuite/poke.pickles/ctf-test.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Remove elf-test.pk,
	dwarf-test.pk and ctf-test.pk.
	* doc/poke.texi (Binary Files): Tell how to find the elf pickles.
	(ELF): Likewise.

2023-01-28  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/poke.c (initialize): Fix addition of POKE_LOAD_PATH to
	load_path.

2023-01-28  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/poke.c (initialize): Honor POKE_LOAD_PATH.
	(print_help): Document new env var.
	* doc/poke.texi (Invoking poke): Likewise.

2023-01-28  Jose E. Marchesi  <jemarch@gnu.org>

	* bootstrap.conf (gnulib_modules): Remove obsolete package memcpy.

2023-01-28  Jose E. Marchesi  <jemarch@gnu.org>

	* autoconf/poke.m4 (PK_PROG_POKE): Simplify regexp.

2023-01-28  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-config.pk.in: Make pk_version immutable.

2023-01-27  Arsen Arsenović  <arsen@aarsen.me>

	* run.in (setup to run uninstalled poke): Replace fragile export
	listings with set -a/set +a block.

2023-01-27  Jose E. Marchesi  <jemarch@gnu.org>

	* autoconf/poke.m4: New file.
	* autoconf/Makefile.am: Likewise.
	* libpoke/pkl-config.pk.in: Likewise.
	* run.in (POKECONFIGDIR): Define POKECONFIGDIR.
	* testsuite/Makefile.am (check-DEJAGNU): Likewise.
	* libpoke/pkl.c (pkl_new): Load pkl-config.pk as part of the
	compiler bootstrapping.
	* Makefile.am (SUBDIRS): Add autoconf.
	* configure.ac (AC_CONFIG_FILES): Add autoconf/Makefile.
	Add pkl-config.pk.
	Turn / into _ in poke_branch.
	* libpoke/Makefile.am (dist_pkgdata_DATA): Add pkl-config.pk.

2023-01-27  Arsen Arsenović  <arsen@aarsen.me>

	* configure.ac (poke_branch): Fix grep -q portability issue.
	* .x-sc_two_space_separator_in_usage: New file.  Exclude
	configure.ac.

2023-01-27  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi: Change dircategory to GNU poke.

2023-01-27  Arsen Arsenović  <arsen@aarsen.me>

	* configure.ac: Add git-version-gen reminder.

2023-01-27  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (_pkl_print_format_any): Simplify code.

2023-01-27  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-typify.c (pkl_typify1_ps_decl): Do not validate
	signature of _print* functions, as opposed to methods.
	* testsuite/poke.pkl/struct-types-defun-4.pk: New test.
	* testsuite/poke.pkl/struct-field-pretty-print-diag-1.pk: Fix
	test.
	* testsuite/poke.pkl/struct-field-pretty-print-diag-2.pk: Likewise.
	* testsuite/poke.pkl/struct-pretty-print-diag-1.pk: Likewise.
	* testsuite/poke.pkl/struct-pretty-print-diag-2.pk: Likewise.

2023-01-27  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-typify.c (pkl_typify1_ps_decl): Check field
	pretty-printers.
	* libpoke/pkl-rt.pk (_pkl_print_format_any): Use field
	pretty-printers whenever available.
	* testsuite/poke.pkl/struct-field-pretty-print-diag-1.pk: New
	test.
	* testsuite/poke.pkl/struct-field-pretty-print-diag-2.pk:
	Likewise.
	* testsuite/poke.pkl/struct-field-pretty-print-1.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.
	* doc/poke.texi (Struct Pretty Printers): New section.

2023-01-26  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi: get_time is now gettime.

2023-01-22  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/ios.c (ios_close): Re-use the IOS ID if possible.
	* testsuite/poke.pkl/ios-close-1.pk: New test.
	* testsuite/poke.pkl/ios-close-2.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2023-01-26  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-lex.l (pkl_lex_get_base): Handle 0[Bb] literals
	properly.
	* testsuite/poke.pkl/integers-11.pk: New test.
	* testsuite/poke.pkl/integers-12.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2023-01-25  Jose E. Marchesi  <jemarch@gnu.org>

	* configure.ac: Bump version number to 3.0.
	* NEWS: Likewise.

2023-01-24  Jose E. Marchesi  <jemarch@gnu.org>

	* configure.ac: Bump version number to 2.90.1.
	* NEWS: Likewise.

2023-01-24  Jose E. Marchesi  <jose.marchesi@oracle.com>

	* libpoke/Makefile.am (uninstall-sources): New rule.
	(uninstall-local): Likewise.
	(install-data-local): Likewise.

2023-01-24  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poked/usock.c (usock_new): Don't blindly set FD_CLOEXEC; first
	get the flags, enable the FD_CLOEXEC flag and set new the flag.

2023-01-24  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-rt.pk (get_time): Renamed to `gettime'.
	* pickles/time.pk (gettimeofday): s/get_time/gettime/.
	* testsuite/poke.pkl/get-time-1.pk: Removed.
	* testsuite/poke.pkl/gettime-1.pk: Added.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2023-01-24  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* testsuite/poke.pkl/apop-diag-2.pk: Fixed.
	* testsuite/poke.pkl/apop-diag-3.pk: Likewise.
	* testsuite/poke.pkl/apush-diag-4.pk: Likewise.
	* testsuite/poke.pkl/apush-diag-5.pk: Likewise.

2023-01-23  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-anal.c (pkl_anal2_ps_op_apush_apop): New phase for
	compile-time check of `apush' and `apop' operations on arrays;
	emit compile-time error unless the array is unbounded.
	(pkl_phase_anal2): Add new phases for `PKL_AST_OP_A{PUSH,POP}'.
	* testsuite/poke.pkl/apush-diag-4.pk: New test.
	* testsuite/poke.pkl/apush-diag-5.pk: Likewise.
	* testsuite/poke.pkl/apop-diag-2.pk: Likewise.
	* testsuite/poke.pkl/apop-diag-3.pk: Likewise.
	* testsuite/poke.pkl/apop-1.pk: Adapt.
	* testsuite/poke.pkl/apush-1.pk: Likewise.
	* testsuite/poke.pkl/apush-2.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2023-01-23  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pvm.jitter (time): Change the instruction to push
	SEC and NSEC to the stack (instead of creating an array and
	pushing the array to the stack).
	* libpoke/pkl-rt.pk (get_time): Adapt.
	* testsuite/poke.pkl/get-time-1.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2023-01-23  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-typify.c (pkl_typify1_ps_type_integral): Reject
	`int<1>' as invalid type.
	* testsuite/poke.cmd/sdiff-10.pk: s/int<1>/uint<1>/.
	* testsuite/poke.map/maps-int-structs-6.pk: Likewise.
	* testsuite/poke.map/maps-int-structs-11.pk: Likewise.
	* testsuite/poke.pkl/cast-integers-12.pk: Likewise.
	* testsuite/poke.pkl/eq-integers-5.pk: Likewise.
	* testsuite/poke.pkl/eq-offsets-8.pk: Likewise.
	* testsuite/poke.pkl/mod-offsets-3.pk: Likewise.
	* testsuite/poke.pkl/mod-offsets-4.pk: Likewise.
	* testsuite/poke.pkl/int-type.pk: Remove `int<1>'.
	* testsuite/poke.pkl/int-type-diag-4.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2023-01-23  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poked/poked.c (poked_version): Don't use year range.

2023-01-24  Arsen Arsenović  <arsen@aarsen.me>

	Integrate git-version-gen.
	* etc/hacking.org (Building Release Tarballs): Add some notes
	about how to get correct versioning information.
	* configure.ac: Invoke git-version-gen to compute version value.
	* bootstrap.conf (gnulib_modules): Add git-version-gen.
	* Makefile.am (EXTRA_DIST): Add ``.version''.
	(BUILT_SOURCES): Ditto.
	($(top_srcdir)/.version): store current $(VERSION) value.
	(dist-hook): Store version as .tarball-version.
	* .gitignore: Ignore .version
	* HACKING: Regenerate.

2023-01-23  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (PVM_BINOP_SL): Do not trigger left-shit UB.

2023-01-23  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-fold.c (pkl_phase_fold): Remove duplicated handler
	entry.
	* libpoke/pkl-trans.c (pkl_phase_trans1): Likewise.

2023-01-23  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/ios.c (ios_read_int): Avoid UB in signed left shifts,
	and overflows in unsigned left shifts.
	* libpoke/pvm-val.h (PVM_VAL_INT): Likewise.
	(PVM_MAKE_INT): Likewise.
	(PVM_MAKE_UINT): Likewise.
	(PVM_VAL_LONG): Likewise.
	* libpoke/pvm.jitter (PVM_ADD_SIGNED): Likewise.
	(PVM_SUB_SIGNED): Likewise.
	(PVM_MUL_SIGNED): Likewise.

2023-01-23  Arsen Arsenović  <arsen@aarsen.me>

	* libpoke/pvm.jitter (sleep): Push an error code rather than
	raising an exception.  Do a range check on the passed seconds and
	nanoseconds value, to reconcile differences between platforms.
	* libpoke/pkl-rt.pk (sleep): Translate error codes pushed by the
	sleep instruction into exceptions.

2023-01-23  Arsen Arsenović  <arsen@aarsen.me>

	* doc/poke.texi (Exceptions): Fix typo in the E_no_return
	description (end of a void function -> end of a non-void
	function).

2023-01-23  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (iolist): Use array indexing instead of
	`apush'.

2023-01-23  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/poke.pkl/typeof-struct-2.pk: Likewise.

	* testsuite/poke.pkl/typeof-struct-1.pk: Update test.

	* libpoke/pkl-gen.pks (typeof): Initialize integral_p.

2023-01-22  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/poke.c (pk_print_version): Bump copyright year to 2023 and
	do not use a year range.

2023-01-22  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.pks (typifier_mapper_wrapper): New function.
	(array_typifier): Use typifier_mapper_wrapper.
	(struct_typifier): Likewise.
	* libpoke/pkl-rt.pk (Pk_type): Do not expose ebound and sbound in
	the mapper closure.
	* doc/poke.texi (typeof): Update accordingly.
	* testsuite/poke.pkl/typeof-27.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2023-01-22  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (typeof): New section.

2023-01-22  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.h: Prototype for pkl_asm_struct_type_method_p.
	Prototype for pkl_asm_get_struct_type_field.
	* libpoke/pkl-ast.c (pkl_asm_get_struct_type_method): New
	function.
	(pkl_asm_get_struct_type_field): Likewise.
	* libpoke/pkl-anal.c (pkl_anal2_ps_struct_ref): New handler.
	(pkl_anal2_ps_ass_stmt): Likewise.
	(pkl_phase_anal2): Register handlers.
	* libpoke/pkl-typify.c (pkl_typify1_ps_type_struct): Do no force
	to define getter and setter methods for computer fields.
	* libpoke/pkl-gen.c (pkl_gen_ps_struct_ref): Raise an exception
	when referring to a computed field with no getter.
	(pkl_gen_pr_ass_stmt): Likewise for the setter.
	* testsuite/poke.pkl/sref-diag-3.pk: New test.
	* testsuite/poke.pkl/computed-19.pk: Likewise.
	* testsuite/poke.pkl/computed-diag-5.pk: Remove.
	* testsuite/poke.pkl/computed-diag-6.pk: Likewise.
	* testsuite/poke.pkl/computed-diag-7.pk: Likewise.
	* testsuite/poke.pkl/ass-diag-10.pk: Likewise.

2023-01-22  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/poke.pkl/acons-20.pk: New test.
	* testsuite/poke.pkl/acons-21.pk: Likewise.
	* testsuite/poke.pkl/acons-22.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2023-01-22  Jose E. Marchesi  <jemarch@termi>

	* libpoke/pkl-gen.pks (array_constructor): Support element types
	of size 0 with sbound > 0.
	* testsuite/poke.pkl/acons-15.pk: New test.
	* testsuite/poke.pkl/acons-16.pk: Likewise.
	* testsuite/poke.pkl/acons-17.pk: Likewise.
	* testsuite/poke.pkl/acons-18.pk: Likewise.
	* testsuite/poke.pkl/acons-19.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2023-01-22  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.pks (array_constructor): Get an argument with
	the initial value to put in constructed arrays.
	* libpoke/pkl-gen.c (pkl_gen_pr_type_array): Pass initial value
	to the constructor.
	(pkl_gen_ps_cons): Likewise.

2023-01-22  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-anal.c (pkl_anal1_ps_cons): Constructing non-empty
	arrays of `any' without initial values is not supported.
	* testsuite/poke.pkl/acons-diag-9.pk: New test.
	* testsuite/poke.pkl/acons-diag-10.pk: Likewise.
	* testsuite/poke.pkl/acons-13.pk: Likewise.
	* testsuite/poke.pkl/acons-14.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2023-01-22  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poke/pk-cmd.c (pk_cmd_exec): Add support for `immutable'.

2023-01-21  Jose E. Marchesi  <jemarch@gnu.org>

	* configure.ac: Change version to 2.90.0.
	* NEWS: Add entries for 2.90.0.

2023-01-21  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pvm-val.c (pvm_sizeof): Add case for `PVM_NULL'.
	* libpoke/pvm.jitter (siz): Add a comment describing special
	cases.

2023-01-20  Jose E. Marchesi  <jemarch@gnu.org>

	* configure.ac: Report missing gensub-capable awk at configure
	time.

2023-01-19  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* man/Makefile.am (man_MANS): Add poked.
	(poked.1): New rule to generate man page for poked.

2023-01-19  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* pickles/pdap.pk: New pickle for "PokeD Application Protocol".
	* testsuite/poke.pickles/pdap-test.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2023-01-19  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* doc/poke.texi (poked): Add new chapter.

2023-01-19  Arsen Arsenović  <arsen@aarsen.me>

	* poke/pk-repl.c (space_substitute_display_matches): Force
	redisplay after displaying match list, to match GNU Readline
	behavior.

2023-01-18  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poked/poked.c (VUCMD_*): Re-enumerate the view (vu) commands.
	* poked/poked.pk (plet_vu): Simplify the dump format. We can
	make it more flexible again later.
	(plet_vu_highlight): Simplify array allocation.

2023-01-18  Jose E. Marchesi  <jemarch@gnu.org>

	* cfg.mk (sc_pvm_wrappers): Remove empty lines.

2023-01-18  Jose E. Marchesi  <jemarch@gnu.org>

	* etc/pvm-wraps-whitelist: Add rpl_printf, __stpcpy_chk, memcpy,
	rpl_memcpy and __strcpy_chk.

2023-01-18  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/Makefile.am (libpoke_la_SOURCES): Add pvm-wrappers.c and
	pvm-wrappers.h.
	* libpoke/pvm-wrappers.c: New file.
	* libpoke/pvm-wrappers.h: Likewise.
	* libpoke/pvm.jitter: Move pvm_* wrappers to pvm-wrappers.c.
	* etc/pvm-wraps-whitelist: Remove entries for functions called
	from pvm_* wrappers.
	* etc/pvm-wraps-static-whitelist: Remove functions no longer
	defined in pvm.jitter.

2023-01-18  Jose E. Marchesi  <jemarch@gnu.org>

	* etc/pvm-wraps-whitelist: Add printf and rpl_printf.

2023-01-18  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter: Wrap pvm_free.

2023-01-17  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pvm.jitter (FORMATF): Rename the macro to `PVM_FORMATF'
	and s/memcpy/pvm_memcpy/.
	(formatf32): s/FORMATF/PVM_FORMATF/.
	(formatf64): Likewise.

2023-01-17  Arsen Arsenović  <arsen@aarsen.me>

	* doc/poke.texi (Top): Include the introductory paragraph from
	<https://jemarch.net/poke.html>, and a brief elaboration on the
	contents of the manual.
	* doc/Makefile.am (html-local): Remove outdated workaround for bug
	in older Texinfo versions.

2023-01-17  Jose E. Marchesi  <jemarch@termi>

	* libpoke/pkl-anal.c (pkl_anal_ps_default): Remove handler.
	(pkl_phase_anal1): And do not use it.
	(pkl_phase_anal2): Likewise.

2023-01-16  Arsen Arsenović  <arsen@aarsen.me>

	* cfg.mk (sc_tests_listed_in_makefile_am): Modernize egrep
	invocation into grep -E, as the former was deprecated.

2023-01-14  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (wrapped-functions): Wrap pvm_random,
	pvm_srandom, pvm_gettime and pvm_secure_getenv.
	(pvm_random): New function.
	(pvm_srandom): Likewise.
	(pvm_gettime): Likewise.
	(pvm_secure_getenv): Likewise.
	(rand): Use pvm_srandom, pvm_random and pvm_gettime.
	(time): Use pvm_gettime.
	(getenv): Use pvm_secure_getenv.
	* etc/pvm-wraps-static-whitelist: Add pvm_random, pvm_srandom,
	pvm_gettime and pvm_secure_getenv.
	* etc/pvm-wraps-whitelist: Add random, rpl_random, srandom,
	rpl_srandom, gettime, rpl_gettime, secure_getenv and
	rpl_secure_getenv.

2023-01-14  Jose E. Marchesi  <jemarch@gnu.org>

	* bootstrap.conf (libpoke_modules): Import module vsnprintf-posix.
	* libpoke/pvm.jitter (wrapped-functions): Add pvm_snprintf.
	(pvm_snprintf): New function.
	(FORMATF): Use pvm_snprintf.
	(PVM_FORMATI): Likewise.
	(PVM_FORMATL): Likewise.
	* etc/pvm-wraps-static-whitelist: Add pvm_snprintf.
	* etc/pvm-wraps-whitelist: Add vsnprintf and rpl_vsnprintf.

2023-01-13  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (FORMATF): Use pvm_asprint.
	(wrapped-functions): Add pvm_asprintf.
	(pvm_asprintf): New function.
	* etc/pvm-wraps-static-whitelist: Add pvm_asprintf.
	* etc/pvm-wraps-whitelist: Add asprintf and rpl_asprintf.

2023-01-12  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (pvm_free): New function.
	(formatf32): Use pvm_free.
	(formatf64): Likewise.
	Remove rpl_free from wrapped-functions.
	* etc/pvm-wraps-whitelist: Whitelist rpl_free and free.
	* etc/pvm-wraps-static-whitelist: Whitelist pvm_free.

2023-01-12  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter: Add rpl_free and asprintf to
	wrapped-functions.
	* etc/pvm-wraps-static-whitelist: Add pvm_literal_dispatch_name,
	pvm_literal_formatf_fmt and pvm_literal_formatf_styles.

2023-01-12  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* doc/poke.texi (.vm dispatch): Fix menu.

2023-01-11  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poked/poked.pk (__dots): Renamed to `__poked_dots'.
	(__PokedDotUpdateFunc): Removed.
	(__PokedDotUpdateFuncEntry): Removed.
	(dots): Renamed to `plet_vu_dots'.
	(dot): Renamed to `plet_vu_dot'.
	(dot2): Renamed to `plet_vu_dot2'.
	(dots_set): Renamed to `plet_vu_dots_set'.
	(dot_set_txtcoord): Renamed to `plet_vu_dot_set_txtcoord'.
	(__vu_Args): Renamed to `__Poked_VuArgs'.
	(__vu_do_p): Renamed to `__plet_vu_do_p'.
	(__vu_args): Renamed to `__plet_vu_args'.
	(__vu_filter): Renamed to `__plet_vu_filter'.
	(__vu_dump): Renamed to `__plet_vu_dump'.
	(plet_vu): Adapt.
	(plet_vu_highlight): Adapt.
	(treevu): Remove treevu pokelet code.  Needs more work.
	(__Disasm): Renamed to `__Poked_Disasm'.
	* poked/poked.c (poked_init): Adapt.
	(poked_compile): Likewise.

2023-01-11  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pvm.jitter (wrapped-globals): Add
	pvm_literal_dispatch_name.
	(pvm_literal_dispatch_name): New global constant.
	(vmdisp): New instruction for pushing the name of current
	dispatching strategy to the stack.
	* libpoke/pkl-rt.pk (vm_dispatch): New function.
	* doc/poke.texi (.vm dispatch): Add new subsection.
	* poke/pk-cmd-vm.c (pk_cmd_vm_dispatch): New function.
	(vm_dispatch_cmd): New variable.
	(vm_cmds): Add `vm_dispatch_cmd' command.
	* poke/pk-help.pk (.vm topic): Add `.vm dispatch'.
	* poke/poke.pk (pk_print_vm_dispatch): New function.
	* testsuite/poke.repl/repl.exp (tab-completion-3): Adapt.
	(tab-completion-4): Likewise.
	(tab-completion-6): Likewise.
	(tab-completion-5): New test for tab completion of
	`.vm dispatch'.

2023-01-11  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pvm.jitter (wrapped-globals): Add
	pvm_literal_formatf_{fmt,styles} to the list.
	(pvm_literal_formatf_fmt): Define global variable for wrapping
	format string in `formatf{32,64}' (we cannot directly use string
	literals in advanced modes).
	(pvm_literal_formatf_styles): Likewise.
	(FORMATF): Use new wrapped globals.  Remove % operator.

2023-01-11  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poked/poked.c (poked_version): Add new function to print version
	in GNU style.
	(poked_options_init): Use `poked_version'.
	(poked_help): Make it GNU-compatible.

2023-01-11  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pvm.jitter (formatf32): Add literal parameter to the
	instruction's doc.
	(formatf64): Likewise.

2023-01-11  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* pickles/riscv.pk (RV_Opcode): Remove the re-definition.
	(RV32_OPCODE_*): Change the type from `RV_Opcode' to `uint<7>'.
	(RV32_InsnFmt_I): Adapt.
	(RV32_InsnFmt_S): Likewise.
	(RV32_InsnFmt_B): Likewise.
	(RV32_InsnFmt_U): Likewise.
	(RV32_InsnFmt_J): Likewise.
	(rv32_lui): Likewise.
	(rv32_auipc): Likewise.
	(rv32_jal): Likewise.
	(_rv32_branch): Likewise.
	(rv32_jalr): Likewise.
	(rv32_lb): Likewise.
	(rv32_lh): Likewise.
	(rv32_lw): Likewise.
	(rv32_lbu): Likewise.
	(rv32_lhu): Likewise.
	(rv32_addi): Likewise.
	(rv32_slti): Likewise.
	(rv32_sltiu): Likewise.
	(rv32_xori): Likewise.
	(rv32_ori): Likewise.
	(rv32_andi): Likewise.
	(rv32_slli): Likewise.
	(rv32_srli): Likewise.
	(rv32_srai): Likewise.
	(rv32_fence): Likewise.
	(rv32_ecall): Likewise.
	(rv32_ebreak): Likewise.
	(_rv32_op): Likewise.
	(_rv32_s): Likewise.

2023-01-11  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* pickles/ieee754.pk: New pickle for IEEE 754 floating-point
	numbers based on initial code from apache2.
	* pickles/Makefile.am (dist_pickles_DATA): Add new pickle.
	* testsuite/poke.pickles/ieee754-test.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2023-01-11  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-insn.def (formatf32): Add new instruction.
	(formatf64): Likewise.
	* libpoke/pvm.jitter (FORMATF): New macro for formatting
	floating-point numbers.
	(formatf32): New instruction for formatting floating-point
	numbers.
	(formatf64): Likewise.
	* libpoke/pkl-ast.h (PKL_AST_FORMAT_ARG_FLOATING_POINT_P): New macro.
	(PKL_AST_FORMAT_ARG_FLOATING_POINT_STYLE): Likewise.
	(PKL_AST_FORMAT_ARG_FLOATING_POINT_PREC): Likewise.
	(PKL_AST_FORMAT_ARG_FLOATING_POINT_WIDTH): Likewise.
	(PKL_AST_FORMAT_ARG_FLOATING_POINT_WIDTH_SINGLE): Likewise.
	(PKL_AST_FORMAT_ARG_FLOATING_POINT_WIDTH_DOUBLE): Likewise.
	(struct pkl_ast_format_arg): Add new fields for floating-points.
	* libpoke/pkl-trans.c (pkl_trans1_ps_format): Handle new specifiers
	for floating-point numbers (f, e, g).
	* libpoke/pkl-gen.c (pkl_gen_pr_format): Add support for formatting
	and printing floating-point numbers.
	* doc/poke.texi (Printing): Add new format specifiers to the table.
	* testsuite/poke.pkl/format-43.pk: New test.
	* testsuite/poke.pkl/format-44.pk: Likewise.
	* testsuite/poke.pkl/format-45.pk: Likewise.
	* testsuite/poke.pkl/format-46.pk: Likewise.
	* testsuite/poke.pkl/format-47.pk: Likewise.
	* testsuite/poke.pkl/format-48.pk: Likewise.
	* testsuite/poke.pkl/format-49.pk: Likewise.
	* testsuite/poke.pkl/format-50.pk: Likewise.
	* testsuite/poke.pkl/format-51.pk: Likewise.
	* testsuite/poke.pkl/format-52.pk: Likewise.
	* testsuite/poke.pkl/format-53.pk: Likewise.
	* testsuite/poke.pkl/format-54.pk: Likewise.
	* testsuite/poke.pkl/format-55.pk: Likewise.
	* testsuite/poke.pkl/format-56.pk: Likewise.
	* testsuite/poke.pkl/format-57.pk: Likewise.
	* testsuite/poke.pkl/format-58.pk: Likewise.
	* testsuite/poke.pkl/format-59.pk: Likewise.
	* testsuite/poke.pkl/format-60.pk: Likewise.
	* testsuite/poke.pkl/format-61.pk: Likewise.
	* testsuite/poke.pkl/format-62.pk: Likewise.
	* testsuite/poke.pkl/format-63.pk: Likewise.
	* testsuite/poke.pkl/format-64.pk: Likewise.
	* testsuite/poke.pkl/format-65.pk: Likewise.
	* testsuite/poke.pkl/format-66.pk: Likewise.
	* testsuite/poke.pkl/format-67.pk: Likewise.
	* testsuite/poke.pkl/format-68.pk: Likewise.
	* testsuite/poke.pkl/format-69.pk: Likewise.
	* testsuite/poke.pkl/format-70.pk: Likewise.
	* testsuite/poke.pkl/format-71.pk: Likewise.
	* testsuite/poke.pkl/format-72.pk: Likewise.
	* testsuite/poke.pkl/format-73.pk: Likewise.
	* testsuite/poke.pkl/format-diag-2.pk: Likewise.
	* testsuite/poke.pkl/format-diag-3.pk: Likewise.
	* testsuite/poke.pkl/format-diag-4.pk: Likewise.
	* testsuite/poke.pkl/format-diag-5.pk: Likewise.
	* testsuite/poke.pkl/format-diag-6.pk: Likewise.
	* testsuite/poke.pkl/format-diag-7.pk: Likewise.
	* testsuite/poke.pkl/format-diag-8.pk: Likewise.
	* testsuite/poke.pkl/format-diag-9.pk: Likewise.
	* testsuite/poke.pkl/printf-41.pk: Likewise.
	* testsuite/poke.pkl/printf-42.pk: Likewise.
	* testsuite/poke.pkl/printf-43.pk: Likewise.
	* testsuite/poke.pkl/printf-44.pk: Likewise.
	* testsuite/poke.pkl/printf-45.pk: Likewise.
	* testsuite/poke.pkl/printf-46.pk: Likewise.
	* testsuite/poke.pkl/printf-47.pk: Likewise.
	* testsuite/poke.pkl/printf-48.pk: Likewise.
	* testsuite/poke.pkl/printf-49.pk: Likewise.
	* testsuite/poke.pkl/printf-50.pk: Likewise.
	* testsuite/poke.pkl/printf-51.pk: Likewise.
	* testsuite/poke.pkl/printf-52.pk: Likewise.
	* testsuite/poke.pkl/printf-53.pk: Likewise.
	* testsuite/poke.pkl/printf-54.pk: Likewise.
	* testsuite/poke.pkl/printf-55.pk: Likewise.
	* testsuite/poke.pkl/printf-56.pk: Likewise.
	* testsuite/poke.pkl/printf-57.pk: Likewise.
	* testsuite/poke.pkl/printf-58.pk: Likewise.
	* testsuite/poke.pkl/printf-59.pk: Likewise.
	* testsuite/poke.pkl/printf-60.pk: Likewise.
	* testsuite/poke.pkl/printf-61.pk: Likewise.
	* testsuite/poke.pkl/printf-62.pk: Likewise.
	* testsuite/poke.pkl/printf-63.pk: Likewise.
	* testsuite/poke.pkl/printf-64.pk: Likewise.
	* testsuite/poke.pkl/printf-65.pk: Likewise.
	* testsuite/poke.pkl/printf-66.pk: Likewise.
	* testsuite/poke.pkl/printf-67.pk: Likewise.
	* testsuite/poke.pkl/printf-68.pk: Likewise.
	* testsuite/poke.pkl/printf-69.pk: Likewise.
	* testsuite/poke.pkl/printf-70.pk: Likewise.
	* testsuite/poke.pkl/printf-71.pk: Likewise.
	* testsuite/poke.pkl/printf-diag-19.pk: Likewise.
	* testsuite/poke.pkl/printf-diag-20.pk: Likewise.
	* testsuite/poke.pkl/printf-diag-21.pk: Likewise.
	* testsuite/poke.pkl/printf-diag-22.pk: Likewise.
	* testsuite/poke.pkl/printf-diag-23.pk: Likewise.
	* testsuite/poke.pkl/printf-diag-24.pk: Likewise.
	* testsuite/poke.pkl/printf-diag-25.pk: Likewise.
	* testsuite/poke.pkl/printf-diag-26.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2023-01-11  Jose E. Marchesi  <jemarch@gnu.org>

	* utils/pk-elfextractor.in: Update to new semantics of `in'
	operator.

2023-01-11  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/btf.pk (BTF_KIND_LAST): Define.
	(BTF_Type): Add constraint to info.kind.

2023-01-11  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.c (pkl_ast_print_1): Fix names in
	PRINT_AST_SUBAST.

2023-01-10  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/poke.c (set_script_args): Fix check for -L in argv.

2023-01-08  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (getenv): Avoid calling the `gettenv'
	instruction twice.

2023-01-08  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (_pkl_stroref): Make immutable.
	(_pkl_aoref): Likewise.
	(_pkl_aoref_complete): Likewise.

2023-01-08  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen-builtins.pks (builtin_iohandler): Remove.
	* libpoke/pkl-tab.y (builtin): Remove rule for BUILTIN_IOHANDLER.
	* libpoke/pkl-gen-builtins.pks (builtin_unsafe_string_set): Remove.
	* libpoke/pkl-tab.y (builtin): Remove rule for BUILTIN_UNSAFE_STRING_SET.
	* libpoke/pkl-ast.h (PKL_AST_BUILTIN_GETENV): Remove.
	* libpoke/pkl-gen.c (pkl_gen_ps_comp_stmt): Remove case for
	PKL_AST_BUILTIN_GETENV.
	* libpoke/pkl-lex.l: Remove rule for __PKL_BUILTIN_GETENV__.
	* libpoke/pkl-tab.y (builtin): Remove rule for BUILTIN_GETENV.
	* libpoke/pkl-gen-builtins.pks (builtin_getenv): Remove.
	* libpoke/pkl-rt.pk (getenv): Rewrite as a normal function.

2023-01-08  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/poke.cmd/sdiff-2.pk: Adapt to new value printing.
	* testsuite/poke.cmd/sdiff-3.pk: Likewise.
	* testsuite/poke.cmd/sdiff-4.pk: Likewise.
	* testsuite/poke.cmd/sdiff-8.pk: Likewise.
	* testsuite/poke.cmd/sdiff-1.pk: Run sdiff with :values 0.
	* testsuite/poke.cmd/sdiff-5.pk: Likewise.
	* testsuite/poke.cmd/sdiff-6.pk: Likewise.
	* testsuite/poke.cmd/sdiff-7.pk: Likewise.
	* testsuite/poke.cmd/sdiff-10.pk: Likewise.
	* testsuite/poke.cmd/sdiff-12.pk: Likewise.

2023-01-08  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/diff.pk (format_value): Remove function.
	Use regular `format' for `any' values.

2023-01-08  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.h (PKL_AST_BUILTIN_CLOSE): Remove.
	* libpoke/pkl-gen.c (pkl_gen_ps_comp_stmt): Remove case for
	PKL_AST_BUILTIN_CLOSE.
	* libpoke/pkl-lex.l: Remove rule for __PKL_BUILTIN_CLOSE__.
	* libpoke/pkl-tab.y (builtin): Remove rule for BUILTIN_CLOSE.
	* libpoke/pkl-gen-builtins.pks (builtin_close): Remove.
	* libpoke/pkl-rt.pk (close): Rewrite as a normal function.

2023-01-08  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.h (PKL_AST_BUILTIN_SET_IOS): Remove.
	* libpoke/pkl-gen.c (pkl_gen_ps_comp_stmt): Remove case for
	PKL_AST_BUILTIN_SET_IOS.
	* libpoke/pkl-lex.l: Remove rule for __PKL_BUILTIN_SET_IOS__.
	* libpoke/pkl-tab.y (builtin): Remove rule for BUILTIN_SET_IOS.
	* libpoke/pkl-gen-builtins.pks (builtin_set_ios): Remove.
	* libpoke/pkl-rt.pk (set_ios): Rewrite as a normal function.

2023-01-08  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (_pkl_print_format_any): Simplify inline asm
	snippet.

2023-01-07  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* pickles/pcap.pk (PCAP_Packet): Declare body as a byte array.

2022-12-22  Darshit Shah  <darnir@gnu.org>

	* doc/poke.texi: Simplify Hyperlink setup by calling `make install`

2022-12-10  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.pks (struct_constructor): Emit
	tv_field_constructed event for fields for which there are
	initializers in the constructor.

2022-12-10  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-insn.def: Define oover.
	* libpoke/pvm.jitter (oover): New instruction.
	* libpoke/pkl-rt.pk (PK_TV_FIELD_CONSTRUCTED): Define.
	* libpoke/pkl.h (PK_TV_FIELD_CONSTRUCTED): Likewise.
	* libpoke/pkl-gen.pks (emit_tv_field_event): New macro.
	(struct_field_mapper): Use it.
	(struct_field_constructor): Emit an event for constructed fields.
	(typeof): Eval to PVM_NULL if the requested typeof is for Pk_Type.
	* poke/pk-tracer.pk (pk_tv_action_field_mapped_constructed):
	Rename from pk_tv_action_field_mapped and adapted to handle both
	events.

2022-12-10  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/poke.pkl/scons-constraints-1.pk: Adapt to new
	exception mesage.
	* testsuite/poke.pkl/scons-constraints-2.pk: Likewise.
	* testsuite/poke.pktest/pktest-12.pk: Likewise.

2022-12-10  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.h (struct pkl_ast_struct_type_field): New field
	constraint_src.
	(PKL_AST_STRUCT_TYPE_FIELD_CONSTRAINT_SRC): Define.
	* libpoke/pkl-ast.c (pkl_ast_dup_type): Adapt accordingly.
	(pkl_ast_node_free_1): Likewise.
	* libpoke/pkl-tab.y (struct_type_field): Fill in constraint_src in
	struct field type AST nodes.
	* libpoke/pkl-rt.pk (_pkl_e_constraint_msg): New function.
	* libpoke/pkl-gen.pks (check_struct_field_constraint): Call
	_pkl_e_constraint_msg.
	* testsuite/poke.map/maps-structs-constraints-2.pk: Adapt to new
	message.
	* testsuite/poke.map/maps-structs-constraints-3.pk: Likewise.
	* testsuite/poke.pickles/pcap-test.pk: Likewise.

2022-12-05  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poked/poked.pk (AUTOCMPL_IDENT): Change the value.
	(AUTOCMPL_IOS): Likewise.
	(AUTOCMPL_ITER_BEGIN): New macro.
	(AUTOCMPL_ITER_END): Likewise.
	(poked_autocmpl_send_one): Adapt.
	(poked_autocmpl_send): Send iteration.

2022-12-04  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poked/poked.pk (plet_disasm): Add an assertion for valid
	architectures.

2022-12-04  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poked/poked.c (PDISAS_ITER_BEGIN): New macro.
	(PDISAS_ITER_END): Likewise.
	(PDISAS_ERR): Likewise.
	(PDISAS_TXT): Likewise.
	(PDISAS_KIND): Likewise.
	(termout_disas): New function.
	(poked_disasm_send): Likewise.
	(iteration_send): Add new param (`chan').
	(iteration_begin): Likewise.
	(iteration_end): Likewise.
	(poked_compile): Add support for Poke disasm.
	(main): Update `iteration_begin' and `iteration_end'
	invocation.
	* poked/poked.pk (PLET_DISAS_KIND_FUNC): New const.
	(PLET_DISAS_KIND_FUNC_NATIVE): Likewise.
	(PLET_DISAS_KIND_EXPR): Likewise.
	(PLET_DISAS_KIND_EXPR_NATIVE): Likewise.
	(__Poked_Disas): New type.
	(__poked_disas_data): New variable.
	(__poked_disas_p): Likewise.
	(__poked_disas_reset): New function.
	(plet_disas_func): Likewise.
	(plet_disas_expr): Likewise.

2022-12-04  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poked/poked.c (OUTCMD_TXT): Change the value.
	(OUTCMD_ITER_END): Likewise.
	(OUTCMD_CLS_BEGIN): Likewise.
	(OUTCMD_CLS_END): Likewise.
	(OUTCMD_EVAL): Likewise.
	(OUTCMD_ERR): Likewise.

2022-12-04  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poked/usock.h (usock_out_printf): New function.
	* poked/usock.c (usock_out_printf): Likewise.

2022-12-04  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poked/usock.h (USOCK_CHAN_IN_AUTOCMPL): Remove macro.
	(USOCK_CHAN_OUT_DISASM): Likewise.
	(USOCK_CHAN_OUT_PDISAS): New macro.
	(USOCK_CHAN_OUT_CDISAS): Likewise.
	* poked/poked.pk (plet_disasm): Update the CPU disasm channel.

2022-12-04  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poked/poked.pk (__poked_libpoke_version): New variable.
	(poked_libpoke_version): New function.
	* poked/poked.c (poked_init): Set `__poked_libpoke_version'.

2022-12-04  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poked/poked.c (main): Print PDAP version.
	(poked_init): Add new param (`pdap_version').
	Update `__poked_pdap_version' Poke variable.
	* poked/poked.pk (__poked_pdap_version): New variable.
	(poked_pdap_version): New function.

2022-11-29  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* testsuite/lib/poke-pk.exp (tap_execute): Only keep the filename
	and parent directory name for test files to be consistent with
	the rest.

2022-11-27  Arsen Arsenović  <arsen@aarsen.me>

	* bootstrap: Sync with Gnulib.
	* autopull.sh: New file from Gnulib, as a result of sync.
	* autogen.sh: Ditto.
	* bootstrap-funclib.sh: Ditto.
	* bootstrap.conf (bootstrap_print_option_usage_hook): Fix help
	string alignment.
	(bootstrap_post_import_hook): Default JITTER_SRCDIR to Jitter,
	die-guard cd "${JITTER_SRCDIR}" to prevent recursing, move Jitter
	submodule update code...
	(bootstrap_post_pull_hook): ... to this new hook.
	(bootstrap_option_hook): Export JITTER_SRCDIR.
	* gnulib: Update to newest.

2022-11-24  Arsen Arsenović  <arsen@aarsen.me>

	* poke/poke.c (poke_getopt_string): Extract the getopt string, to
	avoid repetition.
	(parse_args_1): Use common poke_getopt_string, assert out on
	unhandled option, and exit on unknown option.
	(parse_args_2): Use common poke_getopt_string, assert out on
	unhandled option.

2022-11-24  Agathe Porte  <floss@microjoe.org>

	* doc/poke.texi: fix sbm image bytes in example.

2022-11-23  Arsen Arsenović  <arsen@aarsen.me>

	* doc/Makefile.am (poke.text): Make dependencies match other
	Texinfo targets.

2022-11-23  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-lex.l (build_overflow_error_msg): Use PRIu64 instead
	of `lu'.

2022-11-21  Arsen Arsenović  <arsen@aarsen.me>

	* etc/hacking.org (Continuous Integration): Document the
	Sourceware buildbot.
	* HACKING: Regenerate.

2022-11-16  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* pickles/uuid.pk: New pickle.
	* pickles/redoxfs.pk: Likewise.
	* pickles/pcap.pk: Likewise.
	* testsuite/poke.pickles/uuid-test.pk: New test.
	* testsuite/poke.pickles/pcap-test.pk: Likewise.
	* testsuite/poke.pickles/redoxfs-test.pk: Likewise.
	* pickles/Makefile.am (dist_pickles_DATA): Update.
	* testsuite/Makefile.am (EXTRA_DIST): Likewise.

2022-11-16  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-lex.l: Require at least one digit in octal
	constants.
	* testsuite/poke.pkl/integers-diag-3.pk: New test.
	* testsuite/poke.pkl/integers-diag-4.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2022-11-13  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter: Change `map' instruction to not raise
	exceptions.

2022-11-11  Arsen Arsenović  <arsen@aarsen.me>

	* .gitmodules: Upgrade to HTTPS URLs.

2022-11-11  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/poke.map/maps-unions-17.pk: New test.
	* testsuite/poke.map/maps-unions-18.pk: Likewise.
	* testsuite/poke.map/maps-unions-19.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2022-11-11  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.pks (struct_field_extractor): Keep the right
	lexical environment when subpassing results in a constraint
	exception.

2022-11-11  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* etc/vim/syntax/poke.vim (keyword): Add `computed' to the list
	of keywords.

2022-11-10  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (pushios): Modified to not raise exceptions.
	* libpoke/pkl-tab.y: Remove BUILTIN_GET_IOS.
	* libpoke/pkl-rt.pk (get_ios): raise E_io with an explicative
	message if pushios returns < 0.

2022-11-10  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (open): Modified to not raise exceptions.
	* libpoke/pkl-ast.h (PKL_AST_BUILTIN_OPEN): Remove.
	* libpoke/pkl-lex.l: Do not recognize __PKL_BUILTIN_OPEN__.
	* libpoke/pkl-tab.y (builtin): Remove rule for BUILTIN_OPEN.
	* libpoke/pkl-gen-builtins.pks (builtin_open): Remove.
	* libpoke/pkl-gen.c (pkl_gen_ps_comp_stmt): Do not handle
	PKL_AST_BUILTIN_OPEN.
	* libpoke/pkl-rt.pk (open): Handle error status from `open' and
	raise proper exceptions.

2022-11-03  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* pickles/riscv.pk (RV32_Insn): Make it integral union and
	remove `as_uint' method.

2022-11-03  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-gen.pks (struct_mapper): Handle integral unions.
	* testsuite/poke.map/maps-int-union-6.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2022-11-03  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-cmd-misc.c (pk_cmd_jmd): New quote.

2022-11-02  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (_pkl_print_format_any): Fix `lutos' for long
	values.
	* libpoke/std.pk (ltos): Likewise.
	* testsuite/poke.pkl/printf-40.pk: New test.
	* testsuite/poke.std/std-test.pk: Test ltos with i > 2^31.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2022-11-01  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.h (PKL_AST_DECL_PREV_NAME): Define.
	(struct pkl_ast_decl): New field prev_name.
	* libpoke/pkl-ast.c (pkl_ast_node_free_1): Free PREV_NAME.
	(pkl_ast_print_1): Print PREV_NAME.
	* libpoke/pkl-env.h: Prototype for pkl_env_rollback_renames.
	* libpoke/pkl-env.c (pkl_env_rollback_renames_1): New function.
	(pkl_env_rollback_renames): Likewise.
	(register_decl): Cache the previous name used in the decl.
	* libpoke/pkl.c (pkl_compile_expression): Rollback renames in the
	compile-time environment in case of compilation error.
	(pkl_execute_expression): Likewise.
	(pkl_execute_file): Likewise.
	(pkl_execute_statement): Likewise.
	(pkl_execute_buffer): Likewise.

2022-11-01  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-trans.c (pkl_trans2_ps_exp): Do not assume EXP
	expressions will be constant-folded.
	* libpoke/pkl-fold.c (OP_BINARY_III): Add a note regarding the
	workaround in pkl_trans2_ps_exp.
	* testsuite/poke.pkl/pow-folding-workaround.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2022-11-01  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.c (pkl_ast_sizeof_type): Add assertion.

2022-11-01  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-asm.pks (atrim): Fix boundaries checking for empty
	arrays.
	* testsuite/poke.pkl/trim-36.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2022-10-31  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (_pkl_aoref): Array element offsets are
	absolute.
	* testsuite/poke.pkl/arrays-index-15.pk: New test.
	* testsuite/poke.pkl/arrays-index-16.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2022-10-31  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/coff.pk (COFF_Strtab): Make the get_string method
	map-agnostic.

2022-10-31  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-typify.c (pkl_typify1_ps_indexer): Allow offsets as
	indexes in indexers.
	* libpoke/pkl-promo.c (pkl_promo_ps_indexer): Promote offset
	indexes.
	* libpoke/pkl-gen.c (pkl_gen_pr_indexer): Handle offset indexes.
	* libpoke/pkl-gen.pks (aoref): New macro.
	(stroref): Likewise.
	* libpoke/pkl-rt.pk (_pkl_aoref): New function.
	(_pkl_aoref_complete): Likewise.
	* testsuite/poke.pkl/arrays-index-4.pk: New test.
	* testsuite/poke.pkl/arrays-index-5.pk: Likewise.
	* testsuite/poke.pkl/arrays-index-6.pk: Likewise.
	* testsuite/poke.pkl/arrays-index-7.pk: Likewise.
	* testsuite/poke.pkl/arrays-index-8.pk: Likewise.
	* testsuite/poke.pkl/arrays-index-9.pk: Likewise.
	* testsuite/poke.pkl/arrays-index-10.pk: Likewise.
	* testsuite/poke.pkl/arrays-index-11.pk: Likewise.
	* testsuite/poke.pkl/arrays-index-12.pk: Likewise.
	* testsuite/poke.pkl/arrays-index-13.pk: Likewise.
	* testsuite/poke.pkl/arrays-index-14.pk: Likewise.
	* testsuite/poke.pkl/strings-index-3.pk: Likewise.
	* testsuite/poke.pkl/strings-index-4.pk: likewise.
	* testsuite/poke.pkl/strings-index-5.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.
	* doc/poke.texi (Array Indexing): Document indexing by offset.
	(String Indexing): Likewise.

2022-10-30  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-tab.y: Make unary operators take precedence over AS
	and ISA.
	* testsuite/poke.pkl/cast-integers-19.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2022-10-29  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.c (pkl_ast_make_break_stmt): Remove.
	(pkl_ast_make_break_continue_stmt): Renamed from
	pkl_ast_make_continue_stmt.
	(pkl_ast_node_free_1): Adapt accordingly.
	(pkl_ast_print_1): Likewise.
	* libpoke/pkl-ast.h (enum pkl_ast_code): Rename
	PKL_AST_CONTINUE_STMT to PKL_AST_BREAK_CONTINUE_STMT.
	(enum pkl_ast_code): Remove PKL_AST_BREAK_STMT.
	(PKL_AST_CONTINUE_STMT_KIND): Define.
	(struct pkl_ast_break_continue_stmt): Renamed from
	pkL_ast_continue_stmt.
	(PKL_AST_BREAK_CONTINUE_STMT_BREAK): Define.
	(PKL_AST_BREAK_CONTINUE_STMT_CONTINUE): Likewise.
	* libpoke/pkl-tab.y: Adapt to the unified AST node.
	* libpoke/pkl-pass.c (pkl_do_pass_1): Likewise.
	* libpoke/pkl-anal.c: Likewise.
	* libpoke/pkl-trans.c: Likewise.
	* etc/poke.rec (unify `break' and `continue' in the same AST
	node): Removed as DONE.

2022-10-28  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pvm-val.c (pvm_make_array_type): Fix assertion
	for `bounder' to check that if it is a closure.

2022-10-28  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/poke.pk (_pk_bounder_unbounded): New function.
	* poke/poke.c (set_script_args): Install a proper bounder in array
	type.
	* libpoke/libpoke.h: Fix doc string of pk_make_array_type.

2022-10-28  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/poke.std/std-test.pk: Fix with_temp_ios test for
	big-endian.

2022-10-28  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-diag.c (pkl_loc_to_source): Fix memory overrun.

2022-10-27  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pvm-val.c (pvm_make_array_type): Add an assertion
	for `bounder' to make sure it's not NULL.

2022-10-27  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* doc/poke.texi (Describe-Compute): Fix Packet struct to use
	constraint.
	(Commands and Dot-Commands): Use `expression` and `function`
	sub-cmd of `.vm disassemble`.
	(Poking a SBM Image): Fix typo.
	(Signed Weird Integers): Minor fix (s/byte/bit/).
	(How Structs are Built): Fix example.
	(Reserved fields): Likewise.
	(Setters and Getters): Likewise.
	(Loading pickles as Modules): Likewise.
	(Field Constraints): Likewise.
	(mem command): Explain invocation of .mem with no arg.

2022-10-27  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pvm.jitter (mktya): Fix documentation.
	* libpoke/pkl-rt.pk (_Pkl_ClsN): New type.
	(_Pkl_ClsI): Likewise.
	(_Pkl_ClsO): Likewise.
	(_pkl_mkclsn): New function.
	(_pkl_mkclsi): Likewise.
	(_pkl_mkclso): Likewise.

2022-10-27  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-insn.def (isn): Remove instruction because we
	already have the `nnn' instruction.
	* libpoke/pvm.jitter: Likewise.
	* libpoke/pkl-rt.pk (_pkl_print_format_any): Adapt.

2022-10-27  Jose E. Marchesi  <jemarch@gnu.org>

	* etc/hacking.org (How `any' is handed in the PVM): New section.
	* HACKING: Regenerate.

2022-10-27  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-trans.c: Do not include pvm-program.h.

2022-10-27  Arsen Arsenović  <arsen@aarsen.me>

	* bootstrap.conf (libpoke_modules): Add set, xset and
	linkedhash-set.
	* libpoke/pkl-ast.c (pkl_ast_node_free): Allocate a visitation
	set, and move most code...
	(pkl_ast_node_free_1): ... to here, so that we can track and avoid
	freed nodes.  Also, no longer consult IS_RECURSIVE for lifetime
	information.
	* testsuite/poke.pkl/recursion-bad-1.pk: New test.
	* testsuite/poke.pkl/recursion-bad-2.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add the new tests.

2022-10-27  Jose E. Marchesi  <jemarch@gnu.org>

	* etc/poke.rec (Fix %destructors in parser): Removed as DONE.
	(Do not leak decl AST nodes in parser): Likewise.

2022-10-27  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-tab.y (integer): New rule.
	(primary): Use it.
	(integral_type_specifier): Likewise.
	(offset_type_specifier): Likewise.
	* testsuite/poke.pkl/offsets-diag-3.pk: New test.
	* testsuite/poke.pkl/int-type-diag-3.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2022-10-27  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-rt.pk (_pkl_print_format_any): Fix array boundary
	for types.

2022-10-26  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-rt.pk (_pkl_print_format_any): Handle PVM types.

2022-10-26  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-gen-attrs.pks (attr_size): Add `typof' and `nip'
	instructions around `tyis*` instructions.
	(attr_eoffset): Likewise.
	(attr_esize): Likewise.
	(attr_ename): Likewise.
	(attr_elem): Likewise.
	* libpoke/pkl-insn.def (isn): New instruction.
	(isty): Likewise.
	(tyigetsz): Likewise.
	(tyigetsg): Likewise.
	(tyisv): Likewise.
	(tyogetm): Likewise.
	(tyogetu): Likewise.
	(tyagetn): Likewise.
	(tyagett): Likewise.
	(tyagetb): Likewise.
	(tysctgetnf): Likewise.
	(tysctgetfn): Likewise.
	(tysctgetft): Likewise.
	* libpoke/pkl-rt.pk (_pkl_print_format_any): Adapt.
	* libpoke/pvm-val.c (pvm_typeof): Handle closure case (return
	`PVM_NULL' as the type of closure).
	* libpoke/pvm.jitter (isn): New instruction.
	(isty): Likewise.
	(tyigetsz): Likewise.
	(tyigetsg): Likewise.
	(tyisv): Likewise.
	(tyogetm): Likewise.
	(tyogetu): Likewise.
	(tyagetn): Likewise.
	(tyagett): Likewise.
	(tyagetb): Likewise.
	(tysctgetnf): Likewise.
	(tysctgetfn): Likewise.
	(tysctgetft): Likewise.
	(tyisi): Adapt to expect type (not value).
	(tyisiu): Likewise.
	(tyisl): Likewise.
	(tyislu): Likewise.
	(tyiso): Likewise.
	(tyiss): Likewise.
	(tyisa): Likewise.
	(tyisc): Likewise.
	(tyissct): Likewise.

2022-10-26  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-insn.def (iolist): Remove instruction.
	(ionum): New instruction.
	(ioref): Likewise.
	* libpoke/pvm.jitter (iolist): Remove instruction.
	(ionum): New instruction.
	(ioref): Likewise.
	(late-c): Add callback functions to traverse IO space.
	* libpoke/pkl-rt.pk (iolist): Re-write in terms of new
	instructions.

2022-10-26  Jose E. Marchesi  <jemarch@gnu.org>

	* etc/poke.rec (Introduce SELF in methods): Removed as DONE.

2022-10-26  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-tab.y (pushlevel_args): Register a named argument
	"SELF" instead of a dummy.
	* testsuite/poke.pkl/self-1.pk: New test.
	* testsuite/poke.pkl/self-2.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.
	* doc/poke.texi (Methods): Mention the SELF variable.
	(Struct Methods): Likewise.

2022-10-25  Arsen Arsenović  <arsen@aarsen.me>

	* doc/Makefile.am (AM_MAKEINFOFLAGS): Enable the
	`CHECK_NORMAL_MENU_STRUCTURE' flag.
	* doc/poke.texi (Top): Add `Indices' to menu.
	(Indices): Rename from Indicies (i.e. fix a typo).

2022-10-25  Arsen Arsenović  <arsen@aarsen.me>

	* pickles/dwarf-frame.pk: Set CFA constants to `uint<6>'
	explicitly, to avoid `in' type errors.
	* pickles/pe.pk: Set PE_DEBUG_TYPE constants to uint<32>,
	PE_SUBSYS uint<16>, and cast alignemnt_info to uint<32> explicitly
	to avoid `in' type errors.
	* pickles/jffs2.pk: Se various constants to their right type
	explicitly, to avoid `in' type errors.
	* pickles/asn1-ber.pk: Explicitly set BER tags as uint<5>, to
	avoid `in' type errors.
	* pickles/dwarf-expr.pk: Explicitly set `DW_OP' constants to
	uint<8>, to avoid `in' type errors.
	* pickles/ctf.pk: Explicitly set kinds to uint<6>, to avoid `in'
	type errors.
	* pickles/coff-i386.pk: Explicitly set i386 relocation types to
	uint<16>, to avoid `in' type error.
	* pickles/dwarf-info.pk: Explicitly specify type in version
	`constraint', to avoid `in' type error.
	* pickles/elf-64.pk: Cast d_tag to int<32>, to avoid `in' type
	errors.
	* pickles/bpf.pk: Explicitly make instruction classes three-bit
	uints.
	* pickles/bmp.pk: Use unsigned offsets explicitly, to match header
	type.

2022-10-24  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-insn.def (PKL_INSN_TYSCTN): Removed.
	(PKL_INSN_TYSCTGETN): Added (renamed from PKL_INSN_TYSCTN).
	* libpoke/pkl-rt.pk (_pkl_print_format_any): s/tysctn/tysctgetn/.
	* libpoke/pvm.jitter (tysctn): Removed.
	(tysctgetn): Added (renamed from tysctn).

2022-10-24  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pvm.jitter (wrapped-functions): Remove `pvm_make_any_type'.
	(mktyany): Remove instruction.
	* libpoke/pkl-insn.def (PKL_INSN_MKTYANY): Remove instruction.
	* libpoke/pvm.h (pvm_make_any_type): Remove function decl.
	* libpoke/pvm-val.h (enum pvm_type_code): Remove PVM_TYPE_ANY.
	* libpoke/pk-val.c (pk_type_code): Remove case for PVM_TYPE_ANY.
	(pk_make_any_type): Remove function def.
	* libpoke/pkl-gen.c (pkl_gen_ps_type_any): Replace PKL_INSN_MKTYANY
	with PVM_NULL.  And use PVM_NULL as the result of construction.
	* libpoke/pkl.c (pvm_type_to_ast_type): Remove case for PVM_TYPE_ANY.
	* libpoke/pvm-val.c (any_type): Remove variable.
	(pvm_make_any_type): Remove function.
	(pvm_print_val_1): Remove case for PVM_TYPE_ANY.
	(pvm_type_equal_p): Likewise.
	(pvm_val_initialize): Remove `any_type'.
	(pvm_val_finalize): Likewise.
	* libpoke/libpoke.h (PK_TYPE_ANY): Remove macro.
	(PK_TYPE_VOID): Add macro.
	* libpoke/pkl-gen.pks (emit_tv_field_absent): s/mktyany/push null/.
	(struct_field_mapper): Likewise.

2022-10-23  Arsen Arsenović  <arsen@aarsen.me>

        * doc/gen-pvm-insns.sh (SUBSECTIONS): Emit @pvindex calls for
        insns.
        * doc/poke.texi (PVM Instruction Index): New section.
        (Indicies): New appendix.
        (Concept Index): Move under Indicies and number using @appendixsec.

2022-10-23  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/poke.pickles/ustar-test.pk: Likewise.

	* testsuite/poke.pickles/riscv-test.pk: Likewise.

	* testsuite/poke.pickles/pe-test.pk: Likewise.

	* testsuite/poke.pickles/openpgp-test.pk: Likewise.

	* testsuite/poke.pickles/mcr-test.pk: Likewise.

	* testsuite/poke.pickles/leb128-test.pk: Likewise.

	* testsuite/poke.pickles/jffs-test.pk: Likewise.

	* testsuite/poke.pickles/id3v2-test.pk: Likewise.

	* testsuite/poke.pickles/dwarf-test.pk: Likewise.

	* testsuite/poke.pickles/ctf-test.pk: Likewise.

	* testsuite/poke.pickles/coff-test.pk: Likewise.

	* testsuite/poke.pickles/bpf-ext-test.pk: Likewise.

	* testsuite/poke.pickles/bpf-test.pk: Likewise.

	* testsuite/poke.pickles/bmp-test.pk: Likewise.

	* testsuite/poke.pickles/asn1-ber-test.pk: Likewise.

	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

	* testsuite/poke.pickles/elf-test.pk: New file.

2022-10-23  Arsen Arsenović  <arsen@aarsen.me>

        * AUTHORS: Add myself.
        * etc/hacking.org (Write After Approval): Likewise.
        * HACKING: Regenerate.

2022-10-22  Arsen Arsenović  <arsen@aarsen.me>

        * libpoke/pkl-typify.c (pkl_typify1_ps_op_in): Don't allow
        different types between LHS and element of RHS.
        * libpoke/pkl-rt.pk: More strictly specify PK_TYPE_... constants,
        to adhere to new `in' promotion rules.
        * pickles/btf.pk: More strictly specify BTF_KIND_... constants, to
        adhere to new `in' promotion rules.
        * doc/poke.texi (Array Elements): Update documentation to match
        new promotion behavior.
        (Struct Attributes): Update `magic' field constraint to not fail
        due to new promotion rules.
        * testsuite/poke.pkl/in-3.pk: Refactor test to work with new `in'
        promotion rules.
        * testsuite/poke.pkl/in-2.pk: Likewise.
        * testsuite/poke.pkl/in-1.pk: Likewise.
        * testsuite/poke.pkl/field-init-9.pk: Likewise.
        * testsuite/poke.pkl/field-init-12.pk: Likewise.
        * testsuite/poke.pkl/field-init-11.pk: Likewise.
        * testsuite/poke.pkl/field-init-10.pk: Likewise.

2022-10-21  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pvm.jitter (aset): Do not check for ebounds nor sbounds.

2022-10-21  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.c (pkl_gen_pr_cast): In casts from any, make
	sure that the target type has a bounder if it is an array type.
	(pkl_gen_ps_isa): Likewise for `isa' operations.

2022-10-21  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.c (pkl_gen_pr_decl): Install array bounders in
	function types that may need them.
	(pkl_gen_pr_func_type_arg): Install bounders in function type
	argument if necessary.
	(pkl_gen_ps_type_function): Likewise for the return type.

2022-10-20  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-asm.pks (asetc): New macro.
	* libpoke/pkl-gen.c (pkl_gen_pr_type_array): Require a bounder in
	IN_TYPE context.
	(pkl_gen_pr_array): Generate bounder of the type of array
	literals.
	(pkl_gen_pr_ass_stmt): Use ASETC instead of ASET.
	* libpoke/pkl-asm.pks (array_conv_sel): Set closures as array type
	bounders.
	(array_conv_siz): Likewise.
	* libpoke/pkl-fold.c (OP_BINARY_AAA_ADD): Add missing ASTREF.
	* libpoke/pkl-gen.pks (array_mapper): Use IN_TYPE context to get
	the type of the mapped array.
	(array_constructor): Likewise for constructed arrays.
	* libpoke/pkl-insn.def: New macro-instruction PKL_INSN_ASETC.
	* libpoke/pkl-asm.c (pkl_asm_insn_asetc): New function.
	(pkl_asm_insn): Handle PKL_INSN_ASETC.
	* testsuite/poke.pkl/array-bound-1.pk: Update test.
	* testsuite/poke.pkl/array-bound-2.pk: Likewise.
	* testsuite/poke.pkl/array-bound-3.pk: Likewise.
	* testsuite/poke.pkl/array-bound-4.pk: Likewise.
	* testsuite/poke.pkl/array-bound-5.pk: New test.
	* testsuite/poke.pkl/array-bound-6.pk: Likewise.
	* testsuite/poke.pkl/array-bound-7.pk: Likewise.
	* testsuite/poke.map/ass-map-27.pk: Likewise.

2022-10-17  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.c (pkl_gen_pr_asm_stmt): Do not check the result
	of the asm statement for null.
	(pkl_gen_pr_asm_exp): Likewise.
	* testsuite/poke.pkl/asm-exp-5.pk: Remove.
	* testsuite/poke.pkl/asm-stmt-5.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Update accordingly.

2022-10-15  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.pks (array_mapper): Install the sbound in the
	new array type as an offset and not a bit-offset.
	(array_constructor): Likewise, and do not traverse the array type
	IN_TYPE to actually get a bounder.
	* testsuite/poke.pkl/array-bound-1.pk: New test.
	* testsuite/poke.pkl/array-bound-4.pk: Likewise.
	* testsuite/poke.pkl/array-bound-3.pk: Likewise.
	* testsuite/poke.pkl/array-bound-2.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2022-10-14  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* doc/gen-pvm-insns.sh: s/egrep/grep -E/g.

2022-10-14  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-lex.l (integer_literal_width): New function to
	calculate the width of integer literal.
	(integer_literal_overflow_handling): New function to handle
	overflow in integer literals.
	(build_overflow_error_msg): New function to make integer literal
	overflow errors.
	(Alien token rule): Use new functions.
	(Integer literal rule): Likewise.
	* libpoke/pkl-tab.y (%union): Add new field `exception_msg'.
	(INTEGER_OVERFLOW): Remove token.
	(LEXER_EXCEPTION): New token.
	(primary): Use LEXER_EXCEPTION instead of INTEGER_OVERFLOW.
	* testsuite/poke.pkl/array-integ-33.pk: Adapt to new semantics.
	* testsuite/poke.pkl/cdiv-integers-overflow-1.pk: Likewise.
	* testsuite/poke.pkl/cdiv-integers-overflow-diag-2.pk: Likewise.
	* testsuite/poke.pkl/div-integers-overflow-1.pk: Likewise.
	* testsuite/poke.pkl/div-integers-overflow-diag-2.pk: Likewise.
	* testsuite/poke.pkl/mod-integers-overflow-1.pk: Likewise.
	* testsuite/poke.pkl/mod-integers-overflow-diag-2.pk: Likewise.
	* testsuite/poke.pkl/neg-int-overflow-1.pk: Likewise.
	* testsuite/poke.pkl/sub-integers-overflow-1.pk: Likewise.
	* testsuite/poke.pkl/integers-diag-2.pk: Likewise.
	* testsuite/poke.pkl/int-union-28.pk: Likewise.

2022-10-14  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.h (PKL_AST_ASM_STMT_EXPANDED_TEMPLATE): Likewise.
	(PKL_AST_ASM_EXP_EXPANDED_TEMPLATE): Remove.
	* libpoke/pkl-ast.c: Remove expanded_template.
	* libpoke/pkl-trans.c (pkl_trans2_ps_asm_stmt): Remove handler.
	(pkl_trans2_ps_asm_exp): Likewise.
	* libpoke/pkl-asm.c (pkl_asm_from_string): Expand the given
	template before assembling.
	* testsuite/poke.pkl/asm-exp-diag-5.pk: New test.
	* testsuite/poke.pkl/asm-stmt-diag-5.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2022-10-14  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/libpoke.h (PK_PRINT_F_MAPS): Remove.
	(PK_PRINT_F_PPRINT): Likewise.
	(pk_print_val_with_params): Remove function prototype.
	* libpoke/libpoke.c (pk_print_val_with_params): Remove function.
	* testsuite/poke.libpoke/values.c (testcase_pk_val_equal_p): Use
	pk_print_val instead of pk_print_val_with_params.

2022-10-14  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk: Change documentation of TV_FIELD_MAPPED.
	* libpoke/pkl-gen.pks (struct_field_mapper): Do not pass a
	formatted_value to the TV_FIELD_MAPPED tracing event.
	* poke/pk-tracer.pk (pk_tv_action_field_mapped): Do not get a
	formatted_value argument and format the value instead.

2022-10-13  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (Auto-Remapping): New section.
	(@code{vm_autoremap}): Likewise.
	(@code{vm_set_autoremap}): Likewise.

2022-10-13  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ops.def: Define PKL_AST_OP_REMAP.
	* libpoke/pkl-lex.l: Recognize token `remap'.
	* libpoke/pkl-tab.y: New token REMAP.
	(unary_operator): Syntax for the `remap' operator.
	* libpoke/pkl-typify.c (pkl_typify1_ps_op_remap): New handler.
	(pkl_phase_typify1): Register new handler.
	* libpoke/pkl-gen.c (pkl_gen_ps_op_remap): New handler.
	(pkl_phase_gen): Register new handler.
	(pkl_gen_ps_var): Use AREMAP instead of REMAP.
	(pkl_gen_pr_indexer): Likewise.
	(pkl_gen_ps_struct_ref): Likewise.
	* libpoke/pkl-insn.def: New macro-instruction AREMAP.
	* libpoke/pkl-asm.c (pkl_asm_insn_aremap): New function.
	(pkl_asm_insn): Hanlde PKL_INSN_AREMAP.
	* libpoke/pkl-asm.pks (atrim): Use aremap intead of remap.
	* testsuite/poke.map/remap-1.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2022-10-13  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/libpoke.h: Prototypes for pk_autoremap and
	pk_set_autoremap.
	* libpoke/libpoke.c (pk_autoremap): New function.
	(pk_set_autoremap): Likewise.
	* libpoke/pvm.h: Prototypes for pvm_autoremap and
	pvm_set_autoremap.
	* libpoke/pvm.c (pvm_autoremap): New function.
	(pvm_set_autoremap): Likewise.
	* libpoke/pvm.jitter (state-struct-runtime-c): Add field
	`autoremap' to the VM.
	(state-initialization-c): Initialize `autoremap' to the default
	value 0.
	(pusharem): New instruction.
	(poparem): Likewise.
	* libpoke/pkl-rt.pk (vm_autoremap): New function.
	(vm_set_autoremap): Likewise.
	* poke/pk-settings.pk: Add new setting `autoremap'.
	* libpoke/pkl-asm.pks (remap): Acknowledge autoremap.
	* testsuite/poke.cmd/set-autoremap-1.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2022-10-13  Jose E. Marchesi  <jemarch@gnu.org>

	* testsuite/Makefile.am (EXTRA_DIST): Update.

2022-10-13  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-insn.def: Remove PKL_INSN_INDENT.
	* libpoke/pvm.jitter (indent): Remove instruction.

2022-10-13  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.pks (integral_printer): Remove.
	(integral_formater): Likewise.
	(format_int_suffix): Likewise.
	(print_int_suffix): Likewise.
	(indent_if_tree): Likewise.
	* libpoke/pkl-gen.c (pkl_gen_ps_type_integral): Use the any
	printer and formater for integral values.
	* libpoke/pkl-rt.pk (_pkl_format_int_suffix): Remove.

2022-10-12  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.pks (offset_printer): Remove.
	(offset_formater): Likewise.
	(format_boffset): Likewise.
	(print_boffset): Likewise.
	(string_printer): Likewise.
	(string_formater): Likewise.
	* libpoke/pkl-gen.c (pkl_gen_pr_type_offset): Use the any printer
	and formatter for offset values.
	(pkl_gen_ps_type_string): Likewise.

2022-10-12  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (_pkl_print_format_any): Fix handling of
	odepth and of depth.
	(_pkl_print_any): Set default value of depth to 0.
	(_pkl_format_any): Likewise.

2022-10-12  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.h (PKL_AST_TYPE_S_PRINTER): Remove.
	(PKL_AST_TYPE_S_FORMATER): Likewise.
	* libpoke/pkl-ast.c (pkl_ast_make_struct_type): Remove struct
	printers and formatters.
	* libpoke/pkl-gen.c (pkl_gen_pr_decl): Do not compile closures for
	struct printers and formatters.
	(pkl_gen_pr_type_struct): Use the `any' printer/formater for
	struct values.
	* libpoke/pkl-gen.pks (struct_printer): Remove.
	(struct_formater): Likewise.
	(typifier_formater_wrapper): Likewise.
	(struct_typifier): Do not fill in struct formatters/printers.
	* libpoke/pkl-rt.pk: Remove fields `printer' and `formater'.
	(_pkl_indentation): Remove function.
	* testsuite/poke.pkl/format-19.pk: Adapt test.
	* testsuite/poke.pkl/printf-value-15.pk: Likewise.
	* testsuite/poke.pkl/printf-value-12.pk: Likewise.
	* testsuite/poke.pkl/printf-value-11.pk: Likewise.
	* testsuite/poke.pkl/format-28.pk: Likewise.
	* testsuite/poke.pkl/format-20.pk: Likewise.
	* testsuite/poke.pkl/typeof-13.pk: Remove test.
	* testsuite/poke.pkl/typeof-14.pk: Likewise.
	* testsuite/poke.pkl/typeof-15.pk: Likewise.
	* testsuite/poke.pkl/typeof-16.pk: Likewise.
	* testsuite/poke.pkl/typeof-21.pk: Likewise.

2022-10-12  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-rt.pk (_pkl_print_format_any): Fix indentation
	for struct formatter.

2022-10-12  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/libpoke.c (pk_print_val): Use `pk_call' properly.

2022-10-12  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.c (pkl_gen_pr_type_array): Use
	any_printer/formatter instead of array_printer/formatter macros.
	* libpoke/pkl-gen.pks (array_printer): Remove.
	(array_formater): Likewise.

2022-10-12  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.pks (array_formater): Turn into a macro.
	(array_printer): Likewise.
	(array_typifier): Do not fill in `printer' and `formatter' fields.

	* libpoke/pkl-ast.h (PKL_AST_TYPE_A_PRINTER): Remove.
	(PKL_AST_TYPE_A_FORMATER): Likewise.
	* libpoke/pkl-ast.c (pkl_ast_make_array_type): Do not initialize
	A_PRINTER nor A_FORMATER.
	* libpoke/pkl-gen.c (pkl_gen_pr_decl): Remove handling of arrays
	and structs printers and formatters.
	(pkl_gen_pr_type_array): Use macros for printer and formatter.

2022-10-12  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (_pkl_print_format_any): Use `integer' styling
	class.

2022-10-12  Jose E. Marchesi  <jemarch@gnu.org>,

	* libpoke/libpoke.c (pk_print_val): Use _pkl_print_any instead of
	the C printer.
	* testsuite/poke.cmd/maps-alien-1.pk: Expect padded digits and
	prefixes in output integrals.
	* testsuite/poke.pkl/open-sub-6.pk: Likewise.
	* testsuite/poke.pkl/open-sub-9.pk: Likewise.
	* testsuite/poke.pkl/optcond-1.pk: Likewise.
	* testsuite/poke.pkl/optcond-11.pk: Likewise.
	* testsuite/poke.pkl/optcond-2.pk: Likewise.
	* testsuite/poke.pkl/optcond-pre-1.pk: Likewise.
	* testsuite/poke.pkl/optcond-pre-10.pk: Likewise.
	* testsuite/poke.pkl/optcond-pre-2.pk: Likewise.
	* testsuite/poke.pkl/pow-integers-1.pk: Likewise.
	* testsuite/poke.pkl/pow-offsets-1.pk: Likewise.
	* testsuite/poke.pkl/scons-int-struct-1.pk: Likewise.
	* testsuite/poke.pkl/scons-int-struct-2.pk: Likewise.
	* testsuite/poke.pkl/scons-int-struct-3.pk: Likewise.
	* testsuite/poke.pkl/scons-int-struct-5.pk: Likewise.
	* testsuite/poke.pkl/sl-int-struct-2.pk: Likewise.
	* testsuite/poke.pkl/sl-int-struct-1.pk: Likewise.
	* testsuite/poke.pkl/scons-65.pk: Likewise.
	* testsuite/poke.pkl/scons-56.pk: Likewise.
	* testsuite/poke.map/map-struct-offset-5.pk: Likewise.
	* testsuite/poke.map/map-struct-offset-4.pk: Likewise.
	* testsuite/poke.map/map-optcond-int-struct-2.pk: Likewise.
	* testsuite/poke.pkl/sr-int-struct-2.pk: Likewise.
	* testsuite/poke.pkl/sr-int-struct-1.pk: Likewise.
	* testsuite/poke.pkl/sl-offsets-2.pk: Likewise.
	* testsuite/poke.pkl/sl-integers-3.pk: Likewise.
	* testsuite/poke.pkl/sl-integers-2.pk: Likewise.
	* testsuite/poke.pkl/sr-integers-2.pk: Likewise.
	* testsuite/poke.pkl/sr-integers-1.pk: Likewise.
	* testsuite/poke.pkl/sr-offsets-2.pk: Likewise.
	* testsuite/poke.pkl/sr-offsets-1.pk: Likewise.
	* testsuite/poke.pkl/strings-esc-1.pk: Likewise.
	* testsuite/poke.pkl/strings-esc-2.pk: Likewise.
	* testsuite/poke.pkl/struct-pretty-print-2.pk: Likewise.
	* testsuite/poke.pkl/ior-offsets-1.pk: Likewise.
	* testsuite/poke.pkl/ior-integers-1.pk: Likewise.
	* testsuite/poke.pkl/bconc-int-struct-3.pk: Likewise.
	* testsuite/poke.pkl/bconc-int-struct-1.pk: Likewise.
	* testsuite/poke.pkl/or-int-struct-3.pk: Likewise.
	* testsuite/poke.pkl/or-int-struct-2.pk: Likewise.
	* testsuite/poke.pkl/or-int-struct-1.pk: Likewise.
	* testsuite/poke.pkl/int-union-30.pk: Likewise.
	* testsuite/poke.pkl/int-union-29.pk: Likewise.
	* testsuite/poke.pkl/int-union-23.pk: Likewise.
	* testsuite/poke.pkl/int-union-19.pk: Likewise.
	* testsuite/poke.pkl/cast-int-struct-1.pk: Likewise.
	* testsuite/poke.pkl/band-integers-1.pk: Likewise.
	* testsuite/poke.pkl/array-integ-9.pk: Likewise.
	* testsuite/poke.pkl/array-integ-8.pk: Likewise.
	* testsuite/poke.pkl/array-integ-34.pk: Likewise.
	* testsuite/poke.pkl/array-integ-30.pk: likewise.
	* testsuite/poke.pkl/array-integ-29.pk: Likewise.
	* testsuite/poke.pkl/and-int-struct-3.pk: Likewise.
	* testsuite/poke.pkl/and-int-struct-2.pk: Likewise.
	* testsuite/poke.pkl/add-int-struct-4.pk: Likewise.
	* testsuite/poke.pkl/bconc-7.pk: Likewise.
	* testsuite/poke.pkl/bconc-6.pk: Likewise.
	* testsuite/poke.pkl/bconc-5.pk: Likewise.
	* testsuite/poke.pkl/bconc-4.pk: Likewise.
	* testsuite/poke.pkl/bconc-3.pk: Likewise.
	* testsuite/poke.map/maps-int-structs-28.pk: Likewise.
	* testsuite/poke.map/maps-int-structs-27.pk: Likewise.
	* testsuite/poke.map/maps-int-structs-26.pk: Likewsie.
	* testsuite/poke.map/maps-int-structs-25.pk: Likewise.
	* testsuite/poke.map/maps-unions-method-2.pk: Likewise.
	* testsuite/poke.map/maps-uint-write-15.pk: Likewise.
	* testsuite/poke.map/maps-structs-labels-2.pk: Likewise.
	* testsuite/poke.map/maps-structs-labels-1.pk: Likewise.
	* testsuite/poke.map/maps-structs-6.pk: Likewise.
	* testsuite/poke.map/maps-structs-5.pk: Likewise.
	* testsuite/poke.map/maps-structs-2.pk: Likewise.
	* testsuite/poke.map/maps-structs-13.pk: Likewise.
	* testsuite/poke.map/maps-ios-9.pk: Likewise.
	* testsuite/poke.map/maps-ios-7.pk: Likewise.
	* testsuite/poke.map/maps-ios-8.pk: Likewise.
	* testsuite/poke.map/maps-ios-6.pk: Likewise.
	* testsuite/poke.map/maps-ios-5.pk: Likewise.
	* testsuite/poke.map/maps-ios-4.pk: Likewise.
	* testsuite/poke.map/maps-ios-2.pk: Likewise.
	* testsuite/poke.map/map-struct-offset-3.pk: Likewise.
	* testsuite/poke.pkl/pos-int-struct-1.pk: Likewise.
	* testsuite/poke.pkl/not-int-struct-1.pk: Likewise.
	* testsuite/poke.pkl/mul-int-struct-3.pk: Likewise.
	* testsuite/poke.pkl/mul-int-struct-2.pk: Likewise.
	* testsuite/poke.pkl/mul-int-struct-1.pk: Likewise.
	* testsuite/poke.pkl/ior-int-struct-3.pk: Likewise.
	* testsuite/poke.pkl/ior-int-struct-2.pk: Likewise.
	* testsuite/poke.pkl/ior-int-struct-1.pk: Likewise.
	* testsuite/poke.pkl/div-int-struct-3.pk: Likewise.
	* testsuite/poke.pkl/div-int-struct-2.pk: Likewise.
	* testsuite/poke.pkl/div-int-struct-1.pk: Likewise.
	* testsuite/poke.pkl/band-offsets-1.pk: Likewise.
	* testsuite/poke.pkl/band-int-struct-3.pk: Likewise.
	* testsuite/poke.pkl/band-int-struct-2.pk: Likewise.
	* testsuite/poke.pkl/band-int-struct-1.pk: Likewise.
	* testsuite/poke.pkl/and-int-struct-1.pk: Likewise.
	* testsuite/poke.pkl/add-int-struct-3.pk: Likewise.
	* testsuite/poke.pkl/add-int-struct-2.pk: Likewise.
	* testsuite/poke.pkl/add-int-struct-1.pk: Likewise.
	* testsuite/poke.pkl/sub-int-struct-1.pk: Likewise.
	* testsuite/poke.pkl/sub-int-struct-2.pk: Likewise.
	* testsuite/poke.pkl/sub-int-struct-3.pk: Likewise.
	* testsuite/poke.pkl/typeof-25.pk: Likewise.
	* testsuite/poke.pkl/vm-set-obase-1.pk: Likewise.
	* testsuite/poke.pkl/cast-integers-10.pk: Likewise.
	* testsuite/poke.pkl/cast-integers-11.pk: Likewise.
	* testsuite/poke.pkl/xor-integers-2.pk: Likewise.
	* testsuite/poke.pkl/xor-offsets-2.pk: Likewise.
	* testsuite/poke.map/nsmap-6.pk: Likewise.
	* testsuite/poke.map/trimmed-map-2.pk: Likewise.
	* testsuite/poke.map/trimmed-map-3.pk: Likewise.
	* testsuite/poke.map/trimmed-map-4.pk: Likewise.
	* testsuite/poke.map/trimmed-map.pk: Likewise.
	* testsuite/poke.map/unmap-1.pk: Likewise.
	* testsuite/poke.map/write-structs-1.pk: Likewise.
	* testsuite/poke.map/write-unions-2.pk: Likewise.
	* testsuite/poke.map/write-unions-3.pk: Likewise.
	* testsuite/poke.map/maps-int-structs-11.pk: Likewise.
	* testsuite/poke.map/maps-int-49.pk: Likewise.
	* testsuite/poke.map/maps-int-47.pk: Likewise.
	* testsuite/poke.map/maps-int-46.pk: Likewise.
	* testsuite/poke.map/maps-int-44.pk: Likewise.
	* testsuite/poke.map/maps-int-43.pk: Likewise.
	* testsuite/poke.map/maps-int-42.pk: Likewise.
	* testsuite/poke.map/maps-int-40.pk: Likewise.
	* testsuite/poke.map/maps-int-39.pk: Likewise.
	* testsuite/poke.map/maps-int-38.pk: Likewise.
	* testsuite/poke.map/maps-int-36.pk: Likewise.
	* testsuite/poke.map/maps-int-35.pk: Likewise.
	* testsuite/poke.map/maps-int-34.pk: Likewise.
	* testsuite/poke.map/maps-int-32.pk: Likewise.
	* testsuite/poke.map/maps-int-30.pk: Likewise.
	* testsuite/poke.map/maps-int-26.pk: Likewise.
	* testsuite/poke.map/maps-int-24.pk: Likewise.
	* testsuite/poke.map/maps-int-23.pk: Likewise.
	* testsuite/poke.map/maps-int-22.pk: Likewise.
	* testsuite/poke.map/maps-int-21.pk: Likewise.
	* testsuite/poke.map/maps-int-20.pk: Likewise.
	* testsuite/poke.map/maps-int-19.pk: Likewise.
	* testsuite/poke.map/maps-int-18.pk: Likewise.
	* testsuite/poke.map/maps-int-13.pk: Likewise.
	* testsuite/poke.map/maps-int-11.pk: Likewise.
	* testsuite/poke.map/maps-int-09.pk: Likewise.
	* testsuite/poke.map/maps-int-05.pk: Likewise.
	* testsuite/poke.cmd/set-obase-2.pk: Likewise.
	* testsuite/poke.cmd/set-obase-4.pk: Likewise.
	* testsuite/poke.map/ass-map-3.pk: Likewise.
	* testsuite/poke.map/ass-map-9.pk: Likewise.
	* testsuite/poke.map/ass-map-10.pk: Likewise.
	* testsuite/poke.map/ass-map-11.pk: Likewise.
	* testsuite/poke.map/ass-map-14.pk: Likewise.
	* testsuite/poke.map/ass-map-15.pk: Likewise.
	* testsuite/poke.map/ass-map-17.pk: Likewise.
	* testsuite/poke.map/ass-map-19.pk: Likewise.
	* testsuite/poke.map/ass-map-22.pk: Likewise.
	* testsuite/poke.map/ass-map-23.pk: Likewise.
	* testsuite/poke.map/ass-map-24.pk: Likewise.
	* testsuite/poke.map/ass-map-25.pk: Likewise.
	* testsuite/poke.map/map-struct-offset-2.pk: Likewise.
	* testsuite/poke.map/map-struct-fun-3.pk: Likewise.
	* testsuite/poke.map/map-size-3.pk: Likewise.
	* testsuite/poke.map/map-size-2.pk: Likewise.
	* testsuite/poke.map/map-size-1.pk: Likewise.
	* testsuite/poke.map/ass-map-struct-int-1.pk: Likewise.
	* testsuite/poke.map/maps-arrays-20.pk: Likewise.

2022-10-11  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (_pkl_print_format_any): Do not emit negative
	written forms for numeration bases other than 10.

2022-10-11  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (_pkl_print_format_any): Pad digits when
	printing out integral values for bases other than 10.

2022-10-11  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (_pkl_print_format_any): Handle struct
	pretty-printers.

2022-10-11  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (_pkl_print_format_any): Fix assembly template
	for struct_type_name and avoid calling vm_odepth twice.

2022-10-10  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-anal.c (pkl_anal2_ps_asm_stmt): New handler.
	(pkl_anal2_ps_asm_exp): Likewise.
	* libpoke/pkl-anal.c (pkl_phase_anal2): Register new handlers.

2022-10-10  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (_pkl_print_format_any): Use the "special"
	formatting class to print #<...> strings.

2022-10-10  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-insn.def: /PKL_DEF_INSN/s/, /,/g to not make troubles
	for Apple cpp (see IMPORTANT2 note in file).

2022-10-10  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (_pkl_print_any): `depth' defaults to 1.
	(_pkl_format_any): Likewise.
	(_pkl_print_format_any): Support for struct types.

2022-10-10  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (_pkl_print_format_any): Simplify
	handle_integral.

2022-10-10  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (_pkl_print_format_any): Make argument `depth'
	non-optional.
	Use named arguments in calls to handle_integral for sake of
	clarity.

2022-10-10  Jose E. Marchesi  <jemarch@gnu.org>,

	* libpoke/pkl-insn.def (PKL_INSN_TYISI): Define.
	(PKL_INSN_TYISIU): Likewise.
	(PKL_INSN_TYISL): Likewise.
	(PKL_INSN_TYISLU): Likewise.
	(PKL_INSN_TYISS): Likewise.
	(PKL_INSN_TYISO): Likewise.
	* libpoke/pvm.jitter (tyisi): New instruction.
	(tyisiu): Likewise.
	(tyisl): Likewise.
	(tyislu): Likewise.
	(tyiso): Likewise.
	* libpoke/pkl-rt.pk (_Pkl_Print_Format_Ctx): New type.
	(_pkl_print_format_any): New function.
	(_pkl_print_any): Likewise.
	(_pkl_format_any): Likewise.
	* libpoke/pkl-typify.c (pkl_typify1_ps_format): Allow arguments of
	type `any' in format.
	* libpoke/pkl-gen.c (pkl_gen_ps_type_any): Implement printer and
	formatter for values of type `any'.
	* libpoke/pkl-gen.pks (any_printer): New macro.
	(any_formater): Likewise.
	* testsuite/poke.pkl/printf-diag-17.pk: Remove test.
	* testsuite/poke.pkl/print-any-1.pk: New test.
	* testsuite/poke.pkl/print-any-2.pk: Likewise.
	* testsuite/poke.pkl/print-any-3.pk: Likewise.
	* testsuite/poke.pkl/format-any-1.pk: Likewise.
	* testsuite/poke.pkl/format-any-2.pk: Likewise.
	* testsuite/poke.pkl/format-any-3.pk: Likewise.

2022-10-09  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.h (PKL_AST_BUILTIN_RAND): Remove.
	(PKL_AST_BUILTIN_GET_ENDIAN): Likewise.
	(PKL_AST_BUILTIN_SET_ENDIAN): Likewise.
	(PKL_AST_BUILTIN_GET_IOS): Likewise.
	(PKL_AST_BUILTIN_IOSIZE): Likewise.
	(PKL_AST_BUILTIN_GET_TIME): Likewise.
	(PKL_AST_BUILTIN_STRACE): Likewise.
	(PKL_AST_BUILTIN_TERM_BEGIN_CLASS): Likewise.
	(PKL_AST_BUILTIN_TERM_END_CLASS): Likewise.
	(PKL_AST_BUILTIN_TERM_BEGIN_HYPERLINK): Likewise.
	(PKL_AST_BUILTIN_TERM_END_HYPERLINK): Likewise.
	(PKL_AST_BUILTIN_IOFLAGS): Likewise.
	(PKL_AST_BUILTIN_SLEEP): Likewise.
	(PKL_AST_BUILTIN_VM_OBASE): Likewise.
	(PKL_AST_BUILTIN_VM_SET_OBASE): Likewise.
	(PKL_AST_BUILTIN_VM_OPPRINT): Likewise.
	(PKL_AST_BUILTIN_VM_SET_OPPRINT): Likewise.
	(PKL_AST_BUILTIN_VM_OACUTOFF): Likewise.
	(PKL_AST_BUILTIN_VM_SET_OACUTOFF): Likewise.
	(PKL_AST_BUILTIN_VM_ODEPTH): Likewise.
	(PKL_AST_BUILTIN_VM_SET_ODEPTH): Likewise.
	(PKL_AST_BUILTIN_VM_OINDENT): Likewise.
	(PKL_AST_BUILTIN_VM_SET_OINDENT): Likewise.
	(PKL_AST_BUILTIN_VM_OMAPS): Likewise.
	(PKL_AST_BUILTIN_VM_SET_OMAPS): Likewise.
	(PKL_AST_BUILTIN_VM_OMODE): Likewise.
	(PKL_AST_BUILTIN_VM_SET_OMODE): Likewise.
	(PKL_AST_BUILTIN_UNSAFE_STRING_SET): Likewise.
	(PKL_AST_BUILTIN_IOHANDLER): Likewise.
	(PKL_AST_BUILTIN_IOLIST): Likewise.
	* libpoke/pkl-gen-builtins.pks (builtin_rand): Remove.
	(builtin_get_endian): Likewise.
	(builtin_set_endian): Likewise.
	(builtin_get_ios): Likewise.
	(builtin_iosize): Likewise.
	(builtin_ioflags): Likewise.
	(builtin_iobias): Likewise.
	(builtin_iolist): Likewise.
	(builtin_iosetbias): Likewise.
	(builtin_flush): Likewise.
	(builtin_get_time): Likewise.
	(builtin_sleep): Likewise.
	(builtin_strace): Likewise.
	(builtin_term_begin_class): Likewise.
	(builtin_term_end_class): Likewise.
	(builtin_term_begin_hyperlink): Likewise.
	(builtin_term_end_hyperlink): Likewise.
	(builtin_vm_obase): Likewise.
	(builtin_vm_set_obase): Likewise.
	(builtin_vm_opprint): Likewise.
	(builtin_vm_set_opprint): Likewise.
	(builtin_vm_oacutoff): Likewise.
	(builtin_vm_set_oacutoff): Likewise.
	(builtin_vm_odepth): Likewise.
	(builtin_vm_set_odepth): Likewise.
	(builtin_vm_oindent): Likewise.
	(builtin_vm_set_oindent): Likewise.
	(builtin_vm_omaps): Likewise.
	(builtin_vm_set_omaps): Likewise.
	(builtin_vm_omode): Likewise.
	(builtin_vm_set_omode): Likewise.
	(builtin_unsafe_string_set): Likewise.
	* libpoke/pkl-rt.pk (rand): Reimplement with inlined asm.
	(get_endian): Likewise.
	(set_endian): Likewise.
	(get_ios): Likewise.
	(set_ios): Likewise.
	(iosize): Likewise.
	(iohandler): Likewise.
	(ioflags): Likewise.
	(iobias): Likewise.
	(iosetbias): Likewise.
	(flush): Likewise.
	(get_time): Likewise.
	(sleep): Likewise.
	(strace): Likewise.
	(term_begin_class): Likewise.
	(term_end_class): Likewise.
	(term_begin_hyperlink): Likewise.
	(term_end_hypelink): Likewise.
	(vm_obase): Likewise.
	(vm_set_obase): Likewise.
	(vm_opprint): Likewise.
	(vm_set_opprint): Likewise.
	(vm_oacutoff): Likewise.
	(vm_set_oacutoff): Likewise.
	(vm_odepth): Likewise.
	(vm_set_odepth): Likewise.
	(vm_oindent): Likewise.
	(vm_set_oindent): Likewise.
	(vm_omaps): Likewise.
	(vm_set_omaps): Likewise.
	(vm_omode): Likewise.
	(vm_set_omode): Likewise.
	(__pkl_unsafe_string_set): Likewise.
	* libpoke/pkl-gen.c (pkl_gen_ps_comp_stmt): Remove builtins now
	implemented with asm statements.
	* libpoke/pkl-tab.y (builtin): Adjust rule accordingly.
	* libpoke/pkl-lex.l: Remove rules for builtins.

2022-10-08  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-tab.y: New token ASM.
	Rule for ASM statements and expressions.
	* libpoke/pkl-lex.l: Recognize token ASM.
	* libpoke/pkl-ast.h (PKL_AST_ASM_STMT_TEMPLATE): Define.
	(PKL_AST_ASM_STMT_INPUTS): Likewise.
	(PKL_AST_ASM_STMT_OUTPUTS): Likewise.
	(PKL_AST_ASM_STMT_EXPANDED_TEMPLATE): Likewise.
	(PKL_AST_ASM_EXP_TEMPLATE): Likewise.
	(PKL_AST_ASM_EXP_TYPE): Likewise.
	(PKL_AST_ASM_EXP_INPUTS): Likewise.
	(PKL_AST_ASM_EXP_EXPANDED_TEMPLATE): Likewise.
	(struct pkl_ast_asm_stmt): New struct.
	(struct pkl_ast_asm_exp): Likewise.
	(union pkl_ast_node): New fields asm_exp and asm_stmt.
	* libpoke/pkl-ast.c (pkl_ast_make_asm_stmt): New function.
	(pkl_ast_make_asm_exp): Likewise.
	(pkl_ast_node_free): Handle asm statement and expression nodes.
	(pkl_ast_print_1): Likewise.
	(pkl_ast_make_ass_stmt): Allow building ass_stmt AST nodes without
	r-value.
	* libpoke/pkl-pass.c (pkl_do_pass_1): Traverse asm statement and
	asm expression nodes.
	(pkl_do_pass_1): `exp' may be NULL in ass_stmt.
	* libpoke/pkl-trans.c (pkl_trans1_ps_asm_stmt): New handler.
	(pkl_trans2_ps_asm_stmt): Likewise.
	(pkl_trans2_ps_asm_exp): Likewise.
	(pkl_phase_trans1): Register handler.
	(pkl_phase_trans2): Register handlers.
	* libpoke/pkl-typify.c	(pkl_typify1_ps_asm_stmt): New handler.
	(pkl_typify1_ps_asm_exp): Likewise.
	(pkl_phase_typify1): Register new handlers.
	(pkl_typify1_ps_ass_stmt): `exp' may be NULL.
	* libpoke/pkl-promo.c (pkl_promo_ps_ass_stmt): Do not promote
	anything if `exp' is NULL.
	* libpoke/pkl-gen.c (pkl_gen_pr_asm_exp): New handler.
	(pkl_gen_pr_asm_stmt): Likewise.
	(pkl_phase_gen): Register handlers.
	(pkl_gen_pr_ass_stmt): Do not subpass in EXP if it is null.
	* libpoke/pkl-asm.c (pkl_asm_from_string): New function.
	* libpoke/pvm-program.h: Prototype for pvm_program_parse_from_string.
	* libpoke/pvm-program.c (pvm_program_parse_from_string): New function.
	* libpoke/pkl-rt.pk: New exception E_stack.
	* libpoke/libpoke.h (PK_EC_STACK): Define.
	* libpoke/pvm.h (PVM_E_STACK): Likewise.
	(PVM_E_STACK_NAME): Likewise.
	(PVM_E_STACK_ESTATUS): Likewise.
	* testsuite/poke.pkl/asm-stmt-diag-1.pk: New test.
	* testsuite/poke.pkl/asm-stmt-diag-2.pk: Likewise.
	* testsuite/poke.pkl/asm-stmt-diag-3.pk: Likewise.
	* testsuite/poke.pkl/asm-stmt-diag-4.pk: Likewise.
	* testsuite/poke.pkl/asm-exp-diag-1.pk: Likewise.
	* testsuite/poke.pkl/asm-exp-diag-2.pk: Likewise.
	* testsuite/poke.pkl/asm-exp-diag-3.pk: Likewise.
	* testsuite/poke.pkl/asm-exp-diag-4.pk: Likewise.
	* testsuite/poke.pkl/asm-exp-1.pk: Likewise.
	* testsuite/poke.pkl/asm-exp-2.pk: Likewise.
	* testsuite/poke.pkl/asm-exp-3.pk: Likewise.
	* testsuite/poke.pkl/asm-exp-4.pk: Likewise.
	* testsuite/poke.pkl/asm-exp-5.pk: Likewise.
	* testsuite/poke.pkl/asm-stmt-1.pk: Likewise.
	* testsuite/poke.pkl/asm-stmt-2.pk: Likewise.
	* testsuite/poke.pkl/asm-stmt-3.pk: Likewise.
	* testsuite/poke.pkl/asm-stmt-4.pk: Likewise.
	* testsuite/poke.pkl/asm-stmt-5.pk: Likewise.
	* testsuite/poke.pkl/asm-stmt-6.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.
	* doc/poke.texi (Assembler): New chapter.

2022-10-06  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-tracer.pk (pk_tv_action_field_mapped): Get a Pk_Type as
	the second argument of the event.
	* libpoke/pkl-gen.pks (struct_field_mapper): Pass the Pk_Type of
	the field type to the TV_FIELD_MAPPED event.

2022-10-06  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.c (pkl_gen_pr_op_typeof): Move logic to the
	typeof RAS macro, and use the macro.
	* libpoke/pkl-gen.pks (typeof): New macro.

2022-10-06  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/pe.pk (PE_File): Fix the location of the sections table.

2022-10-05  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/coff.pk (COFF_Name): Add pretty-printer.
	* pickles/pe.pk (PE_File): Map the symtab by size.
	(PE_Sym): Fix definition.

2022-10-05  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.pks (struct_formater): Support formatting absent
	fields in structs.
	* testsuite/poke.pkl/format-optcond-1.pk: New test.
	* testsuite/poke.pkl/format-optcond-2.pk: Likewise.
	* testsuite/poke.pkl/foramt-optcond-3.pk: Likewise.
	* testsuite/poke.pkl/format-optcond-4.pk: Likewise.
	* testsuite/poke.pkl/format-optcond-5.pk: Likewise.
	* testsuite/poke.pkl/format-optcond-6.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2022-10-05  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-tab.y: (struct_type_field_opcond_pre): New rule.
	(struct_type_field_optcond_post): Likewise.
	* libpoke/pkl-ast.h (PKL_AST_STRUCT_TYPE_FIELD_OPTCOND_PRE): New macro.
	(PKL_AST_STRUCT_TYPE_FIELD_OPTCOND_POST): Renamed from OPTCOND.
	(struct pkl_ast_struct_type_field): New field optcond_pre and
	optcond renamed to optcond_post.
	* libpoke/pkl-ast.c (pkl_ast_make_struct_type_field): Handle both
	optcond_pre and optcond_post.
	(pkl_ast_dup_type): Likewise.
	(pkl_ast_sizeof_type): Likewise.
	(pkl_ast_type_is_complete): Likewise.
	(pkl_ast_node_free): Likewise.
	(pkl_ast_print_1): Likewise.
	* libpoke/pkl-anal.c (pkl_anal2_ps_type_struct): Support both
	optcond_pre and optcond_post.
	* libpoke/pkl-pass.c (pkl_do_pass_1): Likewise.
	* libpoke/pkl-promo.c (pkl_promo_ps_struct_type_field): Likewise.
	* libpoke/pkl-typify.c (pkl_typify1_ps_struct): Likewise.
	(pkl_typify1_ps_type_struct): Likewise.
	* libpoke/pvm-val.c (pvm_print_val_1): Do not print offset for
	absent fields in omaps.
	* libpoke/pkl-gen.pks (handle_struct_field_constraints): Likewise.
	(struct_comparator): Likewise.
	(struct_field_mapper): Likewise.
	* testsuite/poke.pkl/optcond-pre-diag-1.pk: New test.
	* testsuite/poke.pkl/optcond-pre-diag-2.pk: Likewise.
	* testsuite/poke.map/map-optcond-pre-1.pk: Likewise.
	* testsuite/poke.map/map-optcond-pre-2.pk: Likewise.
	* testsuite/poke.map/map-optcond-pre-3.pk: Likewise.
	* testsuite/poke.map/map-optcond-pre-4.pk: Likewise.
	* testsuite/poke.map/map-optcond-pre-5.pk: Likewise.
	* testsuite/poke.map/map-optcond-pre-6.pk: Likewise.
	* testsuite/poke.map/map-optcond-pre-7.pk: Likewise.
	* testsuite/poke.map/map-optcond-pre-8.pk: Likewise.
	* testsuite/poke.map/map-optcond-pre-9.pk: Likewise.
	* testsuite/poke.map/map-optcond-pre-10.pk: Likewise.
	* testsuite/poke.map/map-optcond-pre-11.pk: Likewise.
	* testsuite/poke.map/map-optcond-pre-12.pk: Likewise.
	* testsuite/poke.map/map-optcond-pre-write-1.pk: Likewise.
	* testsuite/poke.map/map-optcond-pre-write-2.pk: Likewise.
	* testsuite/poke.pkl/optcond-pre-1.pk: Likewise.
	* testsuite/poke.pkl/optcond-pre-2.pk: Likewise.
	* testsuite/poke.pkl/optcond-pre-3.pk: Likewise.
	* testsuite/poke.pkl/optcond-pre-4.pk: Likewise.
	* testsuite/poke.pkl/optcond-pre-5.pk: Likewise.
	* testsuite/poke.pkl/optcond-pre-6.pk: Likewise.
	* testsuite/poke.pkl/optcond-pre-7.pk: Likewise.
	* testsuite/poke.pkl/optcond-pre-8.pk: Likewise.
	* testsuite/poke.pkl/optcond-pre-9.pk: Likewise.
	* testsuite/poke.pkl/optcond-pre-10.pk: Likewise.
	* testsuite/poke.pkl/optcond-pre-11.pk: Likewise.
	* testsuite/poke.pkl/optcond-pre-12.pk: Likewise.
	* testsuite/poke.map/map-optcond-write-1.pk: Renamed from
	map-opcond-write-1.pk.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.
	* doc/poke.texi (Pretty-printers): Use prefix optional field
	conditions.
	(Optional Fields): Rewrite to document both prefix and suffix
	conditional expressions in optional fields.
	* pickles/pe.pk: Adapted to use pre conditional expressions.
	* pickles/elf-64.pk: Likewise.
	* pickles/elf-32.pk: Likewise.
	* pickles/btf-ext.pk: Likewise.
	* pickles/coff.pk: Likewise.
	* pickles/id3v2.pk: Likewise.
	* pickles/jffs2.pk: Likewise.
	* pickles/openpgp.pk: Likewise.

2022-10-04  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/pe-arm64.pk (PE_ARM64_Reloc): New type.
	* pickles/pe.pk (PE_Reloc): Use ARM64 relocs.
	(PE_Opt_Hdr): data_start only exists if not PE32+.

2022-10-04  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (PK_TV_FIELD_ABSENT): Define.
	(PK_TV_NUM_EVENTS): Adjust.
	* libpoke/pkl.h (PK_TV_FIELD_ABSENT): Define.
	* libpoke/pkl-gen.pks (handle_struct_field_constraints): Generate
	a PK_TV_FIELD_ABSENT event whenever necessary.
	(struct_constructor): Likewise.
	* poke/pk-tracer.pk (pk_tv_action_field_absent): New function.

2022-10-04  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.pks (struct_field_mapper): Handle anonymous
	fields in PK_TV_FIELD_MAPPED events.
	* poke/pk-tracer.pk (pk_tv_action_field_mapped): Print <anonymous>
	for empty field names.

2022-10-04  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk: Note that PK_TV_FIELD_MAPPED is generated
	before constraints are checked.
	* libpoke/pkl-gen.pks (struct_field_mapper): Adjust accordingly.

2022-10-04  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.pks (struct_field_mapper): Force flat omode when
	formatting values for PK_TV_FIELD_MAPPED events.

2022-10-04  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/pe.pk (PE_Opt_Hdr): Fix the constraint for
	file_alignment.

2022-10-03  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (PK_TV_FIELD_CONSTRAINT_FAILED): New variable.
	(PK_TV_NUM_EVENTS): Update.
	* libpoke/pkl.h (PK_TV_FIELD_CONSTRAINT_FAILED): Define.

2022-10-03  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk (pk_tracer_p): New variable.
	(PK_TV_FIELD_MAPPED): Likewise.
	(PK_TV_NUM_EVENTS): Likewise.
	(Pk_Tracer_Action): New type.
	(Pk_Tracer_Dispatch_Table): Likewise.
	(pk_tracer_dispatch): New variable.
	* libpoke/pkl.h: Prototype for pkl_tracer_p.
	(PK_TV_FIELD_MAPPED): Define.
	* libpoke/pkl.c (pkl_tracer_p): New function.
	* libpoke/ras: Support referring to tracing events with PK_TV_*.
	* libpoke/pkl-gen.pks (struct_field_mapper): Generate
	PK_TV_FIELD_MAPPED.
	* poke/pk-tracer.pk: New file.
	* poke/poke.pk: Load pk-tracer.pk.
	* poke/pk-settings.pk: Add setting for tracer.
	* poke/Makefile.am (dist_app_DATA): Add pk-tracer.pk.

2022-10-03  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/pe.pk (PE_Load_Configuration_Layout): New type.
	(PE_GUARD_*): New variables.

2022-10-03  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-diag.h: Prototype for pkl_loc_to_source.
	* libpoke/pkl-diag.c (pkl_loc_to_source): New function.
	* libpoke/pkl-tab.y (pkl_make_assertion): Call pkl_loc_to_source.
	* pickles/pe.pk: Use asserts without explicit message.
	* pickles/color.pk: Likewise.
	* pickles/asn1-ber.pk: Likewise.
	* pickles/mcr.pk: Likewise.
	* pickles/rgb24.pk: Likewise.
	* testsuite/poke.pkl/assert-6.pk: New test.
	* testsuite/poke.pkl/assert-7.pk: Likewise.
	* testsuite/poke.pktest/pktest-11.pk: Adapt test.
	* testsuite/poke.pktest/pktest-7.pk: Likewise.
	* testsuite/poke.pktest/pktest-5.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.
	* doc/poke.texi (assert): Document new behavior.

2022-10-03  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/pe-debug.pk: New file.
	* pickles/pe.pk (PE_Debug_Directory_Entry): New type.
	Load pe-debug.pk.
	(PE_Name): New method match_p.
	* pickles/Makefile.am (dist_pickles_DATA): Add pe-debug.pk and
	pe-riscv.pk.

2022-10-03  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/pe.pk: Load architecture-specific PE parts.
	* pickles/coff.pk (COFF_LINENO): New type.
	(COFF_Shdr): Use COFF_LINENO instead of COFF_LINENO_16.
	(COFF_Sym): e_scnum is signed.
	(COFF_N_ABS): Make negative.
	(COFF_N_DEBUG): Likewise.
	* pickles/coff-pe.pk: Remove file.
	* pickles/pe-i386.pk: New file.
	* pickles/pe-ia64.pk: Likewise.
	* pickles/pe-mips.pk: Likewise.
	* pickles/pe-amd64.pk: Likewise.
	* pickles/pe-arm.pk: Likewise.
	* pickles/pe-arm64.pk: Likewise.
	* pickles/pe-sh3.pk: Likewise.
	* pickles/pe-ppc.pk: Likewise.
	* pickles/pe-m32r.pk: Likewise.
	* pickles/Makefile.am (dist_pickles_DATA): Add new pickles.

2022-10-02  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/coff-pe.pk: New file.
	* pickles/Makefile.am (dist_pickles_DATA): Add coff-pe.pk.
	* pickles/coff.pk (COFF_RELOC): Add alternative for PE/COFF
	relocations.

2022-10-02  Jose E. Marchesi  <jemarch@gnu.org>

	* Makefile.am: Add missing file header.
	* pickles/Makefile.am: Likewise.
	* maps/Makefile.am: Likewise.

2022-10-02  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/pe.pk: New file.
	* pickles/coff.pk: Remove 64-bit optional header, which is
	actually the PE one.
	* pickles/Makefile.am (dist_pickles_DATA): Add pe.pk

2022-10-01  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/coff.pk: New file.
	* pickles/coff-i386.pk: Likewise.
	* pickles/coff-aarch64.pk: Likewise.
	* pickles/Makefile.am (dist_pickles_DATA): Add new pickles.

2022-09-30  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (Field Labels): Expand with an additional example.

2022-09-30  Jose E. Marchesi  <jemarch@gnu.org>

	* etc/hacking.org (Writing REPL tests): Fix typo.
	(General REPL tests): Fix ordering.
	(Command REPL tests): Likewise.
	(PVM values in AST nodes): Update to new implementation.

2022-09-26  Jose E. Marchesi  <jemarch@gnu.org>

	* etc/poke.rec (Support bit-concatenation in l-value): Removed as
	done.
	(Union integrators and deintegrators): Likewise.

2022-09-26  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.h (struct pkl_ast_comp_stmt): New field
	frameless_p.
	(PKL_AST_COMP_STMT_FRAMELESS_P): Define.
	* libpoke/pkl-gen.c (pkl_gen_pr_comp_stmt): Do not generate a
	pushf for frameless compound statements.
	(pkl_gen_ps_comp_stmt): Likewise for popf.
	* libpoke/pkl-ast.h: Prototype for pkl_ast_handle_bconc_ass_stmt.
	* libpoke/pkl-ast.c (pkl_ast_handle_bconc_ass_stmt): New function.
	* libpoke/pkl-trans.c (pkl_trans2_pr_ass_stmt): New rule.
	(pkl_phase_trans2): Register new rule.
	* libpoke/pkl-typify.c (pkl_typify1_ps_ass_stmt): Check the width
	of r-values assigned to bconc expressions.
	* testsuite/poke.pkl/bconc-lvalue-diag-1.pk: New test.
	* testsuite/poke.pkl/bconc-lvalue-diag-2.pk: Likewise.
	* testsuite/poke.pkl/bconc-lvalue-1.pk: Likewise.
	* testsuite/poke.pkl/bconc-lvalue-2.pk: Likewise.
	* testsuite/poke.pkl/bconc-lvalue-3.pk: Likewise.
	* testsuite/poke.pkl/bconc-lvalue-4.pk: Likewise.
	* testsuite/poke.pkl/bconc-lvalue-5.pk: Likewise.
	* testsuite/poke.pkl/bconc-lvalue-6.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.
	* doc/poke.texi (Bit Assignments): New section.

2022-09-26  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* pickles/riscv.pk (RV32_InsnFmt_S): Add computed field `imm'
	(hence add `set_imm' method).
	(RV32_InsnFmt_B): Likewise.
	(RV32_InsnFmt_J): Likewise.
	(RV32_InsnFmt_U): s/imm/imm31_12/. Add computed field `imm'
	(hence add `set_imm' method).
	(RV32_InsnFmt_I): s/imm/imm11_0/. Add computed field `imm'
	(hence add `set_imm' method).
	(_rv32_i): s/imm/imm11_0/.
	(_rv32_u): s/imm/imm31_12/.

2022-09-26  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-tab.y (tokens): s/token/%token/.
	* libpoke/pkl-typify.c (pkl_typify1_ps_cast): Handle integral
	unions.
	(pkl_typify1_ps_type_struct): Likewise.
	* libpoke/pkl-gen.c (pkl_gen_pr_type_struct): Likewise.
	(pkl_gen_pr_decl): Likewise.
	(pkl_gen_pr_cast): In cast from an integral type to struct type,
	add a cast to ITYPE of the struct.
	* libpoke/pkl-gen.pks (RAS_FUNCTION_UNION_INTEGRATOR): New function.
	(RAS_FUNCTION_UNION_DEINTEGRATOR): Likewise.
	(RAS_FUNCTION_STRUCT_INTEGRATOR): Add assertion.
	(RAS_FUNCTION_STRUCT_DEINTEGRATOR): Likewise.
	* doc/poke.texi (Integral Unions): Add new section.
	* testsuite/poke.pkl/int-union-1.pk: New test.
	* testsuite/poke.pkl/int-union-2.pk: Likewise.
	* testsuite/poke.pkl/int-union-3.pk: Likewise.
	* testsuite/poke.pkl/int-union-4.pk: Likewise.
	* testsuite/poke.pkl/int-union-5.pk: Likewise.
	* testsuite/poke.pkl/int-union-6.pk: Likewise.
	* testsuite/poke.pkl/int-union-7.pk: Likewise.
	* testsuite/poke.pkl/int-union-8.pk: Likewise.
	* testsuite/poke.pkl/int-union-9.pk: Likewise.
	* testsuite/poke.pkl/int-union-10.pk: Likewise.
	* testsuite/poke.pkl/int-union-11.pk: Likewise.
	* testsuite/poke.pkl/int-union-12.pk: Likewise.
	* testsuite/poke.pkl/int-union-13.pk: Likewise.
	* testsuite/poke.pkl/int-union-14.pk: Likewise.
	* testsuite/poke.pkl/int-union-15.pk: Likewise.
	* testsuite/poke.pkl/int-union-16.pk: Likewise.
	* testsuite/poke.pkl/int-union-17.pk: Likewise.
	* testsuite/poke.pkl/int-union-18.pk: Likewise.
	* testsuite/poke.pkl/int-union-19.pk: Likewise.
	* testsuite/poke.pkl/int-union-20.pk: Likewise.
	* testsuite/poke.pkl/int-union-21.pk: Likewise.
	* testsuite/poke.pkl/int-union-22.pk: Likewise.
	* testsuite/poke.pkl/int-union-23.pk: Likewise.
	* testsuite/poke.pkl/int-union-24.pk: Likewise.
	* testsuite/poke.pkl/int-union-25.pk: Likewise.
	* testsuite/poke.pkl/int-union-26.pk: Likewise.
	* testsuite/poke.pkl/int-union-27.pk: Likewise.
	* testsuite/poke.pkl/int-union-28.pk: Likewise.
	* testsuite/poke.pkl/int-union-29.pk: Likewise.
	* testsuite/poke.pkl/int-union-30.pk: Likewise.
	* testsuite/poke.pkl/int-union-type-diag-1.pk: Likewise.
	* testsuite/poke.pkl/int-union-type-diag-2.pk: Likewise.
	* testsuite/poke.pkl/int-union-type-diag-3.pk: Likewise.
	* testsuite/poke.pkl/int-union-type-diag-4.pk: Likewise.
	* testsuite/poke.pkl/int-union-type-diag-5.pk: Likewise.
	* testsuite/poke.pkl/int-union-type-diag-6.pk: Likewise.
	* testsuite/poke.pkl/int-union-type-diag-7.pk: Likewise.
	* testsuite/poke.pkl/int-union-type-diag-8.pk: Likewise.
	* testsuite/poke.pkl/int-union-type-diag-9.pk: Likewise.
	* testsuite/poke.pkl/int-union-type-diag-10.pk: Likewise.
	* testsuite/poke.pkl/int-union-type-diag-11.pk: Likewise.
	* testsuite/poke.pkl/int-union-type-diag-12.pk: Likewise.
	* testsuite/poke.pkl/int-union-type-diag-13.pk: Likewise.
	* testsuite/poke.pkl/int-union-type-diag-14.pk: Likewise.
	* testsuite/poke.pkl/int-union-type-diag-15.pk: Likewise.
	* testsuite/poke.pkl/int-union-type-diag-16.pk: Likewise.
	* testsuite/poke.pkl/int-union-type-diag-17.pk: Likewise.
	* testsuite/poke.pkl/int-union-type-diag-18.pk: Likewise.
	* testsuite/poke.map/maps-int-union-1.pk: Likewise
	* testsuite/poke.map/maps-int-union-2.pk: Likewise
	* testsuite/poke.map/maps-int-union-3.pk: Likewise
	* testsuite/poke.map/maps-int-union-4.pk: Likewise
	* testsuite/poke.map/maps-int-union-5.pk: Likewise
	* testsuite/poke.pkl/int-struct-type-diag-3.pk: Adapted.
	* testsuite/poke.pkl/int-struct-type-diag-4.pk: Likewise.
	* testsuite/poke.pkl/int-struct-type-diag-5.pk: Likewise.
	* testsuite/poke.pkl/int-struct-type-diag-11.pk: Likewise.
	* testsuite/poke.pkl/int-struct-type-diag-16.pk: Removed.
	* testsuite/poke.pkl/int-struct-type-diag-17.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2022-09-26  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-gen.pks (function struct_constructor): Do not alter
	items that are already on the stack because `raise' will restore
	the height of stack and the caller will see garbage on the stack.
	(function struct_deintegrator): Likewise.

2022-09-25  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-rt.pk: Do not set the CWD to load_path here.
	* poke/poke.pk: Do it here instead.

2022-09-24  Arsen Arsenović   <arsen@aarsen.me>

	* poke/poke.c: Prefer $XDG_CONFIG_HOME to $XDG_CONFIG_DIRS, even
	when unset.

2022-09-24  Jose E. Marchesi  <jemarch@gnu.org>

	BZ 27481
	* etc/hacking.org: Fix spelling mistakes.
	* NEWS: Likewise.
	* ChangeLog: Likewise.
	* doc/poke.texi: Likewise.
	* etc/parse-valgrind-suppressions.sh: Likewise.
	* etc/poke.rec: Likewise.
	* libpoke/ios.h: Likewise.
	* libpoke/pkl-gen.pks: Likewise.
	* libpoke/pkl-trans.c: Likewise.
	* libpoke/pkl-gen-builtins.pks: Likewise.
	* libpoke/pkl-promo.c: Likewise.
	* libpoke/pkl-asm.pks: Likewise.
	* libpoke/std.pk: Likewise.
	* libpoke/ios-dev-stream.c: Likewise.
	* libpoke/ras: Likewise.
	* libpoke/pvm.h: Likewise.
	* libpoke/pkl-gen.h: Likewise.
	* libpoke/pkl-anal.c: Likewise.
	* libpoke/pkl-typify.c: Likewise.
	* libpoke/ios-buffer.c: Likewise.
	* libpoke/pkl-fold.c: Likewise.
	* libpoke/ios-dev-mem.c: Likewise.
	* libpoke/pkl-tab.y: Likewise.
	* libpoke/pkl-ast.h: Likewise.
	* libpoke/pvm.jitter: Likewise.
	* libpoke/pkl-gen.c: Likewise.
	* libpoke/pvm-val.c: Likewise.
	* libpoke/ios.c: Likewise.
	* libpoke/pvm-val.h: Likewise.
	* libpoke/pkl.c: Likewise.
	* pickles/elf-common.pk: Likewise.
	* pickles/asn1-ber.pk: Likewise.
	* pickles/ios.pk: Likewise.
	* pickles/dwarf-pubnames.pk: Likewise.
	* pickles/jffs2.pk: Likewise.
	* poke/pk-cmd-ios.c: Likewise.
	* poke/pk-settings.pk: Likewise.
	* poke/poke.pk: Likewise.
	* poke/pk-map-parser.h: Likewise.
	* poke/poke.c: Likewise.
	* poke/pk-cmd-editor.c: Likewise.
	* poke/pk-help.pk: Likewise.
	* testsuite/poke.repl/repl.exp: Likewise.
	* testsuite/poke.std/std.exp: Likewise.
	* HACKING: Regenerate.

2022-09-24  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-typify.c (pkl_typify1_ps_cast): Do not allow casts
	to unions.
	* testsuite/poke.pkl/cast-union-diag-1.pk: New test.
	* testsuite/poke.pkl/cast-union-diag-2.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.
	* doc/poke.texi (Casting Structs): Note that casts to unions are
	not allowed.

2022-09-23  Jose E. Marchesi  <jemarch@gnu.org>

	* etc/poke.rec (with_temp_ios): Removed as DONE.
	(casts from integral to array and from array to integral):
	Likewise.
	(Support for offline method definitions): New enhancement.

2022-09-22  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/ios.pk: Do not use standard types.

2022-09-22  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/pk-table.pk: Do not use standard types.

2022-09-22  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/mbr.pk (MBR_CHS): Add computed field `cylinder'.
	* testsuite/poke.pickles/mbr-test.pk: Adapt accordingly.

2022-09-22  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/id3v1.pk: Convert to use computed fields.
	* testsuite/poke.pickles/id3v1-test.pk: Adapted accordingly.

2022-09-22  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-lex.l: Recognize token COMPUTED.
	* libpoke/pkl-ast.h (PKL_AST_STRUCT_TYPE_FIELD_COMPUTED_P): Define.
	(struct pkl_ast_struct_type_field): New field computed_p.
	(struct pkl_ast_type): New field `ncfield' for struct types.
	(PKL_AST_TYPE_S_NCFIELD): Define.
	* libpoke/pkl-ast.c (pkl_ast_print_1): Print the computed_p
	attribute of struct type fields.
	(pkl_ast_sizeof_type): Do not count computed fields for the size
	of the struct.
	(pkl_ast_dup_type): Duplicate computed flag in struct type fields.
	(pkl_ast_type_mappable_p): Do not include computed fields in
	determining whether a struct type is mappable.
	(pkl_ast_type_is_complete): Do not include computed fields in
	determining whether a struct type is complete.
	(pkl_ast_type_is_complete): Likewise for union types.
	(pkl_type_append_to): Append `computed' for computed fields in
	type descriptors.
	* libpoke/pkl-tab.y: New token COMPUTED.
	(struct_type_computed_field): New rule.
	(struct_type_elem_list): Add struct_type_computed_field as an
	alternative.
	* libpoke/pkl-anal.c (pkl_anal2_ps_type_struct): adapt to computed
	fields.
	* libpoke/pkl-trans.c (pkl_trans1_ps_type_struct): Do not include
	computed fields in the nfield count and initialize ncfield.
	* libpoke/pkl-typify.c (pkl_typify1_ps_type_struct): Check methods
	for computed fields.
	(pkl_typify1_ps_cons): Do not allow specifying computed fields in
	struct constructors.
	* libpoke/pkl-gen.c (pkl_gen_pr_ass_stmt): Handle computed fields.
	(pkl_gen_ps_struct_ref): Likewise.
	(pkl_gen_pr_struct_type_field): Do not include computed fields in
	PVM struct types.
	* libpoke/pkl-gen.pks (struct_constructor): Do not construct
	computed fields.
	(struct_mapper): Likewise.
	(struct_writer): Likewise.
	(struct_integrator): Likewise.
	(struct_deintegrator): Likewise.
	(union_comparator): Likewise.
	(struct_comparator): Likewise.
	(union_writer): Likewise.
	(struct_formater): Likewise.
	(struct_printer): Likewise.
	(struct_typifier): Likewise.
	* libpoke/pkl-rt.pk (Pk_Type): New field fcomputed.
	* poke/pk-info.pk (pk_info_type): Display info on computed fields.
	* testsuite/poke.pkl/computed-diag-1.pk: New test.
	* testsuite/poke.pkl/computed-diag-2.pk: Likewise.
	* testsuite/poke.pkl/computed-diag-3.pk: Likewise.
	* testsuite/poke.pkl/computed-diag-4.pk: Likewise.
	* testsuite/poke.pkl/computed-diag-5.pk: Likewise.
	* testsuite/poke.pkl/computed-diag-6.pk: Likewise.
	* testsuite/poke.pkl/computed-diag-7.pk: Likewise.
	* testsuite/poke.pkl/computed-diag-8.pk: Likewise.
	* testsuite/poke.pkl/computed-diag-9.pk: Likewise.
	* testsuite/poke.pkl/computed-diag-10.pk: Likewise.
	* testsuite/poke.pkl/computed-diag-11.pk: Likewise.
	* testsuite/poke.pkl/computed-1.pk: Likewise.
	* testsuite/poke.pkl/computed-2.pk: Likewise.
	* testsuite/poke.pkl/computed-3.pk: Likewise.
	* testsuite/poke.pkl/computed-4.pk: Likewise.
	* testsuite/poke.pkl/computed-5.pk: Likewise.
	* testsuite/poke.pkl/computed-6.pk: Likewise.
	* testsuite/poke.pkl/computed-7.pk: Likewise.
	* testsuite/poke.pkl/computed-8.pk: Likewise.
	* testsuite/poke.pkl/computed-9.pk: Likewise.
	* testsuite/poke.pkl/computed-10.pk: Likewise.
	* testsuite/poke.pkl/computed-11.pk: Likewise.
	* testsuite/poke.pkl/computed-12.pk: Likewise.
	* testsuite/poke.pkl/computed-13.pk: Likewise.
	* testsuite/poke.pkl/computed-14.pk: Likewise.
	* testsuite/poke.pkl/computed-15.pk: Likewise.
	* testsuite/poke.pkl/computed-16.pk: Likewise.
	* testsuite/poke.pkl/computed-17.pk: Likewise.
	* testsuite/poke.pkl/computed-18.pk: Likewise.
	* testsuite/poke.pkl/typeof-26.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.
	* doc/poke.texi (Computed Fields): New section.

2022-09-22  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.h (PKL_AST_DECL_TYPE): Remove.

2022-09-18  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* pickles/elf-32.pk (Elf32_File.get_section_name): New method.
	(Elf32_File.get_symbol_name): Likewise.
	(Elf32_File.get_sections_by_name): Likewise.
	(Elf32_File.get_sections_by_type): Likewise.
	(Elf32_File.section_name_p): Likewise.
	(Elf32_File.get_string): Likewise.
	(Elf32_File.get_group_signature): Likewise.
	(Elf32_File.get_group_signatures): Likewise.
	(Elf32_File.get_section_group): Likewise.

2022-09-18  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* pickles/elf-64.pk (Elf64_File.get_sections_by_name): Use `apush'.
	(Elf64_File.get_sections_by_type): Likewise.
	(Elf64_File.get_group_signatures): Likewise.
	(Elf64_File.get_section_group): Likewise.

2022-09-18  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* pickles/riscv.pk: New pickle for RISC-V RV32I instruction set.
	* pickles/Makefile.am (dist_pickles_DATA): Update.
	* etc/hacking.org (Maintainers): Add myself as the maintainer of
	the pickle.
	* HACKING: Update.

2022-09-17  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poked/poked.pk (poked_restart): Close all IO spaces before
	restarting the daemon.

2022-09-17  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* poked/poked.pk (poked_chan_send): Force Poke to make a copy of
	data before putting into the buffer.


2022-09-01  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-lex.l (IS): Add lower-case b to `IS' definition.
	(Integer literal rule): Accept lower-case b as a valid suffix.
	* doc/learn-poke-language-in-y-minutes.pk: Add a line about integer
	suffixes.
	* testsuite/Makefile.am (EXTRA_DIST): Update.
	* testsuite/poke.pkl/integers-8.pk: New test.
	* testsuite/poke.pkl/integers-9.pk: Likewise.
	* testsuite/poke.pkl/integers-10.pk: Likewise.

2022-07-25  Jose E. Marchesi  <jemarch@gnu.org>

	* configure.ac: Bump version to 2.4.
	* doc/gendocs_template: Likewise.
	* NEWS: Add entries for 2.4.

2022-07-20  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/mbr.pk (MBR_CHS): Use unnammed type for the `cs' field.

2022-07-20  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-map-tab.y (make_map_entry): Set condition_loc.
	(tagged_value): Use location of DATA for the tag's location.
	* poke/pk-map-parser.h (struct pk_map_parsed_entry): New field
	condition_loc.
	(PK_MAP_PARSED_ENTRY_CONDITION_LOC): Define.
	(PK_MAP_NOLOC): Define.
	* poke/pk-map.c (pk_map_load_parsed_map): Use
	pk_compile_buffer_with_loc and pk_compile_expression_with_loc.

2022-07-20  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-cmd.c (pk_cmd_exec): Use pk_compile_statement_with_loc
	and pk_compile_buffer_with_loc.

2022-07-20  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-diag.c (pkl_warning): Use <unknown> for unknown
	source/location.
	(pkl_error_internal): Likewise.

2022-07-20  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-parser.h: Add location info to pkl_parse_buffer.
	(struct pkl_parser): Add fields init_line and init_column.
	* libpoke/pkl-parser.c (pkl_parse_buffer): Likewise.
	(pkl_parse_buffer): Fix initial location to 1:1 instead of 0:0.
	* libpoke/pkl.h: Add location info to pkl_execute_buffer.
	Add location info to pkl_execute_expression.
	Add location info to pkl_execute_statement.
	* libpoke/pkl.c (pkl_execute_buffer): Likewise.
	(pkl_execute_statement): Likewise.
	(pkl_execute_expression): Likewise.
	* libpoke/libpoke.h: Prototype for pk_compile_buffer_with_loc.
	Prototype for pk_compile_statement_with_loc.
	Prototype for pk_compile_expression_with_loc.
	* libpoke/libpoke.c (pk_compile_buffer_with_loc): New function.
	(pk_compile_buffer): Reimplement in terms of
	pk_compile_buffer_with_loc.
	(pk_compile_statement_with_loc): New function.
	(pk_compile_statement): Reimplement in terms of
	pk_compile_statement_with_loc.
	(pk_compile_expression_with_loc): New function.
	(pk_compile_expression): Reimplement in terms of
	pk_compile_expression_with_loc.
	* libpoke/pkl-tab.y (%initial-action): Use pkl_parser->init_line
	and pkl_parser->init_column to initialize the location
	information.

2022-07-19  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (Simple Init File): Add `.set pager yes' to the
	set of recommended options for new users and explain all the
	options a little.

2022-07-19  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-scrabble.pk (Arguments): Move variable declaration out
	of loop to avoid extra allocations.

2022-07-19  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (qsort): Add example of a comparator function for
	qsort and fix comparator prototype.

2022-07-19  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-tab.y (declaration): Move annotation of function
	names to trans1.
	* libpoke/pkl-trans.c (pkl_trans1_pr_decl): Annotate declared
	function names.

2022-07-19  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-parser.h (struct pkl_parser): New field prev_loc.
	* libpoke/pkl-parser.c (pkl_parser_init): Initialize
	parser->prev_loc.
	* libpoke/pkl-lex.l (YY_USER_ACTION): Save a backup of the current
	location.
	(PK_REJECT): Define.
	(RESTORE_LOC): Define.

2022-07-18  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-ast.h (pkl_ast_finish_breaks): Remove.
	* libpoke/pkl-ast.c (pkl_ast_finish_breaks): Likewise.
	(pkl_ast_finish_breaks_1): Likewise.
	* libpoke/pkl-tab.y (stmt): Likewise.
	* libpoke/pkl-trans.h (struct pkl_trans_escapable_ctx): New struct.
	(PKL_TRANS_MAX_COMP_STMT_NEST): New macro.
	(struct pkl_trans_payload): Add new fields.
	* libpoke/pkl-trans.c (PKL_TRANS_ESCAPABLE): New macro.
	(PKL_TRANS_PUSH_ESCAPABLE): Likewise.
	(PKL_TRANS_POP_ESCAPABLE): Likewise.
	(pkl_trans1_pr_comp_stmt): Add logic to track lexical frames around
	`break` and `continue` keywords.
	(pkl_trans1_ps_comp_stmt): Likewise.
	(pkl_trans1_pr_loop_stmt): Likewise.
	(pkl_trans1_ps_loop_stmt): Likewise.
	(pkl_trans1_pr_try_stmt_body): Likewise.
	(pkl_trans1_ps_try_stmt_body): Likewise.
	(pkl_trans1_pr_try_stmt): New handler.
	(pkl_trans1_ps_try_stmt): Likewise.
	(pkl_trans1_pr_try_stmt_handler): Likewise.
	(pkl_trans1_ps_try_stmt_handler): Likewise.
	(pkl_trans1_ps_break_stmt): Likewise.
	(pkl_trans1_ps_continue_stmt): Likewise.
	(pkl_phase_trans1): Register new handlers.

2022-07-17  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* etc/hacking.org (try_stmt): Update the topology.
	* HACKING (try_stmt): Update.
	* libpoke/pkl-ast.h (enum pkl_ast_code): Add
	PKL_AST_TRY_STMT_HANDLER.
	(PKL_AST_TRY_STMT_HANDLER_CODE): New macro.
	(struct pkl_ast_try_stmt_handler): New struct.
	(pkl_ast_make_try_stmt_handler): New function.
	(union pkl_ast_node): Add `try_stmt_handler`.
	* libpoke/pkl-ast.c (pkl_ast_make_try_stmt_handler): New function.
	(pkl_ast_node_free): Add case for TRY_STMT_HANDLER.
	(pkl_ast_print_1): Likewise.
	(pkl_ast_finish_breaks_1): Likewise.
	* libpoke/pkl-tab.y (stmt): Adapt to use
	`pkl_ast_make_try_stmt_handler` in try-catch statements.
	* libpoke/pkl-pass.c (pkl_do_pass_1): Add case for TRY_STMT_HANDLER.
	* libpoke/pkl-gen.c (pkl_gen_ps_try_stmt_handler): New handler.
	(pkl_phase_gen): Register new handler.

2022-07-17  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.h (struct pkl_ast_var): New field is_indexed.
	(struct pkl_ast_indexer): Likewise.
	(PKL_AST_VAR_IS_INDEXED): Define.
	(PKL_AST_INDEXER_IS_INDEXED): Likewise.
	* libpoke/pkl-trans.c (pkl_trans1_ps_var): Annotate is_indexed.
	(pkl_trans1_ps_indexer): New handler.
	(pkl_phase_trans1): Register new handler.
	* libpoke/pkl-gen.c (pkl_gen_ps_var): Avoid remapping arrays when
	indexing elements when the array type is complete and can be
	mapped.
	(pkl_gen_pr_indexer): Ditto for array indexers themselves.

2022-07-16  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/ios.pk (ios_save_bytes): Adapted from poke/pk-save.pk.
	(ios_copy_bytes): Adapted from poke/pk-copy.pk.
	(ios_dump_bytes): Do not use types from std-types.pk.

	* poke/pk-copy.pk (copy): Rewrite in terms of ios_copy_bytes.
	* poke/pk-save.pk (save): Rewrite in terms of ios_save_bytes.
	* doc/poke.texi (IOS): New chapter.
	(ios_dump_bytes): New section.
	(ios_copy_bytes): Likewise.
	(ios_save_bytes): Likewise.

2022-07-16  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-extract.pk (extract): Make `to' optional and report the
	IOS where the value got extracted.
	* doc/poke.texi (extract): Update accordingly.

2022-07-15  Jose E. Marchesi  <jemarch@gnu.org>

	* etc/hacking.org (Building with Debugging support): Recommend
	CFLAGS="-O0 -g3" for debugging.

2022-07-14  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.h: Update comments.
	* libpoke/pkl-trans.c: Remove obsolete comments.
	* etc/hacking.org (exp): New section.
	(cond_exp): Likewise.

2022-07-14  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-trans.c (pkl_trans1_pr_comp_stmt): Merge common parts
	under a single if statement.
	(pkl_trans1_ps_comp_stmt): Likewise.

2022-07-13  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-trans.h (struct pkl_trans_function_ctx): Define.
	* libpoke/pkl-trans.c (pkl_trans_in_functions): Adapt to new
	stack.
	(PKL_TRANS_FUNCTION_BACK): Delete macro.
	(PKL_TRANS_INCR_FUNCTION_BACK): Likewise.
	(PKL_TRANS_DECR_FUNCTION_BACK): Likewise.
	(PKL_TRANS_DECR_FUNCTION_NDROPS): Likewise.
	(PKL_TRANS_DECR_FUNCTION_NPOPES): Likewise.
	(PKL_TRANS_FUNCTION_NDROPS): Likewise.
	(PKL_TRANS_INCR_FUNCTION_NDROPS): Likewise.
	(PKL_TRANS_FUNCTION_NPOPES): Likewise.
	(PKL_TRANS_INCR_FUNCTION_NPOPES): Likewise.
	Update phase handlers accordingly.

2022-07-13  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-ast.h (pkl_ast_finish_returns): Remove.
	* libpoke/pkl-ast.c (pkl_ast_finish_returns): Likewise.
	(pkl_ast_finish_returns_1): Likewise.
	* libpoke/pkl-tab.y (function_specifier): Likewise.
	(declaration): Likewise.
	* libpoke/pkl-trans.h (struct pkl_trans_payload): Add new fields
	`function_ndrops` and `function_npopes`.
	* libpoke/pkl-trans.c (PKL_TRANS_FUNCTION_NDROPS): New macro.
	(PKL_TRANS_INCR_FUNCTION_NDROPS): Likewise.
	(PKL_TRANS_DECR_FUNCTION_NDROPS): Likewise.
	(PKL_TRANS_FUNCTION_NPOPES): Likewise.
	(PKL_TRANS_INCR_FUNCTION_NPOPES): Likewise.
	(PKL_TRANS_DECR_FUNCTION_NPOPES): Likewise.
	(PKL_TRANS_PUSH_FUNCTION): Adapt.
	(pkl_trans1_pr_comp_stmt): Count ndrops and npopes.
	(pkl_trans1_ps_comp_stmt): Likewise.
	(pkl_trans1_pr_loop_stmt): Likewise.
	(pkl_trans1_ps_loop_stmt): Likewise.
	(pkl_trans1_ps_return_stmt): New handler.
	(pkl_trans1_pr_try_stmt_body): Likewise.
	(pkl_trans1_ps_try_stmt_body): Likewise.
	(struct pkl_phase_trans1): Register new handlers.
	* libpoke/pkl-gen.c (pkl_gen_ps_return_stmt): Fix comment.
	* testsuite/poke.pkl/return-3.pk: New test.
	* testsuite/poke.pkl/return-4.pk: Likewise.
	* testsuite/poke.pkl/return-5.pk: Likewise.
	* testsuite/poke.pkl/return-6.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2022-07-13  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.h (enum pkl_ast_code): Define PKL_AST_TRY_STMT
	and PKL_AST_TRY_STMT_BODY, and remove PKL_AST_TRY_UNTIL_STMT and
	PKL_AST_TRY_CATCH_STMT.
	(PKL_AST_TRY_CATCH_STMT_BODY): Rename from PKL_AST_TRY_CATCH_STMT_CODE.
	(struct pkl_ast_try_catch_stmt): Field `code' renamed to `body'.
	(PKL_AST_TRY_STMT_KIND_CATCH): Define.
	(PKL_AST_TRY_STMT_KIND_UNTIL): Likewise.
	(struct pkl_ast_try_catch_stmt_body): New type.
	(PKL_AST_TRY_UNTIL_STMT_CODE): Remove.
	(PKL_AST_TRY_UNTIL_STMT_EXP): Likewise.
	(struct pkl_ast_try_until_stmt): Likewise.
	(PKL_AST_TRY_STMT_BODY_CODE): Define.
	(PKL_AST_TRY_CATCH_STMT_KIND): Define.
	* libpoke/pkl-ast.c (pkl_ast_make_try_until_stmt): Remove.
	(pkl_ast_node_free): Adapt to new AST.
	(pkl_ast_finish_breaks_1): Likewise.
	(pkl_ast_print_1): Likewise.
	(pkl_ast_make_try_stmt_body): Define.
	(pkl_ast_make_try_stmt): Rename from pkl_ast_make_try_catch_stmt.
	* libpoke/pkl-pass.c (pkl_do_pass_1): Adapt to new AST.
	* libpoke/pkl-tab.y (stmt): Adapt to new AST.
	* libpoke/pkl-typify.c (pkl_typify1_ps_try_stmt): Renamed and
	adapted from pkl_typify1_ps_try_catch_stmt.
	* libpoke/pkl-gen.c (pkl_gen_pr_try_stmt): Renamed and adapted
	from pkl_gen_pr_try_catch_stmt.
	(pkl_gen_ps_try_stmt_body): New handler.
	(pkl_phase_gen): Install new handler.
	* etc/hacking.org (try Statements): New section.
	* HACKING: Regenerate.

2022-07-13  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-ast.h (PKL_AST_FUNC_NFRAMES): Remove.
	(PKL_AST_RETURN_STMT_NFRAMES): Likewise.
	(struct pkl_ast_func): Remove `nframes` field.
	(struct pkl_ast_return_stmt): Likewise.
	* libpoke/pkl-ast.c (pkl_ast_finish_returns_1): Remove `nframes` arg.
	(pkl_ast_finish_returns): Update.

2022-07-13  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-trans.c (pkl_trans1_pr_decl): Do not pushing current function
	to the stack of functions here.
	(pkl_trans1_pr_func): Do it here.
	(pkl_trans1_ps_decl): Remove handler.
	(pkl_phase_trans1): Register new handler.
	* testsuite/poke.pkl/lambda-5.pk): Add new test.
	* testsuite/Makefile.am (EXTRA_DIST): Update.

2022-07-11  Jose E. Marchesi  <jose.marchesi@oracle.com>

	* pickles/ctf.pk (ctf_get_dict): Raise an assert instead of
	E_inval.

2022-07-10  Jose E. Marchesi  <jose.marchesi@oracle.com>

	* pickles/ctf-frame.pk: Fix indentation and replace tabs with
	whitespaces.
	* pickles/ctf-frame-dump.pk: Likewise.

2022-07-09  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pkl-gen.c (pkl_gen_pr_op_excond): Invert the logic of excond
	operator.
	* doc/poke.texi (exception predicate): Update to new semantics.
	* libpoke/std.pk (with_temp_ios): Likewise.
	libpoke/std.pk (with_cur_ios): Likewise.
	* pickles/asn1-ber.pk (BER_Data_Value.isdefinite): Likewise.
	* pickles/btf-dump.pk (btf_dump_type_vdata): Likewise.
	* pickles/ctf-dump.pk (ctf_dump_func): Likewise.
	* pickles/diff.pk (diff_structured): Likewise.
	* testsuite/poke.pkl/excond-1.pk: Likewise.
	* testsuite/poke.pkl/excond-2.pk: Likewise.
	* testsuite/poke.pkl/excond-3.pk: Likewise.
	* testsuite/poke.pkl/excond-4.pk: Likewise.
	* testsuite/poke.std/std-test.pk: Likewise.

2022-07-08  Jose E. Marchesi  <jose.marchesi@oracle.com>

	* pickles/btf.pk (BTF_Int): Turn `encoding' into a nested integral
	struct.
	* pickles/btf-dump.pk (btf_dump_int): Update accordingly.

2022-07-08  Jose E. Marchesi  <jose.marchesi@oracle.com>

	* pickles/btf-dump.pk (btf_dump_var): Use btf_var_linkage_names.
	(btf_dump_func): New function.
	(btf_dump_type_vdata): Call btf_dump_func whenever appropriate.
	* pickles/btf.pk (BTF_VAR_STATIC): Define.
	(BTF_VAR_GLOBAL_ALLOCATED): Likewise.
	(BTF_VAR_GLOBAL_EXTERN): Likewise.
	(BTF_FUNC_STATIC): Likewise.
	(BTF_FUNC_GLOBAL): Likewise.
	(BTF_FUNC_EXTERN): Likewise.
	(btf_var_linkage_names): Likewise.
	(btf_func_linkage_names): Likewise.
	(BTF_Type.info._print): Print linkage whenever appropriate.
	(BTF_Variable): Add pretty-printer.

2022-04-10  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/search.pk: New file.
	* pickles/Makefile.am (dist_pickles_DATA): Add search.pk.

2022-07-04  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/search.pk: New file.
	* pickles/Makefile.am (dist_pickles_DATA): Add search.pk.

2022-07-04  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-insn.def (PKL_INSN_IOLIST): Define.
	* libpoke/pvm.jitter (iolist): New instruction.
	* libpoke/pkl-lex.l: Recognize token __PKL_BUILTIN_IOLIST__.
	* libpoke/pkl-tab.y: Likewise.
	* libpoke/pkl-ast.h (PKL_AST_BUILTIN_IOLIST): Define.
	* libpoke/pkl-gen.c (pkl_gen_ps_comp_stmt): Handle
	PKL_AST_BUILTIN_IOLIST.
	* libpoke/pkl-gen-builtins.pks (builtin_iolist): Define.
	* libpoke/pkl-rt.pk (iolist): New builtin.
	* testsuite/poke.pkl/iolist-1.pk: New test.
	* testsuite/poke.pkl/iolist-2.pk: Likewise.
	* testsuite/poke.pkl/iolist-3.pk: Likewise.
	* testsuite/poke.pkl/iolist-4.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.
	* doc/poke.texi (iolist): New section.

2022-06-05  apache2  <apache2@ageinghacker.net>

	* libpoke/ios-dev-file.c (ios_dev_file_pread): Avoid slow unneeded
	seeks.,

2022-05-05  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.pks (struct_mapper): Add an explicative message
	for union alternative constraint exceptions.
	(struct_constructor): Likewise.
	* testsuite/poke.pkl/union-constraint-1.pk: New test.
	* testsuite/poke.pkl/union-constraint-2.pk: Likewise.
	* testsuite/poke.pkl/union-constraint-3.pk: Likewise.
	* testsuite/poke.pkl/union-constraint-4.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2022-04-14  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/std.pk (Pk_With_Ios_Fn): New type.
	(Pk_Temp_Ios_Generator): Likewise.
	(with_temp_ios): New function.
	(with_cur_ios): Likewise.
	* testsuite/poke.std/std-test.pk: Tests for with_temp_ios and
	with_cur_ios.
	* doc/poke.texi (with_temp_ios): New section.
	(with_cur_ios): Likewise.

2022-04-12  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/openpgp.pk (PGP_Packet): Remove pretty-printer.  Use an
	internal UID type and use #<uid:...> marks in its pretty-printer.

2022-04-11  Jose E. Marchesi  <jemarch@gnu.org>



2022-04-11  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/openpgp.pk (PGP_Packet): Add constraint to check that
	the payload size matches with the declared length in the header.

2022-04-11  Jose E. Marchesi  <jemarch@gnu.org>

	* doc/poke.texi (Exceptions): Remove mention to E_map_bounds.
	(Array Constructors): Update.
	(Array maps bounded by number of elements): Likewise.
	(Array maps bounded by size): Likewise.

2022-04-11  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/diff.pk: Correct handling of boundaries constraint
	error.

2022-04-11  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.pks (array_constructor): Add explicative message
	to E_constraint raised from unsatisfied array boundaries.
	(array_mapper): Likewise.

2022-04-11  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-gen.pks (array_mapper): Raise PVM_E_CONSTRAINT
	instead of PVM_E_MAP_BOUNDS in case of array bound failure.
	(array_constructor): Likewise.
	* libpoke/libpoke.h (PK_EC_MAP_BOUNDS): Remove.
	* libpoke/pkl-rt.pk (E_map_bounds): Likewise.
	* libpoke/pvm.h (PVM_E_MAP_BOUNDS): Likewise.
	(PVM_E_MAP_BOUNDS_NAME): Likewise.
	(PVM_E_MAP_BOUNDS_ESTATUS): Likewise.
	* pickles/diff.pk: Adapt accordingly.
	* testsuite/poke.pkl/scons-union-12.pk: New test.
	* testsuite/poke.pkl/scons-union-13.pk: Likewise.
	* testsuite/poke.pkl/scons-union-14.pk: Likewise.
	* testsuite/poke.map/maps-unions-14.pk: Likewise.
	* testsuite/poke.map/maps-unions-15.pk: Likewise.
	* testsuite/poke.map/maps-unions-16.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2022-04-10  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/openpgp.pk (PGP_MPI): The `len' field is big endian.

2022-04-10  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/openpgp.pk (PGP_Packet_Header): Do not print a newline
	in the pretty-printer.
	(PGP_MPI): Likewise.

2022-04-10  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/openpgp.pk (PGP_V3_Packet_Length): Use tag logic to get
	the union value.
	(PGP_V4_Packet_Length): fix units.
	(PGP_Packet_Header): Use the right method name.
	(PGP_Key_Flags): Add missing semicolon.
	(PGP_File): Fix type name for PGP_Packet.

2022-04-09  Mohammad-Reza Nabipoor  <mnabipoor@gnu.org>

	* libpoke/pvm.h (pvm_assert): Add more parameters.
	(PVM_ASSERT): New macro.
	* libpoke/pvm.c (pvm_assert): Replace `assert` with an implementation.
	(assert.h): Remove #include.
	* libpoke/pvm.jitter (PVM_PRINTI): s/pvm_assert/PVM_ASSERT/.
	(PVM_FORMATI): Likewise.
	(PVM_FORMATU): Likewise.
	(exit): Likewise.
	(call): Likewise.
	(asettb): Likewise.
	(strace): Likewise.

2022-04-09  Jose E. Marchesi  <jemarch@gnu.org>

	* pickles/openpgp.pk: New file.

2022-04-08  Jose E. Marchesi  <jemarch@gnu.org>

	* poke/pk-repl.c: Include ctype.h.

2022-04-08  Jose E. Marchesi  <jose.marchesi@oracle.com>

	* libpoke/pkl-gen.c (pkl_gen_ps_func): Fix E_no_return location in
	lambdas.

2022-04-08  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-ast.h: Prototype for pkl_ast_format_loc.
	* libpoke/pkl-ast.c (pkl_ast_format_loc): New function.
	* libpoke/pkl-gen.c (pkl_gen_ps_func): Add function name to
	E_no_return exception whenever possible.
	* testsuite/poke.pkl/fun-no-return-1.pk: New test.
	* testsuite/poke.pkl/fun-no-return-2.pk: Likewise.
	* testsuite/Makefile.am (EXTRA_DIST): Add new tests.

2022-04-08  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-tab.y: Make struct and array constructors primary
	syntax entities.
	* testsuite/poke.pkl/scons-70.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2022-04-06  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-promo.c (pkl_promo_ps_cast): Do not try to promote
	regular structs to integral structs.
	* testsuite/poke.pkl/cast-int-struct-4.pk: New test.
	* testsuite/Makefile.am (EXTRA_DIST): Add new test.

2022-04-04  Jose E. Marchesi  <jemarch@gnu.org>

	* etc/Makefile.am (dist_lisp_DATA): Do not install poke-mode.
	* emacs: Remove.
	* etc/poke-mode.el: Remove.

2022-03-31  Jose E. Marchesi  <jemarch@gnu.org>

	* emacs/poke-el.texi: Capitalize etc.

2022-03-31  Jose E. Marchesi  <jemarch@gnu.org>

	* emacs/poke.el (poke-settings-map): Define.
	(poke-settings-create-widgets): Use poke-settings-map.

2022-03-31  Jose E. Marchesi  <jemarch@gnu.org>

	* emacs/poke.el (poke-vu-goto-byte): Do not handle current-pos.
	(poke-vu-mode): Likewise.
	(poke-vu-handle-cmd): Get current-pos from the buffer.

2022-03-31  Jose E. Marchesi  <jemarch@gnu.org>

	* configure.ac: Update version to 2.3.
	* doc/gendocs_template: Likewise.
	* NEWS: Entries for 2.3.

2022-03-31  Jose E. Marchesi  <jemarch@gnu.org>

	* libpoke/pkl-typify.c (pkl_typify1_ps_type_struct): Fix
	diagnostics in 32-bit.

2022-03-29  Jose E. Marchesi  <jemarch@gnu.org>

	* configure.ac: Update version to 2.2.
	* doc/gendocs_template: Likewise.
	* NEWS: Update for 2.2.

